import * as computer from './computer';

describe('computer', () => {
    describe('interpolation', () => {
        it('should compute interpolated value', () => {
            let result = computer.linearInterpolation(5, 10, 0.5);
            expect(result).toEqual(7.5);
        });
    });
    describe('interpolation', () => {
        it('should compute interpolated value (parameter is 0)', () => {
            let result = computer.linearInterpolation(2, 5, 0);
            expect(result).toEqual(2);
        });
    });
    describe('interpolation', () => {
        it('should compute interpolated value (parameter is 1)', () => {
            let result = computer.linearInterpolation(1000, 60, 1);
            expect(result).toEqual(60);
        });
    });
    describe('hypot', () => {
        it('should compute square root of the sum of squares', () => {
            let result = Math.hypot(3, 4);
            expect(result).toEqual(5);
        });
    });
    describe('hypot', () => {
        it('should compute square root of the sum of square', () => {
            let result = Math.hypot(-2);
            expect(result).toEqual(2);
        });
    });
    describe('hypot', () => {
        it('should return zero when no parameter', () => {
            let result = Math.hypot();
            expect(result).toEqual(0);
        });
    });
    describe('normal', () => {
        it('should compute normal', () => {
            let result = computer.computeNormal(5, 6, 1, 10);
            expect(result).toEqual({ x: 9, y: 1 });
        });
    });
    describe('normal', () => {
        it('should compute normal (zero)', () => {
            let result = computer.computeNormal(0, 0, 0, 0);
            expect(result).toEqual({ x: 0, y: 0 });
        });
    });
    describe('new point', () => {
        it('should compute new point according to normal and distance', () => {
            let result = computer.computeNewPoint({ x: 9, y: 1 }, 2, 5, 5);
            expect(result.x).toBeCloseTo(6.9694, 4);
            expect(result.y).toBeCloseTo(4.4478, 4);
        });
    });
});
