import * as b from 'bobril';
import * as bs from 'bobrilstrap';
import * as css from '../../theme/css/css';

export interface IButtonEraseData {
    onClick?: (event: b.IBobrilMouseEvent) => boolean | void;
    fullScreen: boolean;
}

interface IButtonEraseCtx extends b.IBobrilCtx {
    data: IButtonEraseData;
}

export const buttonErase = b.createVirtualComponent<IButtonEraseData>({
    id: 'button-erase',
    render(ctx: IButtonEraseCtx, me: b.IBobrilNode) {
        me.children = b.style(
            bs.button(
                { option: bs.ButtonOption.Primary, onClick: ctx.data.onClick },
                bs.glyphicon({ icon: bs.GlyphIcon.Erase })
            ),
            ctx.data.fullScreen ? css.buttonFullStyle : css.buttonStyle);
    }
});