import * as b from 'bobril';
import * as bs from 'bobrilstrap';
import * as css from '../../theme/css/css';

export interface IButtonFullScreenData {
    onClick?: (event: b.IBobrilMouseEvent) => boolean | void;
        fullScreen: boolean;
}

interface IButtonFullScreenCtx extends b.IBobrilCtx {
    data: IButtonFullScreenData;
}

export const buttonFullScreen = b.createVirtualComponent<IButtonFullScreenData>({
    id: 'button-Fullscreen',
    render(ctx: IButtonFullScreenCtx, me: b.IBobrilNode) {
        me.children = b.style(bs.button(
            { option: bs.ButtonOption.Primary, onClick: ctx.data.onClick },
            bs.glyphicon({ icon: bs.GlyphIcon.Fullscreen })), ctx.data.fullScreen ? css.buttonFullStyle : css.buttonStyle);
    }
});