import * as b from 'bobril';
import * as bs from 'bobrilstrap';
import * as css from '../../theme/css/css';

export interface IButtonLeftData {
    onClick?: (event: b.IBobrilMouseEvent) => boolean | void;
    fullScreen: boolean;
    enabled?: boolean;
}

interface IButtonLeftCtx extends b.IBobrilCtx {
    data: IButtonLeftData;
}

export const buttonLeft = b.createVirtualComponent<IButtonLeftData>({
    id: 'button-left',
    render(ctx: IButtonLeftCtx, me: b.IBobrilNode) {
        me.children = b.style(
            bs.button(
                {
                    option: bs.ButtonOption.Primary,
                    onClick: ctx.data.onClick,
                    disabled: ctx.data.enabled ? false : true
                },
                bs.glyphicon({ icon: bs.GlyphIcon.ChevronLeft })),
            ctx.data.fullScreen
                ? ctx.data.enabled ? css.buttonFullStyle : css.buttonFullStyleDisabled
                : ctx.data.enabled ? css.buttonStyle : css.buttonStyleDisabled);
    }
});