import * as b from 'bobril';
import * as bs from 'bobrilstrap';
import * as css from '../../theme/css/css';

export interface IButtonNumberData {
    graphNumber: number;
    onClick?: (event: b.IBobrilMouseEvent) => boolean | void;
    fullScreen: boolean;
}

interface IButtonNumberCtx extends b.IBobrilCtx {
    data: IButtonNumberData;
}

export const buttonNumber = b.createVirtualComponent<IButtonNumberData>({
    id: 'button-number',
    render(ctx: IButtonNumberCtx, me: b.IBobrilNode) {
        me.children = b.style(
            bs.button(
                { option: bs.ButtonOption.Primary, onClick: ctx.data.onClick },
                bs.strong({}, '\xa0' + (ctx.data.graphNumber + 1).toString() + '\xa0')),
            ctx.data.fullScreen ? css.buttonFullStyle : css.buttonStyle);
    }
});