import * as b from 'bobril';
import * as bs from 'bobrilstrap';
import * as css from '../../theme/css/css';

export interface IButtonRepeatData {
    onClick?: (event: b.IBobrilMouseEvent) => boolean | void;
    fullScreen: boolean;
    enabled?: boolean;
}

interface IButtonRepeatCtx extends b.IBobrilCtx {
    data: IButtonRepeatData;
}

export const buttonRepeat = b.createVirtualComponent<IButtonRepeatData>({
    id: 'button-repeat',
    render(ctx: IButtonRepeatCtx, me: b.IBobrilNode) {
        me.children = b.style(
            bs.button(
                {
                    option: bs.ButtonOption.Primary,
                    onClick: ctx.data.onClick,
                    disabled: ctx.data.enabled ? false : true
                },
                bs.glyphicon({ icon: bs.GlyphIcon.Repeat })),
            ctx.data.fullScreen
                ? ctx.data.enabled ? css.buttonFullStyle : css.buttonFullStyleDisabled
                : ctx.data.enabled ? css.buttonStyle : css.buttonStyleDisabled);
    }
});