import * as b from 'bobril';
import * as bs from 'bobrilstrap';
import * as css from '../../theme/css/css';

export interface IButtonRightData {
    onClick?: (event: b.IBobrilMouseEvent) => boolean | void;
    fullScreen: boolean;
    enabled?: boolean;
}

interface IButtonRightCtx extends b.IBobrilCtx {
    data: IButtonRightData;
}

export const buttonRight = b.createVirtualComponent<IButtonRightData>({
    id: 'button-right',
    render(ctx: IButtonRightCtx, me: b.IBobrilNode) {
        me.children = b.style(
            bs.button(
                {
                    option: bs.ButtonOption.Primary,
                    onClick: ctx.data.onClick,
                    disabled: ctx.data.enabled ? false : true
                },
                bs.glyphicon({ icon: bs.GlyphIcon.ChevronRight })),
            ctx.data.fullScreen
                ? ctx.data.enabled ? css.buttonFullStyle : css.buttonFullStyleDisabled
                : ctx.data.enabled ? css.buttonStyle : css.buttonStyleDisabled);
    }
});