import * as b from 'bobril';
import * as bs from 'bobrilstrap';
import * as c from '../../common/colors';

const buttonStyle = b.styleDef({
    border: 'none', color: c.grayDark, position: 'absolute', right: '15px',
    top: '70%'
});

const buttonStyleNoSentences = b.styleDef({
    border: 'none', color: c.grayDark, position: 'absolute', right: '15px',
    top: '93%'
});

const buttonFullStyle = b.styleDef({
    border: 'none', color: c.grayDark,
    fontSize: 25, position: 'absolute', right: '15px',
    top: '68%',
});

const buttonFullStyleNoSentences = b.styleDef({
    border: 'none', color: c.grayDark,
    fontSize: 25, position: 'absolute', right: '15px',
    top: '90%',
});

const buttonHover = b.styleDef({ backgroundColor: 'transparent' }, {
    hover: { backgroundColor: 'transparent', color: c.defaultBlack },
    focus: { backgroundColor: 'transparent', color: c.defaultBlack }
});

export interface IButtonSentencesData {
    onClick?: (event: b.IBobrilMouseEvent) => boolean | void;
    fullScreen: boolean;
    shownSentences: boolean;
}

interface IButtonNumberCtx extends b.IBobrilCtx {
    data: IButtonSentencesData;
}

export const buttonSentences = b.createVirtualComponent<IButtonSentencesData>({
    id: 'button-sentences',
    render(ctx: IButtonNumberCtx, me: b.IBobrilNode) {
        me.children = b.style(
            bs.button(
                { option: bs.ButtonOption.Primary, onClick: ctx.data.onClick },
                bs.glyphicon({ icon: bs.GlyphIcon.OptionHorizontal })),
            buttonHover,
            ctx.data.fullScreen ?
                ctx.data.shownSentences ?
                    buttonFullStyle
                    : buttonFullStyleNoSentences
                : ctx.data.shownSentences ?
                    buttonStyle
                    : buttonStyleNoSentences);
    }
});