import * as b from 'bobril';
import * as bs from 'bobrilstrap';
import * as css from '../../theme/css/css';

export interface IButtonStartData {
    onClick?: (event: b.IBobrilMouseEvent) => boolean | void;
    fullScreen: boolean;
    enabled?: boolean;
}

interface IButtonStartCtx extends b.IBobrilCtx {
    data: IButtonStartData;
}

export const buttonStart = b.createVirtualComponent<IButtonStartData>({
    id: 'button-start',
    render(ctx: IButtonStartCtx, me: b.IBobrilNode) {
        me.children = b.style(
            bs.button(
                {
                    option: bs.ButtonOption.Primary,
                    onClick: ctx.data.onClick,
                    disabled: ctx.data.enabled ? false : true
                },
                bs.glyphicon({ icon: bs.GlyphIcon.Home })),
            ctx.data.fullScreen
                ? ctx.data.enabled ? css.buttonFullStyle : css.buttonFullStyleDisabled
                : ctx.data.enabled ? css.buttonStyle : css.buttonStyleDisabled);
    }
});