import * as b from 'bobril';

const controlsStyle = b.styleDef({ textAlign: 'center', width: '100%' });

export interface IProofControlsData {
    bottom?: number;
    right?: number;
    left?: number;
    marginLeft?: string;
    marginRight?: string;
    children?: b.IBobrilChildren;
}

interface IProofControlsCtx extends b.IBobrilCtx {
    data: IProofControlsData;
}

export const proofControls = b.createComponent<IProofControlsData>({
    id: 'proof-controls',
    render(ctx: IProofControlsCtx, me: b.IBobrilNode) {
        me.tag = 'div';
        me.children = ctx.data.children;
        b.style(
            me,
            controlsStyle,
            (ctx.data.right !== undefined) && { right: ctx.data.right },
            (ctx.data.left !== undefined) && { left: ctx.data.left },
            (ctx.data.marginLeft !== undefined) && { marginLeft: ctx.data.marginLeft },
            (ctx.data.marginRight !== undefined) && { marginRight: ctx.data.marginRight },
            (ctx.data.bottom !== undefined) && { bottom: ctx.data.bottom });
    }
});