import * as b from 'bobril';
import * as colors from '../../common/colors';

const cloudStyle = b.styleDef({ stroke: colors.defaultBlack, strokeWidth: '1.5px', fill: 'none', opacity: 0.5 });

export interface ICloudData {
    children?: b.IBobrilChildren;
}

export interface ICloudCtx extends b.IBobrilCtx {
    data: ICloudData;
}

export const cloud = b.createComponent({
    render(ctx: b.IBobrilCtx, me: b.IBobrilNode, oldMe?: b.IBobrilCacheNode): void {
        me.tag = 'path';
        me.children = ctx.data.children;
        me.attrs = { d: 'M 50 125 S 0 174 25 250 S 0 323 75 400 S 180 420 250 448 S 312.5 448 ' +
        ' 380 430 S 487.5 448 560 450 S 637.5 400 700 374 S 720 320 750 260 S 750 210 750 150 S' + 
        '710 60 650 50.6 S 600 0 500 30 S 412.5 0 325 25.6 S 250 10 175 25.6 S 120 80 50 125 Z', filter: 'url(#filter)' };

        b.style(me, cloudStyle);
    }
});