import * as b from 'bobril';

export interface ILabelData {
    children?: b.IBobrilChildren;
    x: number;
    y: number;
    text: string;
}

interface ILabelCtx extends b.IBobrilCtx {
    data: ILabelData;
}

export const label = b.createComponent<ILabelData>({
    id: 'label',
    render(ctx: ILabelCtx, me: b.IBobrilNode) {
        me.tag = 'text';
        me.children = ctx.data.text;
        me.attrs = { x: ctx.data.x, y: ctx.data.y, ['text-anchor']: 'middle', dy: 4 };
    }
});