import * as b from 'bobril';
import { vertex, IVertexData } from './vertex';
import { label } from './label';
import * as colors from '../../common/colors';

const vertexInvisibleStyle = b.styleDef({ stroke: colors.defaultBlack, strokeWidth: '3px', opacity: 0.001 });

export interface IVertexWithLabelData extends IVertexData {
    label: string;
}

interface IVertexWithLabelCtx extends b.IBobrilCtx {
    data: IVertexWithLabelData;
}

export const vertexWithLabel = b.createComponent<IVertexWithLabelData>({
    id: 'vertex-with-label',
    render(ctx: IVertexWithLabelCtx, me: b.IBobrilNode) {
        me.tag = 'g';
        me.children = [
            vertex(ctx.data),
            label({
                text: ctx.data.label,
                x: ctx.data.cx,
                y: ctx.data.cy
            }),
            b.style(vertex(ctx.data), vertexInvisibleStyle)
        ];
    }
});