import * as b from 'bobril';
import { edge } from '../graph/edge';

export interface IAxisData {
    children?: b.IBobrilChildren;
    x1: number;
    y1: number;
    x2: number;
    y2: number;
}

interface IAxisCtx extends b.IBobrilCtx {
    data: IAxisData;
}

export const axis = b.createComponent<IAxisCtx>({
    id: 'axis',
    render(ctx: IAxisCtx, me: b.IBobrilNode) {
        me.tag = 'g';
        me.children = [
            edge({x1: 100, x2: 700, y1: 250, y2: 250}, []),
            edge({x1: 400, x2: 400, y1: 225, y2: 275}, [])
        ];
}});