import * as b from 'bobril';
import * as bs from 'bobrilstrap';

const exerciseStyle = b.styleDef({
    fontSize: 22,
});

export interface IExerciseData {
    statement: b.IBobrilChildren;
    answer: b.IBobrilChildren;
}

interface IExerciseCtx extends b.IBobrilCtx {
    data: IExerciseData;
    onClick?: (event: b.IBobrilMouseEvent) => boolean | void;
    visible: String;
}

export const exercise = b.createComponent<IExerciseData>({
    id: 'exercise',
    init(ctx: IExerciseCtx) {
        ctx.visible = 'hidden';
        ctx.onClick = () => {
            if (ctx.visible === 'hidden') {
                ctx.visible = 'visible';
            } else {
                ctx.visible = 'hidden';
            }
            b.invalidate();
        };
    },
    render(ctx: IExerciseCtx, me: b.IBobrilNode) {
        let statement = b.style(bs.elem({ tag: 'div', onClick: ctx.onClick }, ['Výrok: ', ctx.data.statement]), { marginBottom: 5 });
        let answer = b.style(bs.elem({ tag: 'div' }, ['Negace: ', ctx.data.answer]), { visibility: ctx.visible });
        me.children = [
            statement,
            answer,
            bs.elem({ tag: 'br' }, []),
            bs.elem({ tag: 'hr' }, []),
            bs.elem({ tag: 'br' }, [])
        ];
        b.style(me, exerciseStyle);
    }
});