import * as b from 'bobril';
import { exercise } from './exercise';
import { IExercise } from '../../model/IExercise';

export interface IExercisesData {
    exercises: IExercise[];
}

interface IExercisesCtx extends b.IBobrilCtx {
    data: IExercisesData;
}

export const exercises = b.createComponent<IExercisesData>({
    id: 'exercises',
    render(ctx: IExercisesCtx, me: b.IBobrilNode) {
        let listChildren: b.IBobrilChildren = [];

        if (ctx.data.exercises !== undefined) {
            for (let i = 0; i < ctx.data.exercises.length; i++) {
                listChildren[i] = exercise({
                    statement: ctx.data.exercises[i].statement,
                    answer: ctx.data.exercises[i].answer,
                });
            }
        }
        me.children = listChildren;
    }
});