import * as b from 'bobril';
import * as colors from '../../common/colors';

const halfCircleStyle = b.styleDef({ stroke: colors.defaultBlack, strokeWidth: '3px', fill: 'none' });

export interface IHalfCircleData {
    children?: b.IBobrilChildren;
    x: number;
    y: number;
    color?: string;
    strokeColor?: string;
    strokeWidth?: number;
    rotation?: boolean;
}

interface IHalfCircleCtx extends b.IBobrilCtx {
    data: IHalfCircleData;
}

export const halfCircle = b.createComponent<IHalfCircleData>({
    id: 'halfCircle',
    render(ctx: IHalfCircleCtx, me: b.IBobrilNode) {
        me.tag = 'path';
        me.children = ctx.data.children;
        me.attrs = {
            d: 'm' + ctx.data.x + ', ' + ctx.data.y +
            'c -326.166656,9.666672 -303.333344,89.333344 -303.5,129.000015c-0.166656,39.666672 -18.333344,118.333344  303,109',
            transform: ctx.data.rotation === true
                ? 'rotate(-180, 365, 250) scale(0.93, 1)'
                : 'scale(0.93, 1)'
        };

        b.style(
            me, halfCircleStyle,
            !!ctx.data.color && { fill: ctx.data.color },
            !!ctx.data.strokeColor && { stroke: ctx.data.strokeColor },
            !!ctx.data.strokeWidth && { strokeWidth: ctx.data.strokeWidth });
    }
});