import * as b from 'bobril';
import * as colors from '../../common/colors';

const textStyle = b.styleDef({ 
    color: colors.defaultBlack, 
    fontSize: '27px'
});

export interface ITextData {
    children?: b.IBobrilChildren;
    x: number;
    y: number;
    size?: number;
    color?: string;
    backgroundColor?: string;
}

interface ITextCtx extends b.IBobrilCtx {
    data: ITextData;
}

export const text = b.createComponent<ITextData>({
    id: 'text',
    render(ctx: ITextCtx, me: b.IBobrilNode) {
        me.tag = 'text';
        me.children = ctx.data.children;
        me.attrs = { x: ctx.data.x, y: ctx.data.y },
        b.style(
            me,
            textStyle,
            !!ctx.data.color && { color: ctx.data.color },
            !!ctx.data.backgroundColor && { backgroundColor: ctx.data.backgroundColor },
            !!ctx.data.size && { fontSize: ctx.data.size },
        );
    },
});