import * as b from 'bobril';
import * as bs from 'bobrilstrap';
import * as colors from '../../common/colors';
import { IDefinitionData } from './definition';

const chosenDefinitionStyle = b.styleDef({
    fontSize: 'larger',
    color: colors.defaultBlack,
    direction: 'ltr'
});

const chosenStyle = b.styleDef({
    paddingTop: 20
});

interface IChosenDefinitionCtx extends b.IBobrilCtx {
    data: IDefinitionData;
}

export const chosenDefinition = b.createComponent<IDefinitionData>({
    id: 'chosenDefinition',
    render(ctx: IChosenDefinitionCtx, me: b.IBobrilNode) {
        me.children = [b.style
            (
            bs.elem({ tag: 'div' }, [
                b.style(
                    b.style(bs.elem({ tag: 'div' }, ctx.data.text)), chosenDefinitionStyle),
            ]),
            {
                marginLeft: ctx.data.nesting * 10 + '%',
                paddingLeft: 20,
                borderLeft: '5px solid ' + ctx.data.color
            }),
        b.style(bs.elem({ tag: 'hr' }, []), { marginBottom: 0 })];
        b.style(me, chosenStyle);
    },
    postRender(ctx: IChosenDefinitionCtx) {
        let el = <HTMLDivElement>ctx.me.element;
        if (el !== undefined) {
            let y = window.pageYOffset;
            window.scrollTo(0, y);
        }
    }
});