import * as b from 'bobril';
import * as bs from 'bobrilstrap';

const definitionStyle = b.styleDef({
    direction: 'ltr'
});

export interface IDefinitionData {
    color: string;
    text: b.IBobrilChildren;
    nesting?: number;
}

interface IDefinitionCtx extends b.IBobrilCtx {
    data: IDefinitionData;
}

export const definition = b.createComponent<IDefinitionData>({
    id: 'definition',
    render(ctx: IDefinitionCtx, me: b.IBobrilNode) {
        me.children = [
            b.style
                (
                bs.elem(
                    { tag: 'div' }, [
                        b.style(
                            b.style(bs.elem({ tag: 'div' }, [ctx.data.text])), definitionStyle),
                    ]
                ),
                {
                    marginLeft: ctx.data.nesting * 10 + '%',
                    paddingLeft: 20,
                    borderLeft: '5px solid ' + ctx.data.color
                }
                ),
            b.style(bs.elem({ tag: 'hr' }, []), { marginBottom: 0 })];
        b.style(me, { paddingTop: 20, opacity: 0.4 });
    },
});