import * as b from 'bobril';
import * as colors from '../../common/colors';

const sentenceStyle = b.styleDef({
    width: '100%', height: '20%',
    marginTop: 15,
    backgroundColor: '#FFFFFF',
    border: '1px solid ' + colors.grayDarkerLight,
    padding: 15,
    overflowY: 'auto'
});

const sentenceStyleFull = b.styleDef({
    width: '100%', height: '20%',
    marginTop: 9,
    backgroundColor: '#FFFFFF',
    border: '1px solid ' + colors.grayDarkerLight,
    padding: 15,
    overflowY: 'auto'
});

const sentenceStyleNoSentences = b.styleDef({
    visibility: 'hidden'
});

export interface ISentenceData {
    color?: string;
    text: b.IBobrilChildren;
    shownSentences: boolean;
    fullScreen: boolean;
}

interface ISentenceCtx extends b.IBobrilCtx {
    data: ISentenceData;
}

export const sentence = b.createComponent<ISentenceData>({
    id: 'sentence',
    render(ctx: ISentenceCtx, me: b.IBobrilNode) {
        me.children = [ctx.data.text];
        b.style(me, ctx.data.shownSentences ? ctx.data.fullScreen ? sentenceStyleFull : sentenceStyle : sentenceStyleNoSentences);
    },
});