import * as b from 'bobril';
import * as colors from '../../common/colors';

const wrapDivStyle = b.styleDef({
    position: 'relative', width: 1024, height: 768, marginTop: 50,
    marginBottom: 0, marginLeft: 'auto', marginRight: 'auto',
    border: '1px solid ' + colors.grayDarkerLight,
    fontSize: 15,
    backgroundColor: colors.grayLight,
    padding: 15
});

const wrapDivStyleFull = b.styleDef({
    position: 'fixed', top: 0, left: 0, right: 0, bottom: 0, height: '100%', width: '100%', 
    backgroundColor: colors.grayLight,
    fontSize: 20,
    padding: 15
});

const wrap = b.styleDef({});

export interface ISvgWrapData {
    children?: b.IBobrilChildren;
    fullScreen: boolean;
}

export interface ISvgWrapCtx extends b.IBobrilCtx {
    data: ISvgWrapData;
}

export const svgWrap = b.createComponent<ISvgWrapData>({
    render(ctx: ISvgWrapCtx, me: b.IBobrilNode, oldMe?: b.IBobrilCacheNode): void {
        me.children = ctx.data.children;
        b.style(me, ctx.data.fullScreen ? wrapDivStyleFull : wrapDivStyle);
        b.style(me, wrap);
    }
});