/// <reference types="bootstrap-slider" />

import * as b from 'bobril';
import * as bs from 'bobrilstrap';
import * as theme from './theme/init';
import { mainPage } from './main/mainPage';
import { uvod } from './main/uvod';
import { veta1 } from './proofs/veta1/veta1';
import { tvrzeni1 } from './proofs/tvrzeni1/tvrzeni1';
import { tvrzeni2 } from './proofs/tvrzeni2/tvrzeni2';
import { tvrzeni3 } from './proofs/tvrzeni3/tvrzeni3';
import { veta2 } from './proofs/veta2/veta2';
import { veta3 } from './proofs/veta3/veta3';
import { veta4 } from './proofs/veta4/veta4';
import { veta5 } from './proofs/veta5/veta5';
import { veta6 } from './proofs/veta6/veta6';
import { vyroky } from './statements/vyroky';
import { negace } from './statements/negace';
import { kvantifikovaneVyroky } from './statements/kvantifikovaneVyroky';
import { slozeneVyroky } from './statements/slozeneVyroky';
import { vety } from './statements/vety';
import { procviceni } from './statements/procviceni';
import { primo } from './proofTypes/primo';
import { neprimo } from './proofTypes/neprimo';
import { sporem } from './proofTypes/sporem';
import { indukci } from './proofTypes/indukci';
import { prirucka } from './main/prirucka';

bs.init();
b.asset('node_modules/bootstrap-slider/dist/bootstrap-slider.js');
b.asset('node_modules/bootstrap-slider/dist/css/bootstrap-slider.css');
b.asset('node_modules/jquery.scrollintoview/jquery.scrollintoview.js');
theme.init();
document.title = 'GraPro - Důkazy z teorie grafů';
b.routes(
    b.route({ handler: mainPage }, [
        b.route({ url: '/veta1', name: 'veta1', handler: veta1 }),
        b.route({ url: '/tvrzeni1', name: 'tvrzeni1', handler: tvrzeni1 }),
        b.route({ url: '/tvrzeni2', name: 'tvrzeni2', handler: tvrzeni2 }),
        b.route({ url: '/tvrzeni3', name: 'tvrzeni3', handler: tvrzeni3 }),
        b.route({ url: '/veta2', name: 'veta2', handler: veta2 }),
        b.route({ url: '/veta3', name: 'veta3', handler: veta3 }),
        b.route({ url: '/veta4', name: 'veta4', handler: veta4 }),
        b.route({ url: '/veta5', name: 'veta5', handler: veta5 }),
        b.route({ url: '/veta6', name: 'veta6', handler: veta6 }),
        b.route({ url: '/vyroky', name: 'vyroky', handler: vyroky }),
        b.route({ url: '/negace', name: 'negace', handler: negace }),
        b.route({ url: '/kvantifikovaneVyroky', name: 'kvantifikovaneVyroky', handler: kvantifikovaneVyroky }),
        b.route({ url: '/slozeneVyroky', name: 'slozeneVyroky', handler: slozeneVyroky }),
        b.route({ url: '/vety', name: 'vety', handler: vety }),
        b.route({ url: '/procviceni', name: 'procviceni', handler: procviceni }),
        b.route({ url: '/primo', name: 'primo', handler: primo }),
        b.route({ url: '/neprimo', name: 'neprimo', handler: neprimo }),
        b.route({ url: '/sporem', name: 'sporem', handler: sporem }),
        b.route({ url: '/indukci', name: 'indukci', handler: indukci }),
        b.route({ url: '/uvod', name: 'uvod', handler: uvod }),
        b.route({ url: '/prirucka', name: 'prirucka', handler: prirucka }, [
            b.route({ url: '/priruckaUvod', name: 'priruckaUvod', handler: false }),
            b.route({ url: '/priruckaSystem', name: 'priruckaSystem', handler: false }),
            b.route({ url: '/priruckaAplikace', name: 'priruckaAplikace', handler: false }),
            b.route({ url: '/priruckaVyroky', name: 'priruckaVyroky', handler: false }),
            b.route({ url: '/priruckaTypy', name: 'priruckaTypy', handler: false }),
            b.route({ url: '/priruckaDukazy', name: 'priruckaDukazy', handler: false }),
            b.route({ url: '/priruckaFAQ', name: 'priruckaFAQ', handler: false }),
        ]),
        b.routeDefault({ handler: uvod })
    ])
);