import * as b from 'bobril';
import * as bs from 'bobrilstrap';

const tableKvantStyle = b.styleDef({
    width: 900,
    marginLeft: 'auto',
    marginRight: 'auto'
});

const infoStyle = b.styleDef({
    padding: 0,
});

export const uvod = b.createVirtualComponent({
    render(ctx: b.IBobrilCtx, me: b.IBobrilNode) {
        me.children = [
            bs.h2({}, 'Úvod'),
            bs.paragraph({}, ['Cílem webové aplikace GraPro je podpořit výuku předmětů zabývajících se ',
                'teorií grafů, a to hlavně v oblasti důkazů. ',
                'Aplikace obsahuje teoretický úvod do ',
                b.link(bs.a({}, 'výrokové logiky'), 'vyroky'),
                ' a vizualizaci ',
                b.link(bs.a({}, 'negací'), 'negace'),
                '. ',
                'Najdete zde obecné typy důkazů, jako například ',
                b.link(bs.a({}, 'důkaz přímo'), 'primo'),
                ', a vizualizace vybraných důkazů z teorie grafů, mezi které patří například ',
                b.link(bs.a({}, 'princip sudosti'), 'veta1'),
                '. Teoretická část aplikace byla zpracována s využitím níže uvedených zdrojů. ',
                'Aplikace vznikla jako součást diplomové práce na Fakultě informatiky a managementu ',
                'Univerzity Hradec Králové. ']),

            bs.elem({ tag: 'br' }, []),

            b.style(
                bs.table({}, [
                    bs.tr({}, [
                        b.style(bs.td({}, ['Název práce:']), infoStyle),
                        bs.td({}, ['Vizuální podpora výuky předmětů zabývajících se teorií grafů a grafovými algoritmy']),
                    ]),
                    bs.tr({}, [
                        b.style(bs.td({}, ['Autorka:']), infoStyle),
                        bs.td({}, ['Bc. Markéta Šťastná'])
                    ]),
                    bs.tr({}, [
                        b.style(bs.td({}, ['Obor:']), infoStyle),
                        bs.td({}, ['Aplikovaná informatika']),
                    ]),
                    bs.tr({}, [
                        b.style(bs.td({}, ['Vedoucí práce:']), infoStyle),
                        bs.td({}, ['RNDr. Andrea Ševčíková']),
                    ]),
                    bs.tr({}, [
                        b.style(bs.td({}, ['Kontakt:']), infoStyle),
                        bs.td({}, [bs.a({ href: 'mailto:stastna.marketa@centrum.cz' }, 'stastna.marketa@centrum.cz')]),
                    ]),
                ]),
            ),
            bs.h3({}, 'Zdroje'),
            bs.paragraph({}, [
                '[1] THIELE, Rüdiger. Matematické důkazy. Praha: Státní nakladatelství technické literatury, 1985. Polytechnická knižnice (SNTL).']),
            bs.paragraph({}, [
                '[2] ŠEDIVÝ, Jaroslav, Júlia LUKÁTŠOVÁ, Oldřich ODVÁRKO a Michal ZÖLDY. Úlohy o výrokoch a množinách pre 1. ročník gymnázia. Bratislava: Slovenské pedagogické nakladateľstvo, 1970.']),
            bs.paragraph({}, [
                '[3] PRAŽÁK, Pavel. Matematika 1. Hradec Králové: Gaudeamus, 2012. ISBN 978-80-7435-227-0.']),
            bs.paragraph({}, [
                '[4] ČECH, Vlastimil. Proč děláme důkazy v matematice. Praha: Státní pedagogické nakladatelství, 1971. Knižnice všeobecného vzdělávání mládeže.']),
            bs.paragraph({}, [
                '[5] Základy matematiky: Výroková logika. In: MATEMATIKA online [online]. Ústav matematiky FSI VUT Brno, 2005 [cit. 2017-04-05]. Dostupné z: http://mathonline.fme.vutbr.cz/Logika-dukazy-mnoziny-relace-zobrazeni-algebraicke-struktury/sc-15-sr-1-a-31/default.aspx']),
            bs.paragraph({}, [
                '[6] MIŠKOVSKÝ, Pavel. Důkazy. In: Gymnázium Na Vítězné pláni [online]. Praha 4: Gymnázium Na Vítězné pláni, 2007 [cit. 2017-04-05]. Dostupné z: http://www.gvp.cz/~vinkle/mafynet/M_opakovaci_seminar/02_studijni_texty/Dukazy.pdf']),
            bs.paragraph({}, [
                '[7] Co je to důkaz. Matematika.cz [online]. Brno-město: Vydavatelství Nová média, 2014 [cit. 2017-04-05]. Dostupné z: http://www.matematika.cz/dukazy']),
            bs.paragraph({}, [
                '[8] MILKOVÁ, Eva. Teorie grafů a grafové algoritmy. Hradec Králové: Gaudeamus, 2013. ISBN 978-80-7435-267-6.']),
            bs.paragraph({}, [
                '[9] ČADA, Roman, Tomáš KAISER a Zdeněk RYJÁČEK. Diskrétní matematika. Plzeň: Západočeská univerzita v Plzni, 2004. ISBN 80-7082-939-7.']),
        ];
    }
});