import * as b from 'bobril';
import * as bs from 'bobrilstrap';
import * as a from '../../viewer/actions';
import * as colors from '../../common/colors';

export const examples = () => [
    {
        name: 'tvrzeni2',
        definitions: [
            {
                nesting: 0,
                color: colors.redHighlight,
                text: [
                    'Graf ',
                    bs.em({}, 'G'), ' je souvislý a obsahuje kružnici ',
                    bs.em({}, 'C'),
                    '. Pak graf ',
                    bs.em({}, 'G '), '-', bs.em({}, ' e'), ', kde ',
                    bs.em({}, 'e'), ' je libovolná hrana kružnice ',
                    bs.em({}, 'C'),
                    ', je také souvislý.'
                ]
            },
            {
                nesting: 0,
                color: colors.redHighlight,
                text: ['Dokazujeme implikaci.']
            },
            {
                nesting: 0,
                color: colors.redHighlight,
                text: [
                    'Zobrazený graf ',
                    bs.em({}, 'G'), ' je souvislý ',
                    ' a obsahuje kružnici ',
                    bs.em({}, 'C'), '.',
                ]
            },
            {
                nesting: 0,
                color: colors.redHighlight,
                text: [
                    bs.em({}, 'e '), '=', bs.em({}, ' {v, w}'), ' je libovolná hrana kružnice ',
                    bs.em({}, 'C'), '. ',
                    'Označíme ',
                    bs.em({}, 'P '), '=', bs.em({}, ' C - e'), ' (kružnice bez hrany ',
                    bs.em({}, 'e'), ') jako cestu z vrcholu ',
                    bs.em({}, 'v'), ' do ',
                    bs.em({}, 'w'), '. '
                ]
            },
            {
                nesting: 0,
                color: colors.redHighlight,
                text: [
                    'Dokážeme přímo. Graf je souvislý, to znamená, že dle definice existuje mezi každými ',
                    'dvěma vrcholy ',
                    bs.em({}, 'x'), ', ',
                    bs.em({}, 'y'), ' cesta ', bs.em({}, ['P', bs.sub({}, ['x,y'])]),
                    '. Tato cesta může nebo nemusí v našem případě obsahovat hranu ',
                    bs.em({}, 'e'), '. '
                ]
            },
            {
                nesting: 0,
                color: colors.orangeHighlight,
                text: [
                    '1. případ: cesta ', bs.em({}, ['P', bs.sub({}, ['x,y'])]),
                    ' neobsahuje hranu ',
                    bs.em({}, 'e'), '. '
                ]
            },
            {
                nesting: 1,
                color: colors.orangeHighlightLight,
                text: [
                    'To znamená, že cesta ', bs.em({}, ['P', bs.sub({}, ['x,y'])]),
                    ' je zároveň cestou i v grafu ',
                    bs.em({}, 'G '), '-', bs.em({}, ' e'),
                    '.',
                ]
            },
            {
                nesting: 0,
                color: colors.greenHighlight,
                text: [
                    '2. případ: cesta ', bs.em({}, ['P', bs.sub({}, ['x,y'])]),
                    ' obsahuje hranu ',
                    bs.em({}, 'e'), '. '
                ]
            },
            {
                nesting: 1,
                color: colors.greenHighlightLight,
                text: [
                    'V tom případě hranu ',
                    bs.em({}, 'e'), ' nahradíme cestou ',
                    bs.em({}, 'P'), ' ',
                    'a tím získáme sled z vrcholu ',
                    bs.em({}, 'x'), ' do vrcholu ',
                    bs.em({}, 'y'), ' v původním grafu ',
                    bs.em({}, 'G'), '.',
                ]
            },
            {
                nesting: 1,
                color: colors.greenHighlightLight,
                text: [
                    'Ten je sledem z vrcholu ',
                    bs.em({}, 'x'),
                    ' do vrcholu ',
                    bs.em({}, 'y'), ' i v grafu ',
                    bs.em({}, 'G '), '-', bs.em({}, ' e'), '.',
                ]
            },
            {
                nesting: 1,
                color: colors.greenHighlightLight,
                text: [
                    'Podle Tvrzení 1 tak existuje v ',
                    bs.em({}, 'G '), '-', bs.em({}, ' e'),
                    ' cesta z vrcholu ',
                    bs.em({}, 'x'),
                    ' do vrcholu ',
                    bs.em({}, 'y'),
                    '. ',
                    'Dle definice souvislosti je graf ',
                    bs.em({}, 'G '), '-', bs.em({}, ' e'),
                    ' souvislý.',
                ]
            },
        ],
        steps: [
            { // 0
                actions: [
                    a.addWhiteboard(
                        'whiteboard1',
                        { x: 0, y: 50 },
                        ['Pro každý graf ', bs.em({}, 'G'), '=', bs.em({}, '(V, E)'), ' platí: '],
                        undefined,
                        undefined,
                        40,
                        0
                    ),
                    a.addWhiteboard(
                        'whiteboard1.2',
                        { x: 0, y: 100 },
                        [bs.strong({}, ['Jestliže'])],
                        undefined,
                        undefined,
                        40,
                        1500
                    ),
                    a.addWhiteboard(
                        'whiteboard1.21',
                        { x: 0, y: 150 },
                        ['graf ', bs.em({}, 'G'), ' je souvislý a obsahuje kružnici ', bs.em({}, 'C'), ', '],
                        undefined,
                        undefined,
                        40,
                        2250
                    ),
                    a.addWhiteboard(
                        'whiteboard1.3',
                        { x: 0, y: 200 },
                        [bs.strong({}, [' pak '])],
                        undefined,
                        undefined,
                        40,
                        3000
                    ),
                    a.addWhiteboard(
                        'whiteboard1.4',
                        { x: 0, y: 250 },
                        [
                            'graf ',
                            bs.em({}, 'G '),
                            '-',
                            bs.em({}, ' e'),
                            ', kde ',
                            bs.em({}, 'e'),
                            ' je libovolná hrana kružnice ',
                            bs.em({}, 'C'), ', ',
                            bs.elem({ tag: 'br' }, []),
                            'je také souvislý.'],
                        undefined,
                        undefined,
                        40,
                        3700
                    ),
                ],
                sentence: {
                    text: [
                        bs.strong({}, 'Souvislý graf'), ' je graf, ve kterém existuje mezi každými jeho dvěma vrcholy cesta. ',
                    ]
                },
                time: 5000
            },
            { // 0
                actions: [
                    a.editWhiteboard(
                        'whiteboard1.21',
                        undefined,
                        [b.style(bs.element({ tag: 'span' }, [
                            'graf ', bs.em({}, 'G'), ' je souvislý a obsahuje kružnici ', bs.em({}, 'C')
                        ]), { color: colors.redHighlight })],
                    ),
                    a.editWhiteboard(
                        'whiteboard1.4',
                        undefined,
                        [b.style(bs.element({ tag: 'span' }, [
                            'graf ', bs.em({}, 'G '),
                            '-',
                            bs.em({}, ' e'), ', kde ', bs.em({}, 'e'), ' je libovolná hrana kružnice ', bs.em({}, 'C'), ', ',
                            bs.elem({ tag: 'br' }, []),
                            'je také souvislý.'
                        ]), { color: colors.greenHighlight })],
                    ),
                    a.addHint(
                        'whiteboard2',
                        { x: 530, y: 175 },
                        ['Výrok ', bs.em({}, 'A')],
                        undefined,
                        colors.redHighlight,
                        1500
                    ),
                    a.addHint(
                        'whiteboard3',
                        { x: 530, y: 275 },
                        ['Výrok ', bs.em({}, 'B')],
                        undefined,
                        colors.greenHighlight,
                        3000
                    ),
                    a.addWhiteboard(
                        'whiteboard4',
                        { x: 210, y: 350 },
                        [bs.em({}, 'A')],
                        colors.redHighlight,
                        undefined,
                        40,
                        1500,
                        35
                    ),
                    a.addWhiteboard(
                        'whiteboard4.2',
                        { x: 320, y: 350 },
                        [bs.em({}, 'B')],
                        colors.greenHighlight,
                        undefined,
                        40,
                        3000,
                        35
                    ),
                    a.addWhiteboard(
                        'whiteboard4.3',
                        { x: 260, y: 350 },
                        ['\u21D2'],
                        colors.defaultBlack,
                        undefined,
                        40,
                        4000,
                        35
                    ),
                ],
                sentence: {
                    text: [
                        bs.strong({}, ['Implikace ',
                            bs.em({}, 'p '), '\u21D2', bs.em({}, ' q')]), ': jestliže platí výrok ',
                        bs.em({}, 'p'),
                        ', pak platí výrok ',
                        bs.em({}, 'q'),
                    ]
                },
                time: 6000
            },
            { // 1
                actions: [
                    a.addHint('dukaz-1', { x: 50, y: 60 }, [
                        'Kružnice ',
                        bs.em({}, 'C '), '=', bs.em({}, ' (v, a, b, c, w, v)'),
                    ], undefined, undefined, 0),

                    a.removeWhiteboard('whiteboard1'),
                    a.removeWhiteboard('whiteboard1.2'),
                    a.removeWhiteboard('whiteboard1.21'),
                    a.removeWhiteboard('whiteboard1.3'),
                    a.removeWhiteboard('whiteboard1.4'),
                    a.removeHint('whiteboard2'),
                    a.removeHint('whiteboard3'),
                    a.removeWhiteboard('whiteboard4'),
                    a.removeWhiteboard('whiteboard4.2'),
                    a.removeWhiteboard('whiteboard4.3'),

                    a.addVertex('x', { x: 150, y: 315 }, 'x', undefined, undefined, colors.blueHighlightLight),
                    a.addVertex('y', { x: 630, y: 260 }, 'y', undefined, undefined, colors.blueHighlightLight),
                    a.addVertex('v', { x: 400, y: 317 }, 'v'),
                    a.addVertex('w', { x: 520, y: 240 }, 'w'),
                    a.addVertex('a', { x: 270, y: 240 }, 'a'),
                    a.addVertex('b', { x: 300, y: 100 }, 'b'),
                    a.addVertex('c', { x: 480, y: 90 }, 'c'),
                    a.addEdge('a-b', 'a', 'b'),
                    a.addEdge('b-c', 'b', 'c'),
                    a.addEdge('c-w', 'c', 'w'),
                    a.addEdge('v-w', 'v', 'w'),
                    a.addEdge('a-v', 'a', 'v'),
                    a.addEdge('x-a', 'x', 'a'),
                    a.addEdge('w-y', 'w', 'y'),
                    a.addCloud(),

                    a.highlightEdge('a-b', a.HighlightType.Full, undefined, undefined, undefined, undefined, 2000, 'a-b-red'),
                    a.highlightEdge('b-c', a.HighlightType.Full, undefined, undefined, undefined, undefined, 3000, 'b-c-red'),
                    a.highlightEdge('c-w', a.HighlightType.Full, undefined, undefined, undefined, undefined, 4000, 'c-w-red'),
                    a.highlightEdge('v-w', a.HighlightType.Full, undefined, undefined, undefined, undefined, 5000, 'v-w-red'),
                    a.highlightEdge('a-v', a.HighlightType.Full, undefined, undefined, undefined, undefined, 1000, 'a-v-red'),

                    a.editVertex('v', undefined, undefined, undefined, undefined, colors.redHighlightLight, undefined),
                    a.editVertex('w', undefined, undefined, undefined, undefined, colors.redHighlightLight, undefined, 5000),
                    a.editVertex('b', undefined, undefined, undefined, undefined, colors.redHighlightLight, undefined, 3000),
                    a.editVertex('c', undefined, undefined, undefined, undefined, colors.redHighlightLight, undefined, 4000),
                    a.editVertex('a', undefined, undefined, undefined, undefined, colors.redHighlightLight, undefined, 2000),
                ],
                sentence: {
                    text: [
                        bs.strong({}, 'Kružnice (cyklus)'), ' v grafu ',
                        bs.em({}, 'G'),
                        ' je posloupnost',
                        bs.em({}, [
                            '(v',
                            bs.sub({}, '0'), ', e',
                            bs.sub({}, '1'), ', v',
                            bs.sub({}, '1'), ', ..., e',
                            bs.sub({}, 'k'), ', v',
                            bs.sub({}, '0'), ')'
                        ]),
                        ' kde ',
                        bs.em({}, ['e', bs.sub({}, 'i')]), ' = ', bs.em({}, ['{v', bs.sub({}, 'i-1'), ', v', bs.sub({}, 'i'), '}, i']),
                        ' = ', bs.em({}, ['1,..., k-1; ']),
                        bs.em({}, ['e', bs.sub({}, 'k')]), ' = ', bs.em({}, ['{v', bs.sub({}, 'k-1'), ', v', bs.sub({}, '0'), '}'
                        ]),
                        bs.e({ tag: 'br' }),
                        '\u2022 První a poslední vrchol je stejný ',
                        bs.e({ tag: 'br' }),
                        '\u2022 Hrany a vrcholy od ',
                        bs.em({}, ['v', bs.sub({}, '0')]), ' do ',
                        bs.em({}, ['v', bs.sub({}, 'k-1')])
                        , ' se ',
                        bs.strong({}, 'nesmí'),
                        ' opakovat',
                    ]
                },
                time: 7375
            },
            { // 2
                actions: [
                    a.removeHint('dukaz-1'),
                    a.addHint('dukaz-2', { x: 50, y: 80 }, [
                        'Cesta ', bs.em({}, 'P '), '=', bs.em({}, ' (v, a, b, c, w)'),
                    ], undefined, undefined, 2000),
                    a.addHint('dukaz-2.1', { x: 380, y: 320 }, [
                        'Hrana ', bs.em({}, 'e '), '=', bs.em({}, ' {v, w}'),
                    ], undefined, colors.greenHighlight, 0),
                    a.unHighlightEdge('v-w-red', a.HighlightType.Full),
                    a.highlightEdge('v-w', a.HighlightType.Full, undefined, colors.greenHighlight, undefined, undefined, 1000, 'v-w-green')
                ],
                sentence: {
                    text: [
                        bs.strong({}, 'Cesta'), ' je sled s navzájem různými vrcholy, tj. pro ',
                        bs.em({}, 'i '), '\u2260', bs.em({}, ' j'), ' platí ',
                        bs.em({}, [
                            'v', bs.sub({}, 'i'), ' \u2260 v', bs.sub({}, 'j')
                        ]),
                        bs.e({ tag: 'br' }),
                        'Když z kružnice odebereme hranu spojující dva body, zbytek kružnice utvoří cestu mezi těmito dvěma body.',
                    ]
                },
                time: 3000
            },
            { // 3
                actions: [
                    a.removeHint('dukaz-2'),
                    a.removeHint('dukaz-2.1'),
                    a.highlightVertex('x', undefined, colors.blueHighlight),
                    a.highlightVertex('y', undefined, colors.blueHighlight),
                    a.editVertex('v', undefined, undefined, undefined, undefined, colors.defaultVertex),
                    a.editVertex('w', undefined, undefined, undefined, undefined, colors.defaultVertex),
                    a.editVertex('a', undefined, undefined, undefined, undefined, colors.defaultVertex),
                    a.editVertex('b', undefined, undefined, undefined, undefined, colors.defaultVertex),
                    a.editVertex('c', undefined, undefined, undefined, undefined, colors.defaultVertex),
                    a.unHighlightEdge('a-b-red', a.HighlightType.Full),
                    a.unHighlightEdge('b-c-red', a.HighlightType.Full),
                    a.unHighlightEdge('c-w-red', a.HighlightType.Full),
                    a.unHighlightEdge('v-w-green', a.HighlightType.Full),
                    a.unHighlightEdge('a-v-red', a.HighlightType.Full)
                ],
                sentence: {
                    text: [
                        bs.strong({}, 'Důkaz přímo:'),
                        bs.e({ tag: 'br' }),
                        'Předpokládáme, že výrok ',
                        bs.em({}, 'A'),
                        ' platí (graf ',
                        bs.em({}, 'G'),
                        ' je souvislý), a řetězcem implikací dojdeme k závěru ',
                        bs.em({}, 'B'),
                        ' (graf ',
                        bs.em({}, 'G '), '-', bs.em({}, ' e'),
                        ' je souvislý): ',
                        bs.e({ tag: 'br' }),
                        bs.em({}, 'A '), '\u21D2',
                        bs.em({}, [' B', bs.sub({}, '1'), ' ']), '\u21D2',
                        bs.em({}, ['B', bs.sub({}, '2')]), ' \u21D2 ... \u21D2 ',
                        bs.em({}, ['B', bs.sub({}, 'n'), ' ']), '\u21D2',
                        bs.em({}, ' B')
                    ]
                },
                time: 500
            },
            { // 4
                actions: [
                    a.addHint('dukaz-4', { x: 40, y: 100 }, [
                        'Cesta ', bs.em({}, ['P', bs.sub({}, ['x,y']), ' ']), '=', bs.em({}, ' (x, a, b, c, w, y)'),
                    ], undefined, colors.orangeHighlight, 0),
                    a.addWhiteboard('graf1', { x: 560, y: 50 }, [
                        'Graf ', bs.em({}, 'G'),
                    ], undefined, undefined, 0),

                    a.highlightEdge('a-b', a.HighlightType.Full, undefined, colors.orangeHighlight,
                        undefined, undefined, 2000, 'a-b-orange'),
                    a.highlightEdge('b-c', a.HighlightType.Full, undefined, colors.orangeHighlight,
                        undefined, undefined, 3000, 'b-c-orange'),
                    a.highlightEdge('c-w', a.HighlightType.Full, undefined, colors.orangeHighlight,
                        undefined, undefined, 4000, 'c-w-orange'),
                    a.highlightEdge('w-y', a.HighlightType.Full, undefined, colors.orangeHighlight,
                        undefined, undefined, 5000, 'w-y-orange'),
                    a.highlightEdge('x-a', a.HighlightType.Full, undefined, colors.orangeHighlight,
                        undefined, undefined, 1000, 'x-a-orange'),

                    a.editVertex('w', undefined, undefined, undefined, undefined, colors.orangeHighlightLight, undefined, 5000),
                    a.editVertex('b', undefined, undefined, undefined, undefined, colors.orangeHighlightLight, undefined, 3000),
                    a.editVertex('c', undefined, undefined, undefined, undefined, colors.orangeHighlightLight, undefined, 4000),
                    a.editVertex('a', undefined, undefined, undefined, undefined, colors.orangeHighlightLight, undefined, 2000),
                ],
                sentence: {
                    text: [
                        bs.strong({}, 'Cesta'), ' je sled s navzájem různými vrcholy, tj. pro ',
                        bs.em({}, 'i '), '\u2260', bs.em({}, ' j'), ' platí ',
                        bs.em({}, ['v', bs.sub({}, 'i'), ' ']), '\u2260', bs.em({}, [' v', bs.sub({}, 'j')]),
                        bs.e({ tag: 'br' }),
                        '\u2022 Hrany a vrcholy se v cestě ', bs.strong({}, 'nesmí'), ' opakovat',
                    ]
                },
                time: 7000
            },
            {
                actions: [
                    a.removeWhiteboard('graf1'),
                    a.addWhiteboard(
                        'graf2', { x: 560, y: 50 }, ['Graf ', bs.em({}, 'G '), '-', bs.em({}, ' e')], undefined, undefined, 0
                    ),
                    a.removeEdge('v-w')
                ],
                sentence: {
                    text: [
                        bs.strong({}, 'Cesta'), ' je sled s navzájem různými vrcholy, tj. pro ',
                        bs.em({}, 'i '), '\u2260', bs.em({}, ' j'), ' platí ',
                        bs.em({}, ['v', bs.sub({}, 'i'), ' ']), '\u2260', bs.em({}, [' v', bs.sub({}, 'j')]),
                        bs.e({ tag: 'br' }),
                        '\u2022 Hrany a vrcholy se v cestě ', bs.strong({}, 'nesmí'), ' opakovat',
                    ]
                },
                time: 500
            },
            { // 6
                actions: [
                    a.removeWhiteboard('graf2'),
                    a.removeHint('dukaz-4'),
                    a.addHint('dukaz-6', { x: 350, y: 340 }, [
                        'Cesta ', bs.em({}, ['P', bs.sub({}, ['x,y']), ' ']), '=', bs.em({}, [' (x, a, v, w, y)']),
                    ], undefined, colors.greenHighlight, 0),
                    a.addEdge('v-w', 'v', 'w'),

                    a.unHighlightEdge('a-b-orange', a.HighlightType.Full),
                    a.unHighlightEdge('b-c-orange', a.HighlightType.Full),
                    a.unHighlightEdge('c-w-orange', a.HighlightType.Full),
                    a.unHighlightEdge('w-y-orange', a.HighlightType.Full),
                    a.unHighlightEdge('x-a-orange', a.HighlightType.Full),

                    a.highlightEdge('w-y', a.HighlightType.Full, undefined, colors.greenHighlight, undefined, undefined, 4000, 'w-y-green'),
                    a.highlightEdge('x-a', a.HighlightType.Full, undefined, colors.greenHighlight, undefined, undefined, 1000, 'x-a-green'),
                    a.highlightEdge('v-w', a.HighlightType.Full, undefined, colors.greenHighlight, undefined, undefined, 3000, 'v-w-green'),

                    a.removeEdge('a-v'),

                    a.addEdge('a-v', 'a', 'v', undefined, undefined, undefined, undefined, 10, 5),
                    a.addEdge('a-v1', 'a', 'v', undefined, 7, colors.greenHighlight, undefined, 50, 5, 2000),

                    a.editVertex('w', undefined, undefined, undefined, undefined, colors.defaultVertex),
                    a.editVertex('a', undefined, undefined, undefined, undefined, colors.defaultVertex),
                    a.editVertex('b', undefined, undefined, undefined, undefined, colors.defaultVertex),
                    a.editVertex('c', undefined, undefined, undefined, undefined, colors.defaultVertex),

                    a.editVertex('a', undefined, undefined, undefined, undefined, colors.greenHighlightLight, undefined, 2000),
                    a.editVertex('v', undefined, undefined, undefined, undefined, colors.greenHighlightLight, undefined, 3000),
                    a.editVertex('w', undefined, undefined, undefined, undefined, colors.greenHighlightLight, undefined, 4000),
                ],
                sentence: {
                    text: [
                        bs.strong({}, 'Cesta'), ' je sled s navzájem různými vrcholy, tj. pro ',
                        bs.em({}, 'i '), '\u2260', bs.em({}, ' j'), ' platí ',
                        bs.em({}, ['v', bs.sub({}, 'i'), ' ']), '\u2260', bs.em({}, [' v', bs.sub({}, 'j')]),
                        bs.e({ tag: 'br' }),
                        '\u2022 Hrany a vrcholy se v cestě ', bs.strong({}, 'nesmí'), ' opakovat',
                    ]
                },
                time: 6000
            },
            { // 7
                actions: [
                    a.addWhiteboard('graf3', { x: 560, y: 50 }, [
                        'Graf ', bs.em({}, 'G'),
                    ], undefined, undefined, 0),
                    a.removeHint('dukaz-6'),
                    a.addHint('dukaz-7', { x: 20, y: 10 }, [
                        'Hranu ',
                        bs.em({}, '{v, w}'), ' nahradíme cestou:',
                        bs.e({ tag: 'br' }),
                        bs.em({}, ['P', bs.sub({}, ['v,w']), ' ']), '=', bs.em({}, ' (v, a, b, c, w)'),
                        bs.e({ tag: 'br' }),
                        'Výsledný sled ',
                        bs.em({}, 'S '), '=', bs.em({}, ' (x, a, v, a, b, c, w, y)'),
                    ], undefined, colors.greenHighlight, 0),
                    a.unHighlightEdge('v-w-green', a.HighlightType.Full),
                    a.addEdge('a-v2', 'a', 'v', undefined, 7, colors.greenHighlight, undefined, 50, -5, 2000),
                    //  a.highlightEdge('a-v', a.HighlightType.Full, 14, colors.greenHighlight),
                    a.highlightEdge('a-b', a.HighlightType.Full, undefined, colors.greenHighlight, undefined, undefined, 3000, 'a-b-green'),
                    a.highlightEdge('b-c', a.HighlightType.Full, undefined, colors.greenHighlight, undefined, undefined, 4000, 'b-c-green'),
                    a.highlightEdge('c-w', a.HighlightType.Full, undefined, colors.greenHighlight, undefined, undefined, 5000, 'c-w-green'),
                    a.editVertex('b', undefined, undefined, undefined, undefined, colors.greenHighlightLight, undefined, 4000),
                    a.editVertex('c', undefined, undefined, undefined, undefined, colors.greenHighlightLight, undefined, 5000),
                ],
                sentence: {
                    text: [
                        'Cesta ',
                        bs.em({}, ['P', bs.sub({}, ['v,w'])]), ' vznikla z kružnice odebráním hrany ',
                        bs.em({}, 'e'), '.',
                        bs.e({ tag: 'br' }),
                        bs.strong({}, 'Sled'), ' je posloupnost vrcholů a hran ', bs.em({}, ['(v', bs.sub({}, '0'), ', e',
                            bs.sub({}, '1'), ', v', bs.sub({}, '1'), ', ..., e', bs.sub({}, 'k'), ', v', bs.sub({}, 'k'), ')']),
                        ' kde ',
                        bs.em({}, ['e', bs.sub({}, 'i'), ' ']), '=',
                        bs.em({}, [' {v', bs.sub({}, 'i-1'), ', v', bs.sub({}, 'i'), '}, i ']), '=', bs.em({}, [' 1,..., k']),
                        bs.e({ tag: 'br' }),
                        '\u2022 Hrany a vrcholy se ', bs.strong({}, 'mohou'), ' opakovat',
                    ]
                },
                time: 7000
            },
            { // 8 
                actions: [
                    a.removeWhiteboard('graf3'),
                    a.addWhiteboard('graf4', { x: 560, y: 50 }, [
                        'Graf ', bs.em({}, 'G '), '-', bs.em({}, ' e'),
                    ], undefined, undefined, 0),
                    a.removeHint('dukaz-7'),
                    a.addHint('dukaz-8', { x: 20, y: 10 }, [
                        'Sled ',
                        bs.em({}, 'S '), '=', bs.em({}, ' (x, a, v, a, b, c, w, y)'),
                    ], undefined, colors.greenHighlight, 0),
                    a.removeEdge('v-w')
                ],
                sentence: {
                    text: [
                        bs.strong({}, 'Sled'), ' je posloupnost vrcholů a hran ', bs.em({}, ['(v', bs.sub({}, '0'), ', e',
                            bs.sub({}, '1'), ', v', bs.sub({}, '1'), ', ..., e', bs.sub({}, 'k'), ', v', bs.sub({}, 'k'), ')']),
                        ' kde ',
                        bs.em({}, ['e', bs.sub({}, 'i'), ' ']), '=',
                        bs.em({}, [' {v', bs.sub({}, 'i-1'), ', v', bs.sub({}, 'i'), '}, i = 1,..., k']),
                        bs.e({ tag: 'br' }),
                        '\u2022 Hrany a vrcholy se ', bs.strong({}, 'mohou'), ' opakovat',
                    ]
                },
                time: 500
            },
            { // 9
                actions: [
                    a.removeHint('dukaz-8'),
                    a.addHint('dukaz-9', { x: 30, y: 40 }, [
                        'Cesta ',
                        bs.em({}, 'P '), '=', bs.em({}, ' (x, a, b, c, w, y)'),
                    ], undefined, colors.greenHighlight, 0),
                    a.removeEdge('a-v1'),
                    a.removeEdge('a-v2'),
                    a.editVertex('v', undefined, undefined, undefined, undefined, colors.defaultVertex)
                ],
                sentence: {
                    text: [
                        bs.strong({}, 'Tvrzení 1:'),
                        bs.e({ tag: 'br' }),
                        'Pro každý graf ', bs.em({}, 'G'), '=', bs.em({}, '(V, E)'), ' platí: ', bs.e({ tag: 'br' }),
                        'V grafu ', bs.em({}, 'G'), ' existuje cesta z vrcholu ', bs.em({}, 'v'),
                        ' do vrcholu ', bs.em({}, 'w'), ' právě tehdy, když v grafu ', bs.em({}, 'G'), ' existuje sled ' +
                        'z vrcholu ', bs.em({}, 'v'), ' do vrcholu ', bs.em({}, 'w'), '.'
                    ]
                },
                time: 600
            },
        ]
    },
];