import * as b from 'bobril';
import * as bs from 'bobrilstrap';
import * as a from '../../viewer/actions';
import * as colors from '../../common/colors';

export const examples = () => [
    {
        name: 'tvrzeni3', definitions: [
            {
                nesting: 0,
                color: colors.orangeHighlight,
                text: ['Tvrzení:  Jestliže ', bs.em({}, 'T'), ' je netriviální strom, pak ', bs.em({}, 'T'),
                    ' obsahuje list (resp. obsahuje alespoň dva listy).']
            },
            {
                nesting: 0,
                color: colors.orangeHighlight,
                text: ['Dokazujeme implikaci.']
            },
            {
                nesting: 0,
                color: colors.orangeHighlight,
                text: [
                    bs.em({}, 'T '), '=', bs.em({}, ' (V, E)'), ' je strom s alespoň dvěma vrcholy.  ',
                    'Z definice stromu plyne, že strom je souvislý graf. ',
                ]
            },
            {
                nesting: 0,
                color: colors.orangeHighlight,
                text: [
                    'Dle definice souvislosti pro každé dva vrcholy stromu', bs.em({}, 'T'),
                    ' existuje cesta, která tyto vrcholy spojuje. ',
                ]
            },
            {
                nesting: 0,
                color: colors.orangeHighlight,
                text: [
                    'Označme ', bs.em({}, [
                        'P',
                        bs.sub({}, ['max'])]), ' =',
                    bs.em({}, [' (v',
                        bs.sub({}, ['0']), ', e',
                        bs.sub({}, ['1']), ', v',
                        bs.sub({}, ['1']), ', ..., v',
                        bs.sub({}, ['k'])]), ') cestu ',
                    'maximální délky ve stromu ',
                    bs.em({}, 'T'), '.',
                ]
            },
            {
                nesting: 0,
                color: colors.orangeHighlight,
                text: [
                    'Tvrdíme, že vrchol ', bs.em({}, ['v', bs.sub({}, ['0'])]), ' je list. ',
                    'Dokážeme sporem. ',
                    'Negace: vrchol ',
                    bs.em({}, ['v', bs.sub({}, ['0'])]), ' není list stromu ', bs.em({}, 'T'), '. Vrchol ',
                    bs.em({}, ['v', bs.sub({}, ['0'])]), ' je tudíž spojen hranou nejen s ',
                    bs.em({}, ['v', bs.sub({}, ['1'])]), ', ',
                    'ale alespoň s jedním dalším vrcholem ', bs.em({}, 'v'), '.',
                ]
            },
            {
                nesting: 1,
                color: colors.greenHighlight,
                text: [
                    '1. Jestliže ', bs.em({}, 'v'), ' leží na ', bs.em({}, ['P', bs.sub({}, ['max'])]),
                    ', pak posloupnost tvoří kružnici ',
                    '- spor s předpokladem, že ', bs.em({}, 'T'), ' je strom.',
                ]
            },
            {
                nesting: 1,
                color: colors.purpleHighlight,
                text: [
                    '2. Jestliže ', bs.em({}, 'v'), ' neleží na ', bs.em({}, ['P', bs.sub({}, ['max'])]),
                    ', ',
                    'pak existuje ve stromu ', bs.em({}, 'T'), ' cesta ',
                    'o jednu hranu delší než cesta ', bs.em({}, ['P', bs.sub({}, ['max'])]),
                    ' ',
                    '- spor s předpokladem.'
                ]
            },
            {
                nesting: 0,
                color: colors.orangeHighlight,
                text: [
                    'Dokázali jsme, že vrchol ', bs.em({}, ['v', bs.sub({}, ['0'])]), ' je list. ',
                    'Analogicky můžeme dokázat, že vrchol ', bs.em({}, ['v', bs.sub({}, ['k'])]),
                    ' je list. '
                ]
            },
        ],
        steps: [
            { // 0
                actions: [
                    a.addWhiteboard(
                        'whiteboard1',
                        { x: 0, y: 50 },
                        ['Pro každý graf ', bs.em({}, 'T '), '=', bs.em({}, ' (V, E)'), ' platí:'],
                        undefined,
                        undefined,
                        40,
                        0
                    ),
                    a.addWhiteboard(
                        'whiteboard1.2',
                        { x: 0, y: 100 },
                        [bs.strong({}, ['Jestliže'])],
                        undefined,
                        undefined,
                        40,
                        1500
                    ),
                    a.addWhiteboard(
                        'whiteboard1.21',
                        { x: 0, y: 150 },
                        [bs.em({}, 'T'), ' je netriviální strom, '],
                        undefined,
                        undefined,
                        40,
                        2250
                    ),
                    a.addWhiteboard(
                        'whiteboard1.3',
                        { x: 0, y: 200 },
                        [bs.strong({}, [' pak '])],
                        undefined,
                        undefined,
                        40,
                        3000
                    ),
                    a.addWhiteboard(
                        'whiteboard1.4',
                        { x: 0, y: 250 },
                        [bs.em({}, 'T'),
                            ' obsahuje list (resp. obsahuje alespoň dva listy).'],
                        undefined,
                        undefined,
                        40,
                        3700
                    ),
                ],
                sentence: {
                    text: [
                        bs.strong({}, 'Strom'), ' je souvislý graf, který neobsahuje kružnici. Značíme písmenem ',
                        bs.em({}, 'T'), ' (ze slova tree).',
                        bs.e({ tag: 'br' }),
                        bs.strong({}, 'Netriviální strom'), ' má alespoň dva vrcholy.',
                        bs.e({ tag: 'br' }),
                        bs.strong({}, 'List'), ' je vrchol stromu, který má stupeň 1 (vychází z něj jedna hrana).',
                    ]
                },
                time: 5000
            },
            { // 0
                actions: [
                    a.editWhiteboard(
                        'whiteboard1.21',
                        undefined,
                        [b.style(bs.element({ tag: 'span' }, [
                            bs.em({}, 'T'), ' je netriviální strom, ',
                        ]), { color: colors.redHighlight })],
                    ),
                    a.editWhiteboard(
                        'whiteboard1.4',
                        undefined,
                        [b.style(bs.element({ tag: 'span' }, [bs.em({}, 'T'),
                            ' obsahuje list (resp. obsahuje alespoň dva listy).',
                        ]), { color: colors.greenHighlight })],
                    ),
                    a.addHint(
                        'whiteboard2',
                        { x: 530, y: 175 },
                        ['Výrok ', bs.em({}, 'A')],
                        undefined,
                        colors.redHighlight,
                        1500
                    ),
                    a.addHint(
                        'whiteboard3',
                        { x: 530, y: 275 },
                        ['Výrok ', bs.em({}, 'B')],
                        undefined,
                        colors.greenHighlight,
                        3000
                    ),
                    a.addWhiteboard(
                        'whiteboard4',
                        { x: 210, y: 350 },
                        [bs.em({}, 'A')],
                        colors.redHighlight,
                        undefined,
                        40,
                        1500,
                        35
                    ),
                    a.addWhiteboard(
                        'whiteboard4.2',
                        { x: 320, y: 350 },
                        [bs.em({}, 'B')],
                        colors.greenHighlight,
                        undefined,
                        40,
                        3000,
                        35
                    ),
                    a.addWhiteboard(
                        'whiteboard4.3',
                        { x: 260, y: 350 },
                        ['\u21D2'],
                        colors.defaultBlack,
                        undefined,
                        40,
                        4000,
                        35
                    ),
                ],
                sentence: {
                    text: [
                        bs.strong({}, ['Implikace ',
                            bs.em({}, 'p '), '\u21D2', bs.em({}, ' q')]), ': jestliže platí výrok ',
                        bs.em({}, 'p'), ', pak platí výrok ',
                        bs.em({}, 'q'), '',
                    ]
                },
                time: 6000
            },
            { // 1
                actions: [
                    a.removeWhiteboard('whiteboard1'),
                    a.removeWhiteboard('whiteboard1.2'),
                    a.removeWhiteboard('whiteboard1.21'),
                    a.removeWhiteboard('whiteboard1.3'),
                    a.removeWhiteboard('whiteboard1.4'),
                    a.removeHint('whiteboard2'),
                    a.removeHint('whiteboard3'),
                    a.removeWhiteboard('whiteboard4'),
                    a.removeWhiteboard('whiteboard4.2'),
                    a.removeWhiteboard('whiteboard4.3'),
                    a.addCloud(),
                    a.addVertex('a', { x: 490, y: 80 }, 'a'),
                    a.addVertex('b', { x: 360, y: 170 }, 'b'),
                    a.addVertex('c', { x: 620, y: 180 }, 'c'),
                    a.addVertex('d', { x: 160, y: 390 }, 'd'),
                    a.addVertex('f', { x: 230, y: 280 }, 'f'),
                    a.addVertex('e', { x: 480, y: 270 }, 'e'),
                    a.addEdge('a-b', 'a', 'b'),
                    a.addEdge('a-c', 'a', 'c'),
                    a.addEdge('b-f', 'b', 'f'),
                    a.addEdge('f-d', 'f', 'd', undefined, undefined, undefined, true),
                    a.addEdge('b-e', 'b', 'e')
                ],
                sentence: {
                    text: [
                        bs.strong({}, 'Strom'), ' je souvislý graf, který neobsahuje kružnici.',
                        bs.e({ tag: 'br' }),
                        bs.strong({}, 'Souvislý graf'), ' je graf, ve kterém existuje mezi každými jeho dvěma vrcholy cesta. ',
                    ]
                },
                time: 500
            },
            { // 2
                actions: [
                    a.highlightVertex('c', undefined, colors.orangeHighlight),
                    a.highlightVertex('d', undefined, colors.orangeHighlight),
                    a.editVertex('c', undefined, undefined, undefined, undefined, colors.orangeHighlightLight, undefined),
                    a.editVertex('d', undefined, undefined, undefined, undefined, colors.orangeHighlightLight, undefined),
                ],
                sentence: {
                    text: [
                        bs.strong({}, 'Souvislý graf'), ' je graf, ve kterém existuje mezi každými jeho dvěma vrcholy cesta. ',
                        bs.e({ tag: 'br' }),
                        bs.strong({}, 'Cesta'), ' je sled s navzájem různými vrcholy, tj. pro ',
                        bs.em({}, 'i '), '\u2260', bs.em({}, ' j'), ' platí ',
                        bs.em({}, ['v', bs.sub({}, 'i'), ' ']), '\u2260', bs.em({}, [' v', bs.sub({}, 'j')]),
                        bs.e({ tag: 'br' }),
                        '\u2022 Hrany a vrcholy se ', bs.strong({}, 'nesmí'), ' opakovat'
                    ]
                },
                time: 600
            },
            { // 3
                actions: [
                    a.addHint('list-3', { x: 50, y: 50 }, [
                        'Cesta ',
                        bs.em({}, ['P', bs.sub({}, ['max']), ' ']), '=',
                        bs.em({}, [' (v',
                            bs.sub({}, ['0']), ', e', bs.sub({}, ['1']), ', v',
                            bs.sub({}, ['1']), ', ..., v', bs.sub({}, ['k']), ')'])
                    ], undefined, colors.orangeHighlight, 0),
                    a.editVertex('c', undefined, 'v0', undefined, undefined, colors.orangeHighlightLight, undefined),
                    a.editVertex('a', undefined, 'v1', undefined, undefined, colors.orangeHighlightLight, undefined, 2000),
                    a.editVertex('b', undefined, 'v2', undefined, undefined, colors.orangeHighlightLight, undefined, 3000),
                    a.editVertex('f', undefined, 'v3', undefined, undefined, colors.orangeHighlightLight, undefined, 4000),
                    a.editVertex('d', undefined, 'vk', undefined, undefined, colors.orangeHighlightLight, undefined, 5000),
                    a.highlightEdge('a-b', a.HighlightType.Full, undefined, colors.orangeHighlight, undefined, undefined, 2000),
                    a.highlightEdge('a-c', a.HighlightType.Full, undefined, colors.orangeHighlight, undefined, undefined, 1000),
                    a.highlightEdge('b-f', a.HighlightType.Full, undefined, colors.orangeHighlight, undefined, undefined, 3000),
                    a.highlightEdge('f-d', a.HighlightType.Full, undefined, colors.orangeHighlight, true, undefined, 4000),
                ],
                sentence: {
                    text: [
                        bs.strong({}, 'Cesta'), ' je sled s navzájem různými vrcholy, tj. pro ',
                        bs.em({}, 'i '), '\u2260', bs.em({}, ' j'), ' platí ',
                        bs.em({}, ['v', bs.sub({}, 'i'), ' ']), '\u2260',
                        bs.em({}, [' v', bs.sub({}, 'j')]),
                        bs.e({ tag: 'br' }),
                        '\u2022 Hrany a vrcholy se ', bs.strong({}, 'nesmí'), ' opakovat',
                        bs.e({ tag: 'br' }),
                        '\u2022 Maximální cesta je nejdelší cesta v grafu.'
                    ]
                },
                time: 7000
            },
            { // 4
                actions: [
                    a.removeHint('list-3'),
                    a.editVertex('d', undefined, undefined, undefined, undefined, colors.orangeHighlightLight),
                    a.editVertex('c', undefined, undefined, colors.blueHighlight, 7, colors.blueHighlightLight),
                ],
                sentence: {
                    text: [
                        bs.strong({}, 'List'), ' je vrchol stromu, který má stupeň 1 (vychází z něj jedna hrana).',
                        bs.e({ tag: 'br' }),
                        bs.strong({}, 'Důkaz sporem: '),
                        bs.e({ tag: 'br' }),
                        'Vytvoříme negaci věty, odvozujeme logické důsledky až dojdeme k výroku ',
                        bs.em({}, 'S'),
                        ', který je nepravdivý. Negace věty tedy neplatí, platí původní věta. ',
                    ]
                },
                time: 500
            },
            { // 6
                actions: [
                    a.addHint('list-6', { x: 90, y: 90 }, [
                        'Kružnice ',
                        bs.em({}, ['C = (v',
                            bs.sub({}, ['0']), ', v', bs.sub({}, ['1']), ', v, v', bs.sub({}, ['0']), ')'])
                    ], undefined, colors.greenHighlight, 0),
                    a.editVertex('b', undefined, 'v'),
                    a.addEdge('c-b', 'c', 'b'),
                    a.highlightEdge('c-b', a.HighlightType.Full, undefined, colors.greenHighlight),
                ],
                sentence: {
                    text: [
                        bs.strong({}, 'Kružnice (cyklus)'), ' v grafu G je posloupnost', bs.em({}, ['(v', bs.sub({}, '0'), ', e',
                            bs.sub({}, '1'), ', v', bs.sub({}, '1'), ', ..., e', bs.sub({}, 'k'), ', v', bs.sub({}, '0'), ')']),
                        ' kde ',
                        bs.em({}, ['e', bs.sub({}, 'i'), ' ']), '=',
                        bs.em({}, [' {v', bs.sub({}, 'i-1'), ', v', bs.sub({}, 'i'), '}, i ']), '=',
                        bs.em({}, ' 1,..., k'), '-',
                        bs.em({}, ['1; ' + 'e', bs.sub({}, 'k'), ' ']), '=',
                        bs.em({}, [' {v', bs.sub({}, 'k-1'), ', v', bs.sub({}, '0'), '}']),
                        bs.e({ tag: 'br' }),
                        '\u2022 První a poslední vrchol je stejný ',
                        bs.e({ tag: 'br' }),
                        bs.e({ tag: 'br' }),
                        ' Předpoklad: Strom je souvislý graf, který neobsahuje kružnici \u2192 spor',
                    ]
                },
                time: 2100
            },
            { // 7
                actions: [
                    a.removeHint('list-6'),
                    a.addHint('list-7', { x: 350, y: 350 }, [
                        'Cesta ',
                        bs.em({}, ['P', bs.sub({}, ['max']), ' ']), '=',
                        bs.em({}, [' (v',
                            bs.sub({}, ['0']), ', e', bs.sub({}, ['1']), ', v',
                            bs.sub({}, ['1']), ', ..., v', bs.sub({}, ['k']), ')']),
                        bs.e({ tag: 'br' }),
                        'Cesta P delší než ',
                        'Cesta ',
                        bs.em({}, ['P', bs.sub({}, ['max']), ' ']), '=',
                        bs.em({}, [' (v, v',
                            bs.sub({}, ['0']), ', e', bs.sub({}, ['1']), ', v',
                            bs.sub({}, ['1']), ', ..., v', bs.sub({}, ['k']), ')'])
                    ], undefined, colors.purpleHighlight, 0),
                    a.unHighlightEdge('c-b', a.HighlightType.Full),
                    a.removeEdge('c-b'),
                    a.addVertex('v', { x: 600, y: 300 }, 'v', undefined, undefined, colors.purpleHighlightLight),
                    a.addEdge('c-v', 'c', 'v'),
                    a.highlightEdge('c-v', a.HighlightType.Full, undefined, colors.purpleHighlight),
                ],
                sentence: {
                    text: [
                        bs.strong({}, 'Cesta'), ' je sled s navzájem různými vrcholy, tj. pro ',
                        bs.em({}, 'i '), '\u2260', bs.em({}, ' j'), ' platí ',
                        bs.em({}, ['v', bs.sub({}, 'i'), ' ']), '\u2260', bs.em({}, [' v', bs.sub({}, 'j')]),
                        bs.e({ tag: 'br' }),
                        '\u2022 Hrany a vrcholy se ', bs.strong({}, 'nesmí'), ' opakovat',
                        bs.e({ tag: 'br' }),
                        bs.e({ tag: 'br' }),
                        ' Předpoklad: ', bs.em({}, ['P', bs.sub({}, ['max'])]),
                        '   je cesta maximální délky \u2192 spor'
                    ]
                },
                time: 2574
            },
            {
                actions: [
                    a.removeHint('list-7'),
                    a.removeVertex('v'),
                    a.unHighlightEdge('c-v', a.HighlightType.Full),
                    a.removeEdge('c-v'),

                    a.unHighlightEdge('a-b', a.HighlightType.Full),
                    a.unHighlightEdge('a-c', a.HighlightType.Full),
                    a.unHighlightEdge('b-f', a.HighlightType.Full),
                    a.unHighlightEdge('f-d', a.HighlightType.Full),

                    a.editVertex('b', undefined, undefined, undefined, undefined, colors.defaultVertex),
                    a.editVertex('a', undefined, undefined, undefined, undefined, colors.defaultVertex),
                    a.editVertex('f', undefined, undefined, undefined, undefined, colors.defaultVertex),
                    a.editVertex('d', undefined, undefined, undefined, undefined, colors.blueHighlightLight),
                    a.highlightVertex('d', undefined, colors.blueHighlight)
                ],
                sentence: {
                    text: [
                        'Věta zároveň dokazuje, že i ',
                        bs.em({}, ['v', bs.sub({}, ['k'])]),
                        ' je list (vezmeme "druhý konec" cesty). Tedy můžeme říci, že každý netriviální strom má alespoň dva listy.'
                    ]
                },
                time: 600
            }
        ]
    }
];