import * as b from 'bobril';
import * as bs from 'bobrilstrap';
import * as a from '../../viewer/actions';
import * as colors from '../../common/colors';

export const examples = () => [
    {
        name: 'veta1',
        definitions: [
            {
                nesting: 0,
                color: colors.orangeHighlight,
                text: [
                    'Pro každý graf ',
                    bs.em({}, 'G'), '=', bs.em({}, '(V,E)'), ' platí: součet stupňů všech vrcholů ',
                    bs.em({}, 'v '), '\u2208', bs.em({}, 'V'), ' se rovná dvakrát počet hran ',
                    bs.em({}, 'E'), '. ',
                ]
            },
            {
                nesting: 0,
                color: colors.orangeHighlight,
                text: [
                    'Stupeň vrcholu určíme jako počet hran,',
                    ' které z něj vychází.'
                ]
            },
            {
                nesting: 0,
                color: colors.orangeHighlight,
                text: [
                    'Pro každý vrchol vyznačíme, jaké hrany z něj vychází. ',
                ]
            },
            {
                nesting: 0,
                color: colors.orangeHighlight,
                text: [
                    'Sečteme stupně všech vrcholů v grafu. Stupně "rozložíme" na hrany, které z daných vrcholů vychází. ',
                ]
            },
            {
                nesting: 0,
                color: colors.orangeHighlight,
                text: 'Každá hrana se v součtu stupňů vyskytuje dvakrát, protože má dva koncové vrcholy. '
            },
            {
                nesting: 0,
                color: colors.orangeHighlight,
                text: [
                    'Ověříme tak, že sečteme počet hran grafu. ',
                ]
            },
            {
                nesting: 0,
                color: colors.orangeHighlight,
                text: [
                    'Počet hran vynásobíme dvěma -',
                    ' vyjde součet stupňů všech vrcholů.'
                ]
            },
        ],
        steps: [
            {
                actions: [
                    a.addWhiteboard(
                        'whiteboard1',
                        { x: 212, y: 150 },
                        ['\u2211', bs.em({}, 'v '), '\u2208', bs.em({}, ['V deg', bs.sub({}, ['G']), '(v) ']), '=',
                            bs.em({}, ' 2 '), '\u22C5', bs.em({}, ' |E|')],
                        undefined,
                        undefined,
                        40,
                        0
                    ),
                    a.addWhiteboard(
                        'whiteboard1.2',
                        { x: 150, y: 200 },
                        [bs.em({}, 'deg v1 '), '+', bs.em({}, ' deg v2 '), '+', bs.em({}, ' ... '), '+',
                        bs.em({}, ' deg vn '), '=', bs.em({}, ' 2 '), '\u22C5', bs.em({}, ' |E|')],
                        undefined,
                        undefined,
                        40,
                        1500
                    ),
                ],
                sentence: {
                    text: [
                        bs.strong({}, 'Graf'), ' je definován množinou vrcholů ',
                        bs.em({}, ['V']), ' a hran ',
                        bs.em({}, ['E']), '. ',
                        bs.e({ tag: 'br' }),
                        'Symbol ',
                        bs.em({}, ['|E|']), ' znamená počet hran.'
                    ]
                },
                time: 1700
            },
            { // 0
                actions: [
                    a.addHint('stupen-vrcholu-1', { x: 280, y: 40 }, [
                        'Stupeň vrcholu ',
                        bs.em({}, ['y']), ' je:',
                        bs.e({ tag: 'br' }),
                        bs.em({}, 'deg(y) '), '=', bs.em({}, ' 3'),
                        bs.e({ tag: 'br' }),
                        'Po rozložení na hrany: ',
                        bs.e({ tag: 'br' }),
                        bs.em({}, 'deg(y) '), '=', bs.em({}, ' {c, y} '), '+', bs.em({}, ' {x, y} '), '+', bs.em({}, ' {y, z}'),
                    ], undefined, undefined, 0),
                    a.removeWhiteboard('whiteboard1'),
                    a.removeWhiteboard('whiteboard1.2'),
                    a.addVertex('x', { x: 250, y: 250 }, 'x'),
                    a.addVertex('y', { x: 500, y: 170 }, 'y'),
                    a.addVertex('z', { x: 600, y: 350 }, 'z'),
                    a.addVertex('a', { x: 150, y: 160 }, 'a'),
                    a.addVertex('b', { x: 420, y: 300 }, 'b'),
                    a.addVertex('c', { x: 640, y: 170 }, 'c'),
                    a.addEdge('y-x', 'y', 'x'),
                    a.addEdge('y-z', 'y', 'z'),
                    a.addEdge('a-x', 'a', 'x'),
                    a.addEdge('b-x', 'b', 'x'),
                    a.addEdge('c-y', 'c', 'y'),
                    a.addCloud(),
                    a.highlightVertex('y'),
                    a.highlightEdge('y-x', a.HighlightType.Start, undefined, colors.redHighlight),
                    a.highlightEdge('y-z', a.HighlightType.Start, undefined, colors.redHighlight),
                    a.highlightEdge('c-y', a.HighlightType.End, undefined, colors.redHighlight)
                ],
                sentence: {
                    text: [
                        bs.strong({}, 'Stupeň vrcholu'), ' se značí ',
                        bs.em({}, ['deg(v)']), ', protože pochází ze slova degree.',
                    ]
                },
                time: 500
            },
            { // 1
                actions: [
                    a.removeHint('stupen-vrcholu-1'),
                    a.addHint(
                        'soucet-hran-1',
                        { x: 50, y: 300 },
                        [
                            bs.em({}, ['deg(x)']), ' zahrnuje hrany ',
                            bs.em({}, ['{a, x}']), ', ',
                            bs.em({}, ['{b, x}']), ' a ',
                            bs.em({}, ['{x, y}'])
                        ],
                        undefined,
                        colors.orangeHighlight,
                        0),
                    a.unHighlightVertex('y'),
                    a.unHighlightEdge('y-x', a.HighlightType.Start),
                    a.unHighlightEdge('y-z', a.HighlightType.Start),
                    a.unHighlightEdge('c-y', a.HighlightType.End),
                    a.highlightEdge('y-x', a.HighlightType.Start, undefined, colors.redHighlight),
                    a.highlightEdge('y-x', a.HighlightType.End, undefined, colors.orangeHighlight),
                    a.highlightEdge('y-z', a.HighlightType.Start, undefined, colors.redHighlight),
                    a.highlightEdge('y-z', a.HighlightType.End, undefined, colors.greenHighlight),
                    a.highlightEdge('a-x', a.HighlightType.Start, undefined, colors.purpleHighlight),
                    a.highlightEdge('a-x', a.HighlightType.End, undefined, colors.orangeHighlight),
                    a.highlightEdge('b-x', a.HighlightType.Start, undefined, colors.pinkHighlight),
                    a.highlightEdge('b-x', a.HighlightType.End, undefined, colors.orangeHighlight),
                    a.highlightEdge('c-y', a.HighlightType.Start, undefined, colors.blueHighlight),
                    a.highlightEdge('c-y', a.HighlightType.End, undefined, colors.redHighlight)
                ],
                sentence: {
                    text: [
                        bs.em({}, [bs.strong({}, 'deg(x) ')]), '=',
                        bs.em({}, [' 3, ', bs.strong({}, 'deg(a) ')]), '=',
                        bs.em({}, [' 1, ', bs.strong({}, 'deg(b) ')]), '=',
                        bs.em({}, [' 1, ', bs.strong({}, 'deg(y) ')]), '=',
                        bs.em({}, [' 3, ', bs.strong({}, 'deg(z) ')]), '=',
                        bs.em({}, [' 1, ', bs.strong({}, 'deg(c) ')]), '=',
                        bs.em({}, [' 1'])
                    ]
                },
                time: 600
            },
            { // 2
                actions: [
                    a.removeHint('soucet-hran-1'),
                    a.unHighlightEdge('y-x', a.HighlightType.Start),
                    a.unHighlightEdge('y-x', a.HighlightType.End),
                    a.unHighlightEdge('y-z', a.HighlightType.Start),
                    a.unHighlightEdge('y-z', a.HighlightType.End),
                    a.unHighlightEdge('a-x', a.HighlightType.Start),
                    a.unHighlightEdge('a-x', a.HighlightType.End),
                    a.unHighlightEdge('b-x', a.HighlightType.Start),
                    a.unHighlightEdge('b-x', a.HighlightType.End),
                    a.unHighlightEdge('c-y', a.HighlightType.Start),
                    a.unHighlightEdge('c-y', a.HighlightType.End),
                    a.removeEdge('y-x'),
                    a.removeEdge('y-z'),
                    a.removeEdge('a-x'),
                    a.removeEdge('b-x'),
                    a.removeEdge('c-y'),
                    a.removeVertex('x'),
                    a.removeVertex('a'),
                    a.removeVertex('b'),
                    a.removeVertex('c'),
                    a.removeVertex('y'),
                    a.removeVertex('z'),
                    a.removeCloud(),
                    a.addWhiteboard(
                        'whiteboard3.1',
                        { x: 0, y: 150 },
                        [bs.em({}, [
                            b.style(bs.span({}, ['deg(a)']), { color: colors.purpleHighlight })])],
                        undefined,
                        undefined,
                        40,
                        0
                    ),
                    a.addWhiteboard(
                        'whiteboard3.2',
                        { x: 59, y: 150 },
                        [b.style(bs.span({}, ['+']), { color: colors.defaultBlack })],
                        undefined,
                        undefined,
                        40,
                        1000
                    ),
                    a.addWhiteboard(
                        'whiteboard3.3',
                        { x: 70, y: 150 },
                        [b.style(bs.span({}, ['deg(b)']), { color: colors.pinkHighlight })],
                        undefined,
                        undefined,
                        40,
                        1000
                    ),
                    a.addWhiteboard(
                        'whiteboard3.4',
                        { x: 127, y: 150 },
                        [b.style(bs.span({}, ['+']), { color: colors.defaultBlack })],
                        undefined,
                        undefined,
                        40,
                        2000
                    ),
                    a.addWhiteboard(
                        'whiteboard3.5',
                        { x: 140, y: 150 },
                        [b.style(bs.span({}, ['deg(c)']), { color: colors.blueHighlight })],
                        undefined,
                        undefined,
                        40,
                        2000
                    ),
                    a.addWhiteboard(
                        'whiteboard3.6',
                        { x: 210, y: 150 },
                        [b.style(bs.span({}, ['+']), { color: colors.defaultBlack })],
                        undefined,
                        undefined,
                        40,
                        3000
                    ),
                    a.addWhiteboard(
                        'whiteboard3.7',
                        { x: 230, y: 150 },
                        [b.style(bs.span({}, ['deg(x)']), { color: colors.orangeHighlight })],
                        undefined,
                        undefined,
                        40,
                        3000
                    ),
                    a.addWhiteboard(
                        'whiteboard3.8',
                        { x: 340, y: 150 },
                        [b.style(bs.span({}, ['+']), { color: colors.defaultBlack })],
                        undefined,
                        undefined,
                        40,
                        4000
                    ),
                    a.addWhiteboard(
                        'whiteboard3.9',
                        { x: 390, y: 150 },
                        [b.style(bs.span({}, ['deg(y)']), { color: colors.redHighlight })],
                        undefined,
                        undefined,
                        40,
                        4000
                    ),
                    a.addWhiteboard(
                        'whiteboard3.10',
                        { x: 455, y: 150 },
                        [b.style(bs.span({}, ['+']), { color: colors.defaultBlack })],
                        undefined,
                        undefined,
                        40,
                        5000
                    ),
                    a.addWhiteboard(
                        'whiteboard3.11',
                        { x: 475, y: 150 },
                        [bs.em({}, [
                            b.style(bs.span({}, ['deg(z)']), { color: colors.greenHighlight })])],
                        undefined,
                        undefined,
                        40,
                        5000
                    ),
                    a.addWhiteboard(
                        'whiteboard4.1',
                        { x: 0, y: 220 },
                        [b.style(bs.em({}, ['{a,x}']), { color: colors.purpleHighlight })], undefined, undefined, 40, 0
                    ),
                    a.addWhiteboard(
                        'whiteboard4.2',
                        { x: 44, y: 220 },
                        '+',
                        undefined, undefined,
                        40,
                        1000
                    ),
                    a.addWhiteboard(
                        'whiteboard4.3',
                        { x: 55, y: 220 },
                        [bs.em({}, [b.style(bs.em({}, ['{b,x}']), { color: colors.pinkHighlight })])],
                        undefined,
                        undefined,
                        40,
                        1000
                    ),
                    a.addWhiteboard(
                        'whiteboard4.4',
                        { x: 99, y: 220 },
                        '+',
                        undefined,
                        undefined,
                        40,
                        2000
                    ),
                    a.addWhiteboard(
                        'whiteboard4.5',
                        { x: 110, y: 220 },
                        [bs.em({}, [b.style(bs.em({}, ['{c,y}']), { color: colors.blueHighlight })])],
                        undefined,
                        undefined,
                        40,
                        2000
                    ),
                    a.addWhiteboard(
                        'whiteboard4.6',
                        { x: 154, y: 220 },
                        '+',
                        undefined,
                        undefined,
                        40,
                        3000
                    ),
                    a.addWhiteboard(
                        'whiteboard4.7',
                        { x: 165, y: 220 },
                        [bs.em({}, [b.style(bs.em({}, ['{a,x}']), { color: colors.orangeHighlight })])],
                        undefined,
                        undefined,
                        40,
                        3000
                    ),
                    a.addWhiteboard(
                        'whiteboard4.8',
                        { x: 209, y: 220 },
                        '+',
                        undefined,
                        undefined,
                        40,
                        3000
                    ),
                    a.addWhiteboard(
                        'whiteboard4.9',
                        { x: 220, y: 220 },
                        [bs.em({}, [b.style(bs.em({}, ['{b,x}']), { color: colors.orangeHighlight })])],
                        undefined,
                        undefined,
                        40,
                        3000
                    ),
                    a.addWhiteboard(
                        'whiteboard4.10',
                        { x: 264, y: 220 },
                        '+',
                        undefined,
                        undefined,
                        40,
                        3000
                    ),
                    a.addWhiteboard(
                        'whiteboard4.11',
                        { x: 275, y: 220 },
                        [bs.em({}, [b.style(bs.em({}, ['{x,y}']), { color: colors.orangeHighlight })])],
                        undefined,
                        undefined,
                        40,
                        3000
                    ),
                    a.addWhiteboard(
                        'whiteboard4.12',
                        { x: 317, y: 220 },
                        '+',
                        undefined,
                        undefined,
                        40,
                        4000
                    ),
                    a.addWhiteboard(
                        'whiteboard4.13',
                        { x: 330, y: 220 },
                        [bs.em({}, [b.style(bs.em({}, ['{x,y}']), { color: colors.redHighlight })])],
                        undefined,
                        undefined,
                        40,
                        4000
                    ),
                    a.addWhiteboard(
                        'whiteboard4.14',
                        { x: 372, y: 220 },
                        '+',
                        undefined,
                        undefined,
                        40,
                        4000
                    ),
                    a.addWhiteboard(
                        'whiteboard4.15',
                        { x: 385, y: 220 },
                        [bs.em({}, [b.style(bs.em({}, ['{y,z}']), { color: colors.redHighlight })])],
                        undefined,
                        undefined,
                        40,
                        4000
                    ),
                    a.addWhiteboard(
                        'whiteboard4.16',
                        { x: 427, y: 220 },
                        '+',
                        undefined,
                        undefined,
                        40,
                        4000
                    ),
                    a.addWhiteboard(
                        'whiteboard4.17',
                        { x: 440, y: 220 },
                        [bs.em({}, [b.style(bs.em({}, ['{c,y}']), { color: colors.redHighlight })])],
                        undefined,
                        undefined,
                        40,
                        4000
                    ),
                    a.addWhiteboard(
                        'whiteboard4.18',
                        { x: 482, y: 220 },
                        '+',
                        undefined,
                        undefined,
                        40,
                        5000
                    ),
                    a.addWhiteboard(
                        'whiteboard4.19',
                        { x: 495, y: 220 },
                        [bs.em({}, [b.style(bs.em({}, ['{y,z}']), { color: colors.greenHighlight })])],
                        undefined,
                        undefined,
                        40,
                        5000
                    ),
                ],
                sentence: {
                    text: [
                        bs.em({}, [
                            'deg(a) ']), '=', bs.em({}, [' 1, ',
                            'deg(b) ']), '=', bs.em({}, [' 1, ',
                            'deg(c) ']), '=', bs.em({}, [' 1, ',
                            'deg(x) ']), '=', bs.em({}, [' 3, ',
                            'deg(y) ']), '=', bs.em({}, [' 3, ',
                            'deg(z) ']), '=', bs.em({}, [' 1'
                        ]),
                        bs.e({ tag: 'br' }),
                        bs.strong({}, ['Součet stupňů: ']),
                        bs.em({}, '∑ v '), '∈', bs.em({}, ['V deg', bs.sub({}, ['G']), '(v) ']), '=', bs.em({}, ' 10')
                    ]
                },
                time: 6000
            },
            { // 2.5
                actions: [
                    a.editWhiteboard(
                        'whiteboard4.1',
                        undefined,
                        [
                            bs.underlined({}, [
                                bs.em({}, [
                                    b.style(bs.em({}, ['{a,x}']), { color: colors.purpleHighlight })
                                ])
                            ])
                        ]),

                    a.editWhiteboard(
                        'whiteboard4.7',
                        undefined,
                        [
                            bs.underlined({}, [
                                bs.em({}, [
                                    b.style(bs.em({}, ['{a,x}']), { color: colors.orangeHighlight })
                                ])
                            ])
                        ]),

                    a.addWhiteboard('whiteboard5.10', { x: 90, y: 290 }, [bs.em({}, [bs.em({}, ['2'])])], undefined, undefined, 40, 1000),
                    a.addWhiteboard('whiteboard5.11', { x: 110, y: 290 }, [bs.em({}, [bs.em({}, ['·'])])], undefined, undefined, 40, 1000),
                    a.addWhiteboard('whiteboard5.1', { x: 130, y: 290 }, [
                        bs.em({}, [bs.em({}, ['[{a,x}'])])], undefined, undefined, 40, 1000),
                    a.addWhiteboard('whiteboard5.2', { x: 180, y: 290 }, ['+'], undefined, undefined, 40, 1000),
                    a.addWhiteboard('whiteboard5.3', { x: 189, y: 290 }, [
                        bs.em({}, [bs.em({}, ['{b,x}'])])], undefined, undefined, 40, 1000),
                    a.addWhiteboard('whiteboard5.4', { x: 234, y: 290 }, ['+'], undefined, undefined, 40, 1000),
                    a.addWhiteboard('whiteboard5.5', { x: 246, y: 290 }, [
                        bs.em({}, [bs.em({}, ['{c,y}'])])], undefined, undefined, 40, 1000),
                    a.addWhiteboard('whiteboard5.6', { x: 286, y: 290 }, ['+'], undefined, undefined, 40, 1000),
                    a.addWhiteboard('whiteboard5.7', { x: 297, y: 290 }, [
                        bs.em({}, [bs.em({}, ['{x,y}'])])], undefined, undefined, 40, 1000),
                    a.addWhiteboard('whiteboard5.8', { x: 339, y: 290 }, ['+'], undefined, undefined, 40, 1000),
                    a.addWhiteboard('whiteboard5.9', { x: 352, y: 290 }, [
                        bs.em({}, [bs.em({}, ['{y,z}]'])])], undefined, undefined, 40, 1000),
                ],
                sentence: {
                    text: [
                        'Součet stupňů všech vrcholů = 2 · počet hran',
                        bs.e({ tag: 'br' }),
                        bs.em({}, '∑ v '), '∈', bs.em({}, ['V deg', bs.sub({}, ['G']), '(v) ']), '=', bs.em({}, ' 2 · |E|')
                    ]
                },
                time: 2000
            },
            { // 3
                actions: [

                    a.addHint('soucet-stupnu-vsech-vrcholu-1', { x: 250, y: 40 }, [
                        'Hran je pět.'
                    ], undefined, undefined, 0),
                    a.removeWhiteboard('whiteboard3.1'),
                    a.removeWhiteboard('whiteboard3.2'),
                    a.removeWhiteboard('whiteboard3.3'),
                    a.removeWhiteboard('whiteboard3.4'),
                    a.removeWhiteboard('whiteboard3.5'),
                    a.removeWhiteboard('whiteboard3.6'),
                    a.removeWhiteboard('whiteboard3.7'),
                    a.removeWhiteboard('whiteboard3.8'),
                    a.removeWhiteboard('whiteboard3.9'),
                    a.removeWhiteboard('whiteboard3.10'),
                    a.removeWhiteboard('whiteboard3.11'),
                    a.removeWhiteboard('whiteboard4.1'),
                    a.removeWhiteboard('whiteboard4.2'),
                    a.removeWhiteboard('whiteboard4.3'),
                    a.removeWhiteboard('whiteboard4.4'),
                    a.removeWhiteboard('whiteboard4.5'),
                    a.removeWhiteboard('whiteboard4.6'),
                    a.removeWhiteboard('whiteboard4.7'),
                    a.removeWhiteboard('whiteboard4.8'),
                    a.removeWhiteboard('whiteboard4.9'),
                    a.removeWhiteboard('whiteboard4.10'),
                    a.removeWhiteboard('whiteboard4.11'),
                    a.removeWhiteboard('whiteboard4.12'),
                    a.removeWhiteboard('whiteboard4.13'),
                    a.removeWhiteboard('whiteboard4.14'),
                    a.removeWhiteboard('whiteboard4.15'),
                    a.removeWhiteboard('whiteboard4.16'),
                    a.removeWhiteboard('whiteboard4.17'),
                    a.removeWhiteboard('whiteboard4.18'),
                    a.removeWhiteboard('whiteboard4.19'),
                    a.removeWhiteboard('whiteboard5.1'),
                    a.removeWhiteboard('whiteboard5.2'),
                    a.removeWhiteboard('whiteboard5.3'),
                    a.removeWhiteboard('whiteboard5.4'),
                    a.removeWhiteboard('whiteboard5.5'),
                    a.removeWhiteboard('whiteboard5.6'),
                    a.removeWhiteboard('whiteboard5.7'),
                    a.removeWhiteboard('whiteboard5.8'),
                    a.removeWhiteboard('whiteboard5.9'),
                    a.removeWhiteboard('whiteboard5.10'),
                    a.removeWhiteboard('whiteboard5.11'),
                    a.addVertex('x', { x: 250, y: 250 }, 'x'),
                    a.addVertex('y', { x: 500, y: 170 }, 'y'),
                    a.addVertex('z', { x: 600, y: 350 }, 'z'),
                    a.addVertex('a', { x: 150, y: 160 }, 'a'),
                    a.addVertex('b', { x: 420, y: 300 }, 'b'),
                    a.addVertex('c', { x: 640, y: 170 }, 'c'),
                    a.addEdge('y-x', 'y', 'x'),
                    a.addEdge('y-z', 'y', 'z'),
                    a.addEdge('a-x', 'a', 'x'),
                    a.addEdge('b-x', 'b', 'x'),
                    a.addEdge('c-y', 'c', 'y'),
                    a.addCloud(),
                    a.highlightEdge('y-x', a.HighlightType.Full, undefined, colors.redHighlight),
                    a.highlightEdge('y-z', a.HighlightType.Full, undefined, colors.greenHighlight),
                    a.highlightEdge('a-x', a.HighlightType.Full, undefined, colors.purpleHighlight),
                    a.highlightEdge('b-x', a.HighlightType.Full, undefined, colors.orangeHighlight),
                    a.highlightEdge('c-y', a.HighlightType.Full, undefined, colors.blueHighlight)
                ],
                sentence: {
                    text: [
                        'Počet hran: ',
                        bs.e({ tag: 'br' }),
                        bs.em({}, '{a, x} '), '+', bs.em({}, ' {b, x} '), '+',
                        bs.em({}, ' {c, y} '), '+', bs.em({}, ' {x, y} '), '+', bs.em({}, ' {y, z} '), '=', bs.em({}, ' 5'),
                        bs.e({ tag: 'br' }),
                        'V součtu stupňů je každá z těchto hran uvedena ', bs.strong({}, 'dvakrát. '),
                    ]
                },
                time: 500
            },
            { // 4
                actions: [
                    a.removeHint('soucet-stupnu-vsech-vrcholu-1'),
                    a.addHint('soucet-stupnu-vsech-vrcholu-2', { x: 270, y: 40 }, 'Součet stupňů všech vrcholů je deset.',
                        undefined, undefined, 0),
                    a.unHighlightEdge('y-x', a.HighlightType.Full),
                    a.unHighlightEdge('y-z', a.HighlightType.Full),
                    a.unHighlightEdge('a-x', a.HighlightType.Full),
                    a.unHighlightEdge('b-x', a.HighlightType.Full),
                    a.unHighlightEdge('c-y', a.HighlightType.Full),
                    a.highlightEdge('y-x', a.HighlightType.Both, undefined, colors.redHighlight),
                    a.highlightEdge('y-z', a.HighlightType.Both, undefined, colors.greenHighlight),
                    a.highlightEdge('a-x', a.HighlightType.Both, undefined, colors.purpleHighlight),
                    a.highlightEdge('b-x', a.HighlightType.Both, undefined, colors.orangeHighlight),
                    a.highlightEdge('c-y', a.HighlightType.Both, undefined, colors.blueHighlight)
                ],
                sentence: {
                    text: [
                        'Součet stupňů všech vrcholů = 2 · počet hran',
                        bs.e({ tag: 'br' }),
                        bs.em({}, '∑ v '), '∈', bs.em({}, ['V deg', bs.sub({}, ['G']), '(v) ']), '=', bs.em({}, ' 2 · |E|'),
                        bs.e({ tag: 'br' }),
                        '10 (součet stupňů) = 2 · 5 (počet hran)',
                    ]
                },
                time: 600
            },
        ]
    }
];