import * as b from 'bobril';
import * as bs from 'bobrilstrap';
import * as a from '../../viewer/actions';
import * as colors from '../../common/colors';

export const examples = () => [
    {
        name: 'veta2', definitions: [
            { // 0
                nesting: 0,
                color: colors.orangeHighlight,
                text: ['Věta: Graf ', bs.em({}, 'T'), ' je strom právě tehdy, když mezi jeho libovolnými dvěma vrcholy ', bs.em({}, 'x, y'),
                    ' existuje právě jedna cesta.']
            },
            { // 1
                nesting: 0,
                color: colors.orangeHighlight,
                text: [
                    'Rozdělení věty na dva výroky ',
                    bs.em({}, 'A'),
                    ' a ',
                    bs.em({}, 'B'),
                    ' spojené pomocí ekvivalence. '
                ]
            },
            { // 2
                nesting: 0,
                color: colors.orangeHighlight,
                text: 'Ekvivalenci dokážeme rozdělením na dvě implikace. '
            },
            { // 3
                nesting: 0,
                color: colors.greenHighlight,
                text: [
                    '1. implikace: Jestliže  ',
                    bs.em({}, 'T'),
                    ' je strom, pak mezi jeho libovolnými dvěma vrcholy ', bs.em({}, 'x, y'),
                    ' existuje právě jedna cesta.'
                ]
            },
            { // 4
                nesting: 1,
                color: colors.greenHighlightLight,
                text: [
                    'Dokážeme sporem: ',
                    bs.em({}, 'T'),
                    ' je strom a zároveň existuje alespoň jedna dvojice vrcholů ', bs.em({}, 'x, y'),
                    ', mezi kterými buď neexistuje cesta nebo existuje dvě a více cest.'
                ]
            },
            { // 5
                nesting: 1,
                color: colors.blueHighlight,
                text: [
                    'a. První možností je, že existuje alespoň jedna dvojice vrcholů, mezi kterými není cesta. Pak dle definice souvislosti není graf souvislý. To je dle definice stromu spor s předpokladem, že graf je strom.',
                ]
            },
            { // 6
                nesting: 1,
                color: colors.redHighlight,
                text: [
                    'b. Druhou možností je, že existuje alespoň jedna dvojice vrcholů, mezi kterými je více cest. ',
                ]
            },
            { // 7
                nesting: 2,
                color: colors.redHighlightLight,
                text: [
                    'Pak tyto cesty vytvoří kružnici. To je dle definice stromu spor s předpokladem, že graf je strom. Dokázali jsme první implikaci.',
                ]
            },
            { // 8
                nesting: 0,
                color: colors.purpleHighlight,
                text: [
                    '2. implikace: Jestliže mezi libovolnými dvěma vrcholy ', bs.em({}, 'x, y'),
                    ' existuje právě jedna cesta, pak graf ',
                    bs.em({}, 'T'),
                    ' je strom.'
                ]
            },
            { // 9
                nesting: 1,
                color: colors.purpleHighlightLight,
                text: [
                    'Když mezi dvěma libovolnými vrcholy existuje cesta, pak je graf souvislý (dle definice souvislosti). Abychom dokázali, že se jedná o strom, tak musíme ještě dokázat, že v grafu není kružnice (dle definice stromu). ',
                ]
            },
            { // 10
                nesting: 1,
                color: colors.purpleHighlightLight,
                text: [
                    'Dokážeme sporem: Mezi libovolnými dvěma vrcholy ', bs.em({}, 'x, y'),
                    ' existuje právě jedna cesta a zároveň graf obsahuje kružnici. ',
                ]
            },
            { // 11
                nesting: 1,
                color: colors.purpleHighlightLight,
                text: [
                    'Kružnici lze rozdělit na dvě cesty z ', bs.em({}, 'x'),
                    ' do ', bs.em({}, 'y'),
                    '. Došli jsme ke sporu s předpokladem, že mezi každými dvěma vrcholy v grafu existuje právě jedna cesta. Dokázali jsme druhou implikaci.',
                ]
            },
        ],
        steps: [
            { // 0
                actions: [
                    a.addWhiteboard(
                        'whiteboard1',
                        { x: 0, y: 50 },
                        ['Pro každý graf ', bs.em({}, 'T'), ' = ', bs.em({}, '(V, E)'), ' platí:'],
                        undefined,
                        undefined,
                        40,
                        0
                    ),
                    a.addWhiteboard(
                        'whiteboard1.2',
                        { x: 0, y: 110 },
                        ['Graf ', bs.em({}, 'T'), ' je strom '],
                        undefined,
                        undefined,
                        40,
                        1500
                    ),
                    a.addWhiteboard(
                        'whiteboard1.3',
                        { x: 0, y: 170 },
                        [bs.strong({}, [' právě tehdy, když '])],
                        undefined,
                        undefined,
                        40,
                        2250
                    ),
                    a.addWhiteboard(
                        'whiteboard1.4',
                        { x: 0, y: 230 },
                        [' mezi jeho libovolnými dvěma vrcholy ', bs.em({}, 'x, y'),
                            bs.element({ tag: 'br' }),
                            ' existuje právě jedna cesta.'],
                        undefined,
                        undefined,
                        40,
                        3000
                    ),
                ],
                sentence: {
                    text: [
                        bs.strong({}, 'Strom'), ' je souvislý graf, který neobsahuje kružnici. Značíme písmenem ',
                        bs.em({}, 'T'), ' (ze slova tree).',
                        bs.e({ tag: 'br' }),
                        bs.strong({}, 'Cesta'), ' je sled s navzájem různými vrcholy, tj. pro ',
                        bs.em({}, 'i'), ' \u2260 ', bs.em({}, 'j'),
                        ' platí ',
                        bs.em({}, ['v', bs.sub({}, 'i')]), ' \u2260 ', bs.em({}, ['v', bs.sub({}, 'j')]),
                        bs.e({ tag: 'br' }),
                        '\u2022 Hrany a vrcholy se ', bs.strong({}, 'nesmí'), ' opakovat',
                    ]
                },
                time: 5100
            },
            { // 1
                actions: [
                    a.editWhiteboard(
                        'whiteboard1.2',
                        undefined,
                        [b.style(bs.element({ tag: 'span' }, [
                            'Graf ', bs.em({}, 'T'), ' je strom ',
                        ]), { color: colors.redHighlight })],
                    ),
                    a.editWhiteboard(
                        'whiteboard1.4',
                        undefined,
                        [b.style(bs.element({ tag: 'span' }, [' mezi jeho libovolnými dvěma vrcholy ', bs.em({}, 'x, y'),
                            bs.element({ tag: 'br' }),
                            ' existuje právě jedna cesta.'
                        ]), { color: colors.greenHighlight })],
                    ),
                    a.addHint(
                        'whiteboard2',
                        { x: 530, y: 140 },
                        ['Výrok ', bs.em({}, 'A')],
                        undefined,
                        colors.redHighlight,
                        1500
                    ),
                    a.addHint(
                        'whiteboard3',
                        { x: 530, y: 255 },
                        ['Výrok ', bs.em({}, 'B')],
                        undefined,
                        colors.greenHighlight,
                        3000
                    ),
                    a.addWhiteboard(
                        'whiteboard4',
                        { x: 210, y: 350 },
                        [bs.em({}, 'A')],
                        colors.redHighlight,
                        undefined,
                        40,
                        1500,
                        35
                    ),
                    a.addWhiteboard(
                        'whiteboard4.2',
                        { x: 320, y: 350 },
                        [bs.em({}, 'B')],
                        colors.greenHighlight,
                        undefined,
                        40,
                        3000,
                        35
                    ),
                    a.addWhiteboard(
                        'whiteboard4.3',
                        { x: 260, y: 350 },
                        ['\u21D4'],
                        colors.defaultBlack,
                        undefined,
                        40,
                        4000,
                        35
                    )
                ],
                sentence: {
                    text: [
                        bs.strong({}, 'Výrok')
                        , ' je tvrzení, o kterém můžeme prohlásit, jestli je pravdivé nebo nepravdivé',
                        bs.e({ tag: 'br' }),
                        bs.strong({}, 'Složený výrok')
                        , ' vytvoříme složením výroků pomocí logických spojek (konjunkce, disjunkce, implikace, ekvivalence)',
                        bs.e({ tag: 'br' }),
                    ]
                },
                time: 6100
            },
            { // 2
                actions: [
                    a.removeWhiteboard('whiteboard1'),
                    a.removeWhiteboard('whiteboard1.2'),
                    a.removeWhiteboard('whiteboard1.3'),
                    a.removeWhiteboard('whiteboard1.4'),
                    a.removeHint('whiteboard2'),
                    a.removeHint('whiteboard3'),
                    a.removeWhiteboard('whiteboard4'),
                    a.removeWhiteboard('whiteboard4.2'),
                    a.removeWhiteboard('whiteboard4.3'),
                    a.addWhiteboard(
                        'whiteboard5',
                        { x: 240, y: 30 },
                        [bs.em({}, 'A'),
                            ' \u21D4 ',
                        bs.em({}, 'B')],
                        colors.orangeHighlight,
                        undefined,
                        40,
                        0,
                        30
                    ),
                    a.addWhiteboard(
                        'whiteboard6',
                        { x: 200, y: 120 },
                        ['1. implikace: ',
                            bs.em({}, 'A'),
                            ' \u21D2 ',
                            bs.em({}, 'B')],
                        colors.redHighlight,
                        undefined,
                        40,
                        1500
                    ),
                    a.addWhiteboard(
                        'whiteboard6.2',
                        { x: 10, y: 170 },
                        ['Jestliže  ',
                            bs.em({}, 'T'),
                            ' je strom, pak mezi jeho libovolnými dvěma vrcholy ', bs.em({}, 'x, y'),
                            ' existuje právě jedna cesta.'],
                        colors.defaultBlack,
                        undefined,
                        40,
                        1500
                    ),
                    a.addWhiteboard(
                        'whiteboard7',
                        { x: 200, y: 280 },
                        ['2. implikace: ', bs.em({}, 'B '), '\u21D2', bs.em({}, ' A')],
                        colors.greenHighlight,
                        undefined,
                        40,
                        3000
                    ),
                    a.addWhiteboard(
                        'whiteboard7.2',
                        { x: 10, y: 330 },
                        ['Jestliže mezi libovolnými dvěma vrcholy ', bs.em({}, 'x, y'),
                            ' existuje právě jedna cesta, pak graf ',
                            bs.em({}, 'T'),
                            ' je strom.'],
                        colors.defaultBlack,
                        undefined,
                        40,
                        3000
                    ),
                ],
                sentence: {
                    text: [
                        bs.strong({}, ['Implikace ',
                            bs.em({}, 'p'), ' \u21D2 ', bs.em({}, 'q')]), ': jestliže platí výrok ',
                        bs.em({}, 'p'), ', pak platí výrok ',
                        bs.em({}, 'q'),
                        bs.e({ tag: 'br' }),
                        bs.strong({}, ['Ekvivalence ',
                            bs.em({}, 'p'), ' \u21D4 ', bs.em({}, 'q')]), ': výrok ',
                        bs.em({}, 'p'), ' platí právě tehdy, když platí výrok ',
                        bs.em({}, 'q'),
                        bs.e({ tag: 'br' }),
                        'Ekvivalenci rozdělíme na dvě implikace, které dokážeme zvlášť. '
                    ]
                },
                time: 5376
            },
            { // 3
                actions: [
                    a.addHint('dukaz-1', { x: 200, y: 20 }, [
                        'Například mezi ', bs.em({}, 'x'),
                        ' a ', bs.em({}, 'y'),
                        ' je cesta ', bs.em({}, 'C'),
                        ' = ', bs.em({}, '(x, c, d, y)'),
                    ], undefined, colors.greenHighlight, 0),

                    a.removeWhiteboard('whiteboard5'),
                    a.removeWhiteboard('whiteboard6'),
                    a.removeWhiteboard('whiteboard6.2'),
                    a.removeWhiteboard('whiteboard7.2'),
                    a.removeWhiteboard('whiteboard7'),

                    a.addCloud(),

                    a.addVertex('a', { x: 200, y: 390 }, 'a'),
                    a.addVertex('b', { x: 190, y: 220 }, 'x', colors.greenHighlight, 7, colors.greenHighlightLight),
                    a.addVertex('c', { x: 290, y: 120 }, 'c'),
                    a.addVertex('h', { x: 410, y: 270 }, 'h'),
                    a.addVertex('g', { x: 490, y: 130 }, 'y', colors.greenHighlight, 7, colors.greenHighlightLight),
                    a.addVertex('e', { x: 350, y: 300 }, 'e'),
                    a.addVertex('i', { x: 160, y: 107 }, 'i'),
                    a.addVertex('d', { x: 420, y: 170 }, 'd'),
                    a.addVertex('f', { x: 300, y: 250 }, 'f'),

                    a.addEdge('a-b', 'a', 'b'),
                    a.addEdge('d-e', 'd', 'e'),
                    a.addEdge('e-f', 'e', 'f'),
                    a.addEdge('d-g', 'd', 'g'),
                    a.addEdge('b-c', 'b', 'c'),
                    a.addEdge('c-d', 'c', 'd'),
                    a.addEdge('e-h', 'e', 'h'),
                    a.addEdge('b-i', 'b', 'i')
                ],
                sentence: {
                    text: [
                        bs.strong({}, 'Strom'), ' je souvislý graf, který neobsahuje kružnici. Značíme písmenem ',
                        bs.em({}, 'T'), ' (ze slova tree).',
                        bs.e({ tag: 'br' }),
                        bs.strong({}, 'Cesta'), ' je sled s navzájem různými vrcholy, tj. pro ',
                        bs.em({}, 'i'), ' \u2260 ', bs.em({}, 'j'),
                        ' platí ',
                        bs.em({}, ['v', bs.sub({}, 'i')]), ' \u2260 ', bs.em({}, ['v', bs.sub({}, 'j')]),
                        bs.e({ tag: 'br' }),
                        '\u2022 Hrany a vrcholy se ', bs.strong({}, 'nesmí'), ' opakovat',
                    ]
                },
                time: 500
            },
            { // 4
                actions: [
                    a.removeHint('dukaz-1'),
                    a.addHint('dukaz-2', { x: 200, y: 20 }, [
                        'Pro důkaz sporem předpokládáme, ',
                        bs.e({ tag: 'br' }),
                        'že tento graf je strom. ',
                    ], undefined, colors.greenHighlight, 0),

                    a.addVertex('j', { x: 520, y: 360 }, 'j'),
                    a.addVertex('l', { x: 580, y: 370 }, 'l'),
                    a.addVertex('k', { x: 560, y: 300 }, 'k'),

                    a.editVertex('b', undefined, 'b', colors.defaultBlack, 3, colors.defaultVertex),
                    a.editVertex('g', undefined, 'g', colors.defaultBlack, 3, colors.defaultVertex),

                    a.addEdge('j-l', 'j', 'l'),
                    a.addEdge('k-l', 'k', 'l'),
                    a.addEdge('a-f', 'a', 'f')
                ],
                sentence: {
                    text: [
                        bs.strong({}, 'Důkaz sporem: '),
                        bs.e({ tag: 'br' }),
                        'Vytvoříme negaci věty, odvozujeme logické důsledky až dojdeme k výroku ',
                        bs.em({}, ['S']), ', který je nepravdivý. Negace věty tedy neplatí, platí původní věta. ',
                        bs.e({ tag: 'br' }),
                        'Věta: ',
                        bs.em({}, 'A'), ' \u21D2 ', bs.em({}, 'B'),
                        ', negace: ',
                        bs.em({}, 'A'), ' \u2227 ', bs.em({}, 'B\u2032')
                    ]
                },
                time: 600
            },
            { // 5
                actions: [
                    a.removeHint('dukaz-2'),
                    a.addHint('dukaz-3', { x: 370, y: 200 }, [
                        'Mezi ',
                        bs.em({}, 'x'),
                        ' a ',
                        bs.em({}, 'y'),
                        ' není v grafu žádná cesta. ',
                    ], undefined, colors.blueHighlight, 0),

                    a.editVertex('h', undefined, 'x', colors.blueHighlight, 7, colors.blueHighlightLight),
                    a.editVertex('j', undefined, 'y', colors.blueHighlight, 7, colors.blueHighlightLight),
                ],
                sentence: {
                    text: [
                        bs.strong({}, 'Strom'), ' je souvislý graf, který neobsahuje kružnici. Značíme písmenem ',
                        bs.em({}, 'T'), ' (ze slova tree).',
                        bs.e({ tag: 'br' }),
                        bs.strong({}, 'Souvislý graf'), ' je graf, ve kterém existuje mezi každými jeho dvěma vrcholy cesta. ',
                    ]
                },
                time: 500
            },
            { // 6
                actions: [
                    a.removeHint('dukaz-3'),
                    a.addHint('dukaz-4', { x: 200, y: 20 }, [
                        'Mezi ',
                        bs.em({}, 'x'),
                        ' a ',
                        bs.em({}, 'y'),
                        ' jsou v grafu dvě možné cesty. ',
                        bs.e({ tag: 'br' }),
                        bs.em({}, ['P', bs.sub({}, '1')]), ' = ', bs.em({}, ['(x, c, y)']),
                        bs.e({ tag: 'br' }),
                        bs.em({}, ['P', bs.sub({}, '2')]), ' = ', bs.em({}, ['(x, a, f, e, y)']),
                    ], undefined, colors.redHighlight, 0),

                    a.editVertex('h', undefined, 'h', colors.defaultBlack, 3, colors.defaultVertex),
                    a.editVertex('j', undefined, 'j', colors.defaultBlack, 3, colors.defaultVertex),
                    a.editVertex('b', undefined, 'x', colors.redHighlight, 7, colors.redHighlightLight),
                    a.editVertex('d', undefined, 'y', colors.redHighlight, 7, colors.redHighlightLight),

                    a.highlightEdge('b-c', a.HighlightType.Full, undefined, colors.pinkHighlight, undefined, undefined, 1000, 'b-c-green'),
                    a.highlightEdge('c-d', a.HighlightType.Full, undefined, colors.pinkHighlight, undefined, undefined, 2000, 'c-d-green'),

                    a.highlightEdge('a-b', a.HighlightType.Full, undefined, colors.blueHighlight, undefined, undefined, 4000, 'a-b-blue'),
                    a.highlightEdge('a-f', a.HighlightType.Full, undefined, colors.blueHighlight, undefined, undefined, 5000, 'a-f-blue'),
                    a.highlightEdge('e-f', a.HighlightType.Full, undefined, colors.blueHighlight, undefined, undefined, 6000, 'e-f-blue'),
                    a.highlightEdge('d-e', a.HighlightType.Full, undefined, colors.blueHighlight, undefined, undefined, 7000, 'd-e-blue'),

                    a.editVertex('c', undefined, undefined, undefined, undefined, colors.pinkHighlightLight, undefined, 2000),
                    a.editVertex('a', undefined, undefined, undefined, undefined, colors.blueHighlightLight, undefined, 5000),
                    a.editVertex('f', undefined, undefined, undefined, undefined, colors.blueHighlightLight, undefined, 6000),
                    a.editVertex('e', undefined, undefined, undefined, undefined, colors.blueHighlightLight, undefined, 7000),
                ],
                sentence: {
                    text: [
                        bs.strong({}, 'Cesta'), ' je sled s navzájem různými vrcholy, tj. pro ',
                        bs.em({}, 'i'), ' \u2260 ', bs.em({}, 'j'),
                        ' platí ',
                        bs.em({}, ['v', bs.sub({}, 'i')]), ' \u2260 ', bs.em({}, ['v', bs.sub({}, 'j')]),
                        bs.e({ tag: 'br' }),
                        '\u2022 Hrany a vrcholy se ', bs.strong({}, 'nesmí'), ' opakovat',
                    ]
                },
                time: 9300
            },
            { // 7
                actions: [
                    a.removeHint('dukaz-4'),
                    a.addHint('dukaz-5', { x: 200, y: 20 }, [
                        'Cesty vytvoří kružnici: ',
                        bs.e({ tag: 'br' }),
                        bs.em({}, ['C']), ' = ', bs.em({}, ['(x, c, y, e, f, a, x)']),
                    ], undefined, colors.redHighlight, 0),

                    a.highlightEdge('b-c', a.HighlightType.Full, undefined, colors.redHighlight, undefined, undefined, 1000, 'b-c-red', 80),
                    a.highlightEdge('c-d', a.HighlightType.Full, undefined, colors.redHighlight, undefined, undefined, 2000, 'c-d-red', 80),

                    a.highlightEdge('a-b', a.HighlightType.Full, undefined, colors.redHighlight, undefined, undefined, 7000, 'a-b-red', 80),
                    a.highlightEdge('a-f', a.HighlightType.Full, undefined, colors.redHighlight, undefined, undefined, 6000, 'a-f-red', 80),
                    a.highlightEdge('e-f', a.HighlightType.Full, undefined, colors.redHighlight, undefined, undefined, 5000, 'e-f-red', 80),
                    a.highlightEdge('d-e', a.HighlightType.Full, undefined, colors.redHighlight, undefined, undefined, 4000, 'd-e-red', 80),

                    a.editVertex('c', undefined, undefined, undefined, undefined, colors.redHighlightLight, undefined, 2000),
                    a.editVertex('a', undefined, undefined, undefined, undefined, colors.redHighlightLight, undefined, 7000),
                    a.editVertex('f', undefined, undefined, undefined, undefined, colors.redHighlightLight, undefined, 6000),
                    a.editVertex('e', undefined, undefined, undefined, undefined, colors.redHighlightLight, undefined, 5000),
                ],
                sentence: {
                    text: [
                        bs.strong({}, 'Kružnice (cyklus)'), ' v grafu ',
                        bs.em({}, 'G'),
                        ' je posloupnost',
                        bs.em({}, [
                            '(v',
                            bs.sub({}, '0'), ', e',
                            bs.sub({}, '1'), ', v',
                            bs.sub({}, '1'), ', ..., e',
                            bs.sub({}, 'k'), ', v',
                            bs.sub({}, '0'), ')'
                        ]),
                        ' kde ',
                        bs.em({}, ['e', bs.sub({}, 'i')]), ' = ', bs.em({}, ['{v', bs.sub({}, 'i-1'), ', v', bs.sub({}, 'i'), '}, i']),
                        ' = ', bs.em({}, ['1,..., k-1; ']),
                        bs.em({}, ['e', bs.sub({}, 'k')]), ' = ', bs.em({}, ['{v', bs.sub({}, 'k-1'), ', v', bs.sub({}, '0'), '}']),
                        bs.e({ tag: 'br' }),
                        '\u2022 První a poslední vrchol je stejný ',
                        bs.e({ tag: 'br' }),
                        '\u2022 Hrany a vrcholy od ',
                        bs.em({}, ['v', bs.sub({}, '0')]), ' do ',
                        bs.em({}, ['v', bs.sub({}, 'k-1')])
                        , ' se ',
                        bs.strong({}, 'nesmí'),
                        ' opakovat',
                        bs.e({ tag: 'br' }),
                        bs.strong({}, 'Strom'), ' je souvislý graf, který neobsahuje kružnici.',
                    ]
                },
                time: 9200
            },
            { // 8
                actions: [
                    a.removeHint('dukaz-5'),

                    a.unHighlightEdge('b-c-red', a.HighlightType.Full),
                    a.unHighlightEdge('c-d-red', a.HighlightType.Full),

                    a.unHighlightEdge('b-c-green', a.HighlightType.Full),
                    a.unHighlightEdge('c-d-green', a.HighlightType.Full),

                    a.unHighlightEdge('a-b-red', a.HighlightType.Full),
                    a.unHighlightEdge('a-f-red', a.HighlightType.Full),
                    a.unHighlightEdge('e-f-red', a.HighlightType.Full),
                    a.unHighlightEdge('d-e-red', a.HighlightType.Full),

                    a.unHighlightEdge('a-b-blue', a.HighlightType.Full),
                    a.unHighlightEdge('a-f-blue', a.HighlightType.Full),
                    a.unHighlightEdge('e-f-blue', a.HighlightType.Full),
                    a.unHighlightEdge('d-e-blue', a.HighlightType.Full),

                    a.editVertex('c', undefined, 'x', colors.purpleHighlight, 7, colors.purpleHighlightLight),
                    a.editVertex('a', undefined, undefined, colors.defaultBlack, 3, colors.defaultVertex),
                    a.editVertex('f', undefined, undefined, colors.defaultBlack, 3, colors.defaultVertex),
                    a.editVertex('b', undefined, 'b', colors.defaultBlack, 3, colors.defaultVertex),
                    a.editVertex('d', undefined, undefined, colors.purpleHighlight, 7, colors.purpleHighlightLight),
                    a.editVertex('e', undefined, undefined, colors.defaultBlack, 3, colors.defaultVertex),
                    a.editVertex('h', undefined, undefined, colors.defaultBlack, 3, colors.defaultVertex),
                    a.editVertex('j', undefined, undefined, colors.defaultBlack, 3, colors.defaultVertex),

                    a.removeEdge('a-f'),
                    a.removeEdge('e-f'),
                    a.addEdge('c-f', 'c', 'f'),

                    a.removeVertex('j'),
                    a.removeVertex('k'),
                    a.removeVertex('l'),
                    a.removeEdge('j-l'),
                    a.removeEdge('k-l')
                ],
                sentence: {
                    text: [
                        bs.strong({}, 'Cesta'), ' je sled s navzájem různými vrcholy, tj. pro ',
                        bs.em({}, 'i'), ' \u2260 ', bs.em({}, 'j'),
                        ' platí ',
                        bs.em({}, ['v', bs.sub({}, 'i')]), ' \u2260 ', bs.em({}, ['v', bs.sub({}, 'j')]),
                        bs.e({ tag: 'br' }),
                        '\u2022 Hrany a vrcholy se ', bs.strong({}, 'nesmí'), ' opakovat',
                        bs.e({ tag: 'br' }),
                        bs.strong({}, 'Strom'), ' je souvislý graf, který neobsahuje kružnici.',
                    ]
                },
                time: 600
            },
            { // 9
                actions: [
                    a.addHint('dukaz-6', { x: 200, y: 20 }, [
                        'Mezi vrcholy ',
                        bs.em({}, ['x']),
                        ' a ',
                        bs.em({}, ['y']),
                        ' existuje cesta ',
                        bs.em({}, ['P']), ' = ', bs.em({}, ['(x, y)']),
                    ], undefined, colors.purpleHighlight, 0),

                    a.highlightEdge('c-d', a.HighlightType.Full, undefined, colors.purpleHighlight,
                        undefined, undefined, 1000, 'c-d-purple'),
                ],
                sentence: {
                    text: [
                        bs.strong({}, 'Souvislý graf'), ' je graf, ve kterém existuje mezi každými jeho dvěma vrcholy cesta. ',
                        bs.e({ tag: 'br' }),
                        bs.strong({}, 'Strom'), ' je souvislý graf, který neobsahuje kružnici.',
                    ]
                },
                time: 3100
            },
            { // 10
                actions: [
                    a.removeHint('dukaz-6'),
                    a.addHint('dukaz-7', { x: 200, y: 20 }, [
                        'Graf obsahuje kružnici: ',
                        bs.e({ tag: 'br' }),
                        bs.em({}, ['C']), ' = ', bs.em({}, ['(x, y, e, f, x)']),
                    ], undefined, colors.purpleHighlight, 0),

                    a.addEdge('e-f', 'e', 'f'),
                    a.highlightEdge('e-f', a.HighlightType.Full, undefined, colors.purpleHighlight,
                        undefined, undefined, 2000, 'e-f-purple'),
                    a.highlightEdge('d-e', a.HighlightType.Full, undefined, colors.purpleHighlight,
                        undefined, undefined, 1000, 'd-e-purple'),
                    a.highlightEdge('c-f', a.HighlightType.Full, undefined, colors.purpleHighlight,
                        undefined, undefined, 3000, 'c-f-purple'),

                    a.editVertex('f', undefined, undefined, undefined, undefined, colors.purpleHighlightLight, undefined, 3000),
                    a.editVertex('e', undefined, undefined, undefined, undefined, colors.purpleHighlightLight, undefined, 2000),
                ],
                sentence: {
                    text: [
                        bs.strong({}, 'Důkaz sporem: '),
                        bs.e({ tag: 'br' }),
                        'Vytvoříme negaci věty, odvozujeme logické důsledky až dojdeme k výroku ',
                        bs.em({}, ['S']), ', který je nepravdivý. Negace věty tedy neplatí, platí původní věta. ',
                        bs.e({ tag: 'br' }),
                        'Věta: ',
                        bs.em({}, 'A'), ' \u21D2 ', bs.em({}, 'B'),
                        ', negace: ',
                        bs.em({}, 'A'), ' \u2227 ', bs.em({}, 'B\u2032')
                    ]
                },
                time: 5100
            },
            { // 11
                actions: [
                    a.removeHint('dukaz-7'),
                    a.addHint('dukaz-8', { x: 200, y: 20 }, [
                        'Kružnici ',
                        bs.em({}, ['C']), ' = ', bs.em({}, ['(x, y, e, f, x)']),
                        bs.e({ tag: 'br' }),
                        'lze rozdělit na cestu ',
                        bs.em({}, ['P', bs.sub({}, '1')]), ' = ', bs.em({}, ['(x, y)']),
                        bs.e({ tag: 'br' }),
                        'a cestu ',
                        bs.em({}, ['P', bs.sub({}, '2')]), ' = ', bs.em({}, ['(x, f, e, y)']),
                    ], undefined, colors.purpleHighlight, 0),

                    a.highlightEdge('e-f', a.HighlightType.Full, undefined, colors.orangeHighlight,
                        undefined, undefined, 2000, 'e-f-orange', 80),
                    a.highlightEdge('d-e', a.HighlightType.Full, undefined, colors.orangeHighlight,
                        undefined, undefined, 3000, 'd-e-orange', 80),
                    a.highlightEdge('c-f', a.HighlightType.Full, undefined, colors.orangeHighlight,
                        undefined, undefined, 1000, 'c-f-orange', 80),
                    a.editVertex('f', undefined, undefined, undefined, undefined, colors.orangeHighlightLight, undefined, 2000),
                    a.editVertex('e', undefined, undefined, undefined, undefined, colors.orangeHighlightLight, undefined, 3000),
                ],
                sentence: {
                    text: [
                        bs.strong({}, 'Kružnice (cyklus)'), ' v grafu ',
                        bs.em({}, 'G'),
                        ' je posloupnost',
                        bs.em({}, [
                            '(v',
                            bs.sub({}, '0'), ', e',
                            bs.sub({}, '1'), ', v',
                            bs.sub({}, '1'), ', ..., e',
                            bs.sub({}, 'k'), ', v',
                            bs.sub({}, '0'), ')'
                        ]),
                        ' kde ',
                        bs.em({}, ['e', bs.sub({}, 'i')]), ' = ', bs.em({}, ['{v', bs.sub({}, 'i-1'), ', v', bs.sub({}, 'i'), '}, i']),
                        ' = ', bs.em({}, ['1,..., k-1; ']),
                        bs.em({}, ['e', bs.sub({}, 'k')]), ' = ', bs.em({}, ['{v', bs.sub({}, 'k-1'), ', v', bs.sub({}, '0'), '}']),
                        bs.e({ tag: 'br' }),
                        bs.strong({}, 'Cesta'), ' je sled s navzájem různými vrcholy, tj. pro ',
                        bs.em({}, 'i'), ' \u2260 ', bs.em({}, 'j'),
                        ' platí ',
                        bs.em({}, ['v', bs.sub({}, 'i')]), ' \u2260 ', bs.em({}, ['v', bs.sub({}, 'j'),
                        ]),
                    ]
                },
                time: 6500
            }
        ]
    }
];