import * as b from 'bobril';
import * as bs from 'bobrilstrap';
import * as a from '../../viewer/actions';
import * as colors from '../../common/colors';

export const examples = () => [
    {
        name: 'veta3', definitions: [
            { // 0
                nesting: 0,
                color: colors.orangeHighlight,
                text: ['Věta: Graf ',
                    bs.em({}, 'T'), ' je strom právě tehdy, když je souvislý a každá jeho hrana je most.']
            },
            { // 1
                nesting: 0,
                color: colors.orangeHighlight,
                text: [
                    'Rozdělení věty na dva výroky ',
                    bs.em({}, 'A'),
                    ' a ',
                    bs.em({}, 'B'),
                    ' spojené pomocí ekvivalence. '
                ]
            },
            { // 2
                nesting: 0,
                color: colors.orangeHighlight,
                text: 'Ekvivalenci dokážeme rozdělením na dvě implikace. '
            },
            { // 3
                nesting: 0,
                color: colors.greenHighlight,
                text: [
                    '1. implikace: Jestliže  ',
                    bs.em({}, 'T'), ' je strom, pak je souvislý a každá jeho hrana je most.'
                ]
            },
            { // 4
                nesting: 1,
                color: colors.greenHighlightLight,
                text: [
                    'Podle definice stromu už víme, že strom je souvislý graf. Stačí dokázat, že každá hrana grafu je most.',
                ]
            },
            { // 5
                nesting: 1,
                color: colors.greenHighlightLight,
                text: [
                    'Dokážeme sporem: ',
                    bs.em({}, 'T'),
                    ' je strom a zároveň existuje hrana ',
                    bs.em({}, 'e'),
                    ' =  ',
                    bs.em({}, '{v, w}'),
                    ', která není most.'
                ]
            },
            { // 6
                nesting: 1,
                color: colors.greenHighlightLight,
                text: [
                    'Když hrana ',
                    bs.em({}, 'e'),
                    ' není most, tak ji můžeme odebrat a graf ',
                    bs.em({}, 'T '), '-', bs.em({}, ' e'),
                    ' bude stále souvislý (dle definice mostu). Podle definice souvislosti v něm existuje mezi vrcholy ',
                    bs.em({}, 'v, w'),
                    ' cesta.',
                ]
            },
            { // 7
                nesting: 1,
                color: colors.greenHighlightLight,
                text: [
                    'Ta je cestou mezi vrcholy ',
                    bs.em({}, 'v, w'),
                    ' i v původním grafu ',
                    bs.em({}, 'T'),
                    '.',
                ]
            },
            { // 8
                nesting: 1,
                color: colors.greenHighlightLight,
                text: [
                    'Spolu s hranou ',
                    bs.em({}, 'e'),
                    ' tvoří v původním grafu kružnici. To je spor s předpokladem, že ',
                    bs.em({}, 'T'),
                    ' je strom. Dokázali jsme první implikaci. ',
                ]
            },
            { // 9
                nesting: 0,
                color: colors.purpleHighlight,
                text: [
                    '2. implikace: Jestliže graf  ',
                    bs.em({}, 'T'), ' je souvislý a každá jeho hrana je most, pak je ',
                    bs.em({}, 'T'), ' strom.'
                ]
            },
            { // 10
                nesting: 1,
                color: colors.purpleHighlightLight,
                text: [
                    'Dokážeme sporem: Existuje souvislý graf ',
                    bs.em({}, 'T'),
                    ', jehož každá hrana je most a zároveň ',
                    bs.em({}, 'T'),
                    ' není strom. Pokud graf není stromem, pak je (dle definice stromu) nesouvislý nebo obsahuje alespoň jednu kružnici ',
                    bs.em({}, 'C'),
                    '.',
                ]
            },
            { // 11
                nesting: 1,
                color: colors.blueHighlight,
                text: [
                    'a. Graf je nesouvislý. Došli jsme ke sporu s předpokladem, že graf je souvislý.',
                ]
            },
            { // 12
                nesting: 1,
                color: colors.redHighlight,
                text: [
                    'b. Graf obsahuje kružnici.'
                ]
            },
            { // 13
                nesting: 2,
                color: colors.redHighlightLight,
                text: [
                    'Odebereme libovolnou hranu ',
                    bs.em({}, 'e'),
                    ' ležící na kružnici ',
                    bs.em({}, 'C'),
                    '. Dle tvrzení 2 získáme opět souvislý graf. To je spor s přepokladem, že každá hrana grafu je most. Dokázali jsme druhou implikaci.',
                ]
            },
        ],
        steps: [
            { // 0
                actions: [
                    a.addWhiteboard(
                        'whiteboard1',
                        { x: 0, y: 50 },
                        ['Pro každý graf ', bs.em({}, 'T'), ' = ', bs.em({}, '(V, E)'), ' platí:'],
                        undefined,
                        undefined,
                        40,
                        0
                    ),
                    a.addWhiteboard(
                        'whiteboard1.2',
                        { x: 0, y: 110 },
                        ['Graf ', bs.em({}, 'T'), ' je strom '],
                        undefined,
                        undefined,
                        40,
                        1500
                    ),
                    a.addWhiteboard(
                        'whiteboard1.3',
                        { x: 0, y: 170 },
                        [bs.strong({}, [' právě tehdy, když '])],
                        undefined,
                        undefined,
                        40,
                        2250
                    ),
                    a.addWhiteboard(
                        'whiteboard1.4',
                        { x: 0, y: 230 },
                        [' je souvislý a každá jeho hrana je most.'],
                        undefined,
                        undefined,
                        40,
                        3000
                    ),
                ],
                sentence: {
                    text: [
                        bs.strong({}, 'Strom'), ' je souvislý graf, který neobsahuje kružnici. Značíme písmenem ',
                        bs.em({}, 'T'), ' (ze slova tree).',
                        bs.e({ tag: 'br' }),
                        'Hrana ',
                        bs.em({}, 'e'), ' je ',
                        bs.strong({}, 'most'),
                        ' grafu ',
                        bs.em({}, 'G'), ', jestliže graf ',
                        bs.em({}, 'G '), '-', bs.em({}, ' e'), ' má více komponent než graf ',
                        bs.em({}, 'G'), '.',
                    ]
                },
                time: 5100
            },
            { // 1
                actions: [
                    a.editWhiteboard(
                        'whiteboard1.2',
                        undefined,
                        [b.style(bs.element({ tag: 'span' }, [
                            'Graf ', bs.em({}, 'T'), ' je strom ',
                        ]), { color: colors.redHighlight })],
                    ),
                    a.editWhiteboard(
                        'whiteboard1.4',
                        undefined,
                        [b.style(bs.element({ tag: 'span' }, [
                            ' je souvislý a každá jeho hrana je most.'
                        ]), { color: colors.greenHighlight })],
                    ),
                    a.addHint(
                        'whiteboard2',
                        { x: 530, y: 140 },
                        ['Výrok ', bs.em({}, 'A')],
                        undefined,
                        colors.redHighlight,
                        1500
                    ),
                    a.addHint(
                        'whiteboard3',
                        { x: 530, y: 255 },
                        ['Výrok ', bs.em({}, 'B')],
                        undefined,
                        colors.greenHighlight,
                        3000
                    ),
                    a.addWhiteboard(
                        'whiteboard4',
                        { x: 210, y: 350 },
                        [bs.em({}, 'A')],
                        colors.redHighlight,
                        undefined,
                        40,
                        1500,
                        35
                    ),
                    a.addWhiteboard(
                        'whiteboard4.2',
                        { x: 320, y: 350 },
                        [bs.em({}, 'B')],
                        colors.greenHighlight,
                        undefined,
                        40,
                        3000,
                        35
                    ),
                    a.addWhiteboard(
                        'whiteboard4.3',
                        { x: 260, y: 350 },
                        ['\u21D4'],
                        colors.defaultBlack,
                        undefined,
                        40,
                        4000,
                        35
                    )
                ],
                sentence: {
                    text: [
                        bs.strong({}, 'Výrok')
                        , ' je tvrzení, o kterém můžeme prohlásit, jestli je pravdivé nebo nepravdivé',
                        bs.e({ tag: 'br' }),
                        bs.strong({}, 'Složený výrok')
                        , ' vytvoříme složením výroků pomocí logických spojek (konjunkce, disjunkce, implikace, ekvivalence)',
                        bs.e({ tag: 'br' }),
                    ]
                },
                time: 6100
            },
            { // 2
                actions: [
                    a.removeWhiteboard('whiteboard1'),
                    a.removeWhiteboard('whiteboard1.2'),
                    a.removeWhiteboard('whiteboard1.3'),
                    a.removeWhiteboard('whiteboard1.4'),
                    a.removeHint('whiteboard2'),
                    a.removeHint('whiteboard3'),
                    a.removeWhiteboard('whiteboard4'),
                    a.removeWhiteboard('whiteboard4.2'),
                    a.removeWhiteboard('whiteboard4.3'),
                    a.addWhiteboard(
                        'whiteboard5',
                        { x: 240, y: 30 },
                        [bs.em({}, 'A'),
                            ' \u21D4 ',
                        bs.em({}, 'B')],
                        colors.orangeHighlight,
                        undefined,
                        40,
                        0,
                        30
                    ),
                    a.addWhiteboard(
                        'whiteboard6',
                        { x: 200, y: 120 },
                        ['1. implikace: ',
                            bs.em({}, 'A'),
                            ' \u21D2 ',
                            bs.em({}, 'B')],
                        colors.redHighlight,
                        undefined,
                        40,
                        1500
                    ),
                    a.addWhiteboard(
                        'whiteboard6.2',
                        { x: 10, y: 170 },
                        ['Jestliže graf  ',
                            bs.em({}, 'T'), ' je strom, pak je graf souvislý a každá jeho hrana je most.'],
                        colors.defaultBlack,
                        undefined,
                        40,
                        1500
                    ),
                    a.addWhiteboard(
                        'whiteboard7',
                        { x: 200, y: 280 },
                        ['2. implikace: ', bs.em({}, 'B '), '\u21D2', bs.em({}, ' A')],
                        colors.greenHighlight,
                        undefined,
                        40,
                        3000
                    ),
                    a.addWhiteboard(
                        'whiteboard7.2',
                        { x: 10, y: 330 },
                        ['Jestliže graf  ',
                            bs.em({}, 'T'), ' je souvislý a každá jeho hrana je most, pak je graf ',
                            bs.em({}, 'T'), ' strom.'],
                        colors.defaultBlack,
                        undefined,
                        40,
                        3000
                    ),
                ],
                sentence: {
                    text: [
                        bs.strong({}, ['Implikace ',
                            bs.em({}, 'p'), ' \u21D2 ', bs.em({}, 'q')]), ': jestliže platí výrok ',
                        bs.em({}, 'p'), ', pak platí výrok ',
                        bs.em({}, 'q'),
                        bs.e({ tag: 'br' }),
                        bs.strong({}, ['Ekvivalence ',
                            bs.em({}, 'p'), ' \u21D4 ', bs.em({}, 'q')]), ': výrok ',
                        bs.em({}, 'p'), ' platí právě tehdy, když platí výrok ',
                        bs.em({}, 'q'),
                        bs.e({ tag: 'br' }),
                        'Ekvivalenci rozdělíme na dvě implikace, které dokážeme zvlášť. '
                    ]
                },
                time: 5376
            },
            { // 3
                actions: [
                    a.removeWhiteboard('whiteboard5'),
                    a.removeWhiteboard('whiteboard6'),
                    a.removeWhiteboard('whiteboard6.2'),
                    a.removeWhiteboard('whiteboard7.2'),
                    a.removeWhiteboard('whiteboard7'),

                    a.addCloud(),

                    a.addVertex('a', { x: 200, y: 390 }, 'a'),
                    a.addVertex('b', { x: 190, y: 220 }, 'b'),
                    a.addVertex('c', { x: 290, y: 120 }, 'c'),
                    a.addVertex('h', { x: 410, y: 270 }, 'h'),
                    a.addVertex('g', { x: 600, y: 130 }, 'g'),
                    a.addVertex('e', { x: 450, y: 300 }, 'e'),
                    a.addVertex('i', { x: 160, y: 107 }, 'i'),
                    a.addVertex('d', { x: 480, y: 170 }, 'd'),
                    a.addVertex('f', { x: 300, y: 250 }, 'f'),

                    a.addEdge('a-b', 'a', 'b'),
                    a.addEdge('d-e', 'd', 'e'),
                    a.addEdge('c-f', 'c', 'f'),
                    a.addEdge('d-g', 'd', 'g'),
                    a.addEdge('b-c', 'b', 'c'),
                    a.addEdge('c-d', 'c', 'd'),
                    a.addEdge('e-h', 'e', 'h'),
                    a.addEdge('b-i', 'b', 'i'),
                ],
                sentence: {
                    text: [
                        bs.strong({}, 'Strom'), ' je souvislý graf, který neobsahuje kružnici. Značíme písmenem ',
                        bs.em({}, 'T'), ' (ze slova tree).',
                        bs.e({ tag: 'br' }),
                        bs.strong({}, 'Souvislý graf'), ' je graf, ve kterém existuje mezi každými jeho dvěma vrcholy cesta. ',
                        bs.e({ tag: 'br' }),
                        'Hrana ',
                        bs.em({}, 'e'), ' je ',
                        bs.strong({}, 'most'),
                        ' grafu ',
                        bs.em({}, 'G'), ', jestliže graf ',
                        bs.em({}, 'G '), '-', bs.em({}, ' e'), ' má více komponent než graf ',
                        bs.em({}, 'G'), '.',
                    ]
                },
                time: 200
            },
            { // 4
                actions: [
                    a.addHint('dukaz-2', { x: 200, y: 20 }, [
                        'Zvýrazněná hrana je mostem. ',
                        bs.e({ tag: 'br' }),
                        'Pokud bychom ji odstranili, ',
                        bs.e({ tag: 'br' }),
                        'výsledný graf by měl dvě komponenty. ',
                    ], undefined, colors.greenHighlight, 0),

                    a.highlightEdge('c-d', a.HighlightType.Full, undefined, undefined, undefined, undefined, undefined, 'c-d-red')
                ],
                sentence: {
                    text: [
                        bs.strong({}, 'Strom'), ' je souvislý graf, který neobsahuje kružnici.',
                        bs.e({ tag: 'br' }),
                        'Hrana ',
                        bs.em({}, 'e'), ' je ',
                        bs.strong({}, 'most'),
                        ' grafu ',
                        bs.em({}, 'G'), ', jestliže graf ',
                        bs.em({}, 'G '), '-', bs.em({}, ' e'), ' má více komponent než graf ',
                        bs.em({}, 'G'), '.',
                    ]
                },
                time: 500
            },
            { // 5
                actions: [
                    a.removeHint('dukaz-2'),
                    a.addHint('dukaz-3', { x: 280, y: 40 }, [
                        'Předpokládáme, že graf je strom ',
                        bs.e({ tag: 'br' }),
                        'a hrana ',
                        bs.em({}, 'e'),
                        ' = ',
                        bs.em({}, '{v, w}'),
                        ' není most.',
                    ], undefined, colors.greenHighlight, 0),

                    a.addWhiteboard('graf1', { x: 560, y: 50 }, [
                        'Graf ', bs.em({}, 'T')]),

                    a.unHighlightEdge('c-d-red', a.HighlightType.Full),

                    a.editVertex('b', undefined, 'v', colors.greenHighlight, 7, colors.greenHighlightLight),
                    a.editVertex('c', undefined, 'w', colors.greenHighlight, 7, colors.greenHighlightLight),
                    a.highlightEdge('b-c', a.HighlightType.Full, undefined,
                        colors.greenHighlight, undefined, undefined, undefined, 'b-c-green'),
                    a.addEdge('a-f', 'a', 'f')
                ],
                sentence: {
                    text: [
                        bs.strong({}, 'Důkaz sporem: '),
                        bs.e({ tag: 'br' }),
                        'Vytvoříme negaci věty, odvozujeme logické důsledky až dojdeme k výroku ',
                        bs.em({}, ['S']), ', který je nepravdivý. Negace věty tedy neplatí, platí původní věta. ',
                        bs.e({ tag: 'br' }),
                        'Věta: ',
                        bs.em({}, 'A'), ' \u21D2 ', bs.em({}, 'B'),
                        ', negace: ',
                        bs.em({}, 'A'), ' \u2227 ', bs.em({}, 'B\u2032')
                    ]
                },
                time: 1000
            },
            { // 6
                actions: [
                    a.removeHint('dukaz-3'),
                    a.addHint('dukaz-4', { x: 200, y: 20 }, [
                        'Mezi ',
                        bs.em({}, 'v'),
                        ' a ',
                        bs.em({}, 'w'),
                        ' existuje v grafu ',
                        bs.em({}, 'T '), '-', bs.em({}, ' e'),
                        ' cesta: ',
                        bs.e({ tag: 'br' }),
                        bs.em({}, ['P']), ' = ', bs.em({}, ['(v, a, f, w)']),
                    ], undefined, colors.greenHighlight, 0),

                    a.removeWhiteboard('graf1'),
                    a.addWhiteboard(
                        'graf2', { x: 560, y: 50 }, ['Graf ', bs.em({}, 'T '), '-', bs.em({}, ' e')], undefined, undefined, 0
                    ),

                    a.unHighlightEdge('b-c-green', a.HighlightType.Full),
                    a.removeEdge('b-c'),

                    a.highlightEdge('a-b', a.HighlightType.Full, undefined, colors.greenHighlight, undefined, undefined, 1000, 'a-b-green'),
                    a.highlightEdge('a-f', a.HighlightType.Full, undefined, colors.greenHighlight, undefined, undefined, 2000, 'a-f-green'),
                    a.highlightEdge('c-f', a.HighlightType.Full, undefined, colors.greenHighlight, undefined, undefined, 3000, 'c-f-green'),

                    a.editVertex('a', undefined, undefined, undefined, undefined, colors.greenHighlightLight, undefined, 2000),
                    a.editVertex('f', undefined, undefined, undefined, undefined, colors.greenHighlightLight, undefined, 3000)
                ],
                sentence: {
                    text: [
                        'Hrana ',
                        bs.em({}, 'e'), ' je ',
                        bs.strong({}, 'most'),
                        ' grafu ',
                        bs.em({}, 'G'), ', jestliže graf ',
                        bs.em({}, 'G '), '-', bs.em({}, ' e'), ' má více komponent než graf ',
                        bs.em({}, 'G'), '.',
                        bs.e({ tag: 'br' }),
                        bs.strong({}, 'Souvislý graf'), ' je graf, ve kterém existuje mezi každými jeho dvěma vrcholy cesta. ',
                        bs.e({ tag: 'br' }),
                        bs.strong({}, 'Cesta'), ' je sled s navzájem různými vrcholy, tj. pro ',
                        bs.em({}, 'i'), ' \u2260 ', bs.em({}, 'j'),
                        ' platí ',
                        bs.em({}, ['v', bs.sub({}, 'i')]), ' \u2260 ', bs.em({}, ['v', bs.sub({}, 'j')]),
                    ]
                },
                time: 5230
            },
            { // 7
                actions: [
                    a.removeHint('dukaz-4'),
                    a.addHint('dukaz-42', { x: 200, y: 20 }, [
                        'Mezi ',
                        bs.em({}, 'v'),
                        ' a ',
                        bs.em({}, 'w'),
                        ' existuje cesta i v grafu ',
                        bs.em({}, 'T'),
                        ':',
                        bs.e({ tag: 'br' }),
                        bs.em({}, ['P']), ' = ', bs.em({}, ['(v, a, f, w)']),
                    ], undefined, colors.greenHighlight, 0),

                    a.removeWhiteboard('graf2'),
                    a.addWhiteboard(
                        'graf3', { x: 560, y: 50 }, ['Graf ', bs.em({}, 'T')], undefined, undefined, 0
                    ),

                    a.addEdge('b-c', 'b', 'c')
                ],
                sentence: {
                    text: [
                        bs.strong({}, 'Cesta'), ' je sled s navzájem různými vrcholy, tj. pro ',
                        bs.em({}, 'i'), ' \u2260 ', bs.em({}, 'j'),
                        ' platí ',
                        bs.em({}, ['v', bs.sub({}, 'i')]), ' \u2260 ', bs.em({}, ['v', bs.sub({}, 'j')]),
                        bs.e({ tag: 'br' }),
                        '\u2022 Hrany a vrcholy se ', bs.strong({}, 'nesmí'), ' opakovat',
                    ]
                },
                time: 500
            },
            { // 8
                actions: [
                    a.removeHint('dukaz-42'),
                    a.addHint('dukaz-5', { x: 300, y: 10 }, [
                        'K cestě ',
                        bs.em({}, ['P']), ' = ', bs.em({}, ['(v, a, f, w)']),
                        bs.e({ tag: 'br' }),
                        'přidáme hranu  ',
                        bs.em({}, 'e'),
                        ' = ',
                        bs.em({}, '{v, w}'),
                        '.',
                        bs.e({ tag: 'br' }),
                        'Vznikne kružnice  ',
                        bs.em({}, ['C']), ' = ', bs.em({}, ['(v, a, f, w, v)']),
                    ], undefined, colors.greenHighlight, 0),

                    a.highlightEdge('b-c', a.HighlightType.Full, undefined,
                        colors.greenHighlight, undefined, undefined, undefined, 'b-c-green'),
                ],
                sentence: {
                    text: [
                        bs.strong({}, 'Kružnice (cyklus)'), ' v grafu ',
                        bs.em({}, 'G'),
                        ' je posloupnost',
                        bs.em({}, [
                            '(v',
                            bs.sub({}, '0'), ', e',
                            bs.sub({}, '1'), ', v',
                            bs.sub({}, '1'), ', ..., e',
                            bs.sub({}, 'k'), ', v',
                            bs.sub({}, '0'), ')'
                        ]),
                        ' kde ',
                        bs.em({}, ['e', bs.sub({}, 'i')]), ' = ', bs.em({}, ['{v', bs.sub({}, 'i-1'), ', v', bs.sub({}, 'i'), '}, i']),
                        ' = ', bs.em({}, ['1,..., k-1; ']),
                        bs.em({}, ['e', bs.sub({}, 'k')]), ' = ', bs.em({}, ['{v', bs.sub({}, 'k-1'), ', v', bs.sub({}, '0'), '}']),
                        bs.e({ tag: 'br' }),
                        '\u2022 První a poslední vrchol je stejný ',
                        bs.e({ tag: 'br' }),
                        '\u2022 Hrany a vrcholy od ',
                        bs.em({}, ['v', bs.sub({}, '0')]), ' do ',
                        bs.em({}, ['v', bs.sub({}, 'k-1')])
                        , ' se ',
                        bs.strong({}, 'nesmí'),
                        ' opakovat',
                        bs.e({ tag: 'br' }),
                        bs.strong({}, 'Strom'), ' je souvislý graf, který neobsahuje kružnici.',
                    ]
                },
                time: 600
            },
            { // 9
                actions: [
                    a.removeHint('dukaz-5'),
                    a.removeWhiteboard('graf3'),

                    a.unHighlightEdge('a-b-green', a.HighlightType.Full),
                    a.unHighlightEdge('a-f-green', a.HighlightType.Full),
                    a.unHighlightEdge('c-f-green', a.HighlightType.Full),
                    a.unHighlightEdge('b-c-green', a.HighlightType.Full),
                    a.removeEdge('a-f'),

                    a.editVertex('a', undefined, undefined, undefined, undefined, colors.defaultVertex),
                    a.editVertex('f', undefined, undefined, undefined, undefined, colors.defaultVertex),
                    a.editVertex('b', undefined, 'b', colors.defaultBlack, 3, colors.defaultVertex),
                    a.editVertex('c', undefined, 'c', colors.defaultBlack, 3, colors.defaultVertex)
                ],
                sentence: {
                    text: [
                        bs.strong({}, 'Souvislý graf'), ' je graf, ve kterém existuje mezi každými jeho dvěma vrcholy cesta. ',
                        bs.e({ tag: 'br' }),
                        'Hrana ',
                        bs.em({}, 'e'), ' je ',
                        bs.strong({}, 'most'),
                        ' grafu ',
                        bs.em({}, 'G'), ', jestliže graf ',
                        bs.em({}, 'G - e'), ' má více komponent než graf ',
                        bs.em({}, 'G'), '.',
                        bs.e({ tag: 'br' }),
                        bs.strong({}, 'Strom'), ' je souvislý graf, který neobsahuje kružnici.',
                    ]
                },
                time: 500
            },
            { // 10
                actions: [
                    a.addHint('dukaz-7', { x: 200, y: 20 }, [
                        'Předpokládáme, že každá hrana je most. ',
                        bs.e({ tag: 'br' }),
                        'Graf není stromem. '
                    ],
                        undefined, colors.purpleHighlight, 0),

                    a.addEdge('f-h', 'f', 'h'),
                    a.addVertex('j', { x: 520, y: 290 }, 'j'),
                    a.addVertex('l', { x: 580, y: 370 }, 'l'),
                    a.addVertex('k', { x: 620, y: 220 }, 'k'),
                    a.addEdge('j-l', 'j', 'l'),
                    a.addEdge('k-l', 'k', 'l')
                ],
                sentence: {
                    text: [
                        bs.strong({}, 'Důkaz sporem: '),
                        bs.e({ tag: 'br' }),
                        'Vytvoříme negaci věty, odvozujeme logické důsledky až dojdeme k výroku ',
                        bs.em({}, ['S']), ', který je nepravdivý. Negace věty tedy neplatí, platí původní věta. ',
                        bs.e({ tag: 'br' }),
                        'Věta: ',
                        bs.em({}, 'A'), ' \u21D2 ', bs.em({}, 'B'),
                        ', negace: ',
                        bs.em({}, 'A'), ' \u2227 ', bs.em({}, 'B\u2032')
                    ]
                },
                time: 400
            },
            { // 11
                actions: [
                    a.removeHint('dukaz-7'),
                    a.addHint('dukaz-8', { x: 200, y: 20 }, [
                        'Graf není stromem, protože je nesouvislý. ',
                    ], undefined, colors.blueHighlight, 0),


                ],
                sentence: {
                    text: [
                        bs.strong({}, 'Souvislý graf'), ' je graf, ve kterém existuje mezi každými jeho dvěma vrcholy cesta. ',
                        bs.e({ tag: 'br' }),
                        bs.strong({}, 'Cesta'), ' je sled s navzájem různými vrcholy, tj. pro ',
                        bs.em({}, 'i'), ' \u2260 ', bs.em({}, 'j'),
                        ' platí ',
                        bs.em({}, ['v', bs.sub({}, 'i')]), ' \u2260 ', bs.em({}, ['v', bs.sub({}, 'j'),
                        ]),
                    ]
                },
                time: 500
            },
            { // 12
                actions: [
                    a.removeHint('dukaz-8'),
                    a.addHint('dukaz-9', { x: 200, y: 20 }, [
                        'Graf není stromem, protože je obsahuje kružnici.',
                        bs.e({ tag: 'br' }),
                        bs.em({}, ['C']), ' = ', bs.em({}, ['(c, f, h, e, d, c)']),
                    ], undefined, colors.redHighlight, 0),

                    a.removeVertex('j'),
                    a.removeVertex('l'),
                    a.removeVertex('k'),
                    a.removeEdge('j-l'),
                    a.removeEdge('k-l'),

                    a.highlightEdge('c-f', a.HighlightType.Full, undefined, colors.redHighlight, undefined, undefined, 1000, 'c-f-red'),
                    a.highlightEdge('f-h', a.HighlightType.Full, undefined, colors.redHighlight, undefined, undefined, 2000, 'f-h-red'),
                    a.highlightEdge('e-h', a.HighlightType.Full, undefined, colors.redHighlight, undefined, undefined, 3000, 'e-h-red'),
                    a.highlightEdge('d-e', a.HighlightType.Full, undefined, colors.redHighlight, undefined, undefined, 4000, 'd-e-red'),
                    a.highlightEdge('c-d', a.HighlightType.Full, undefined, colors.redHighlight, undefined, undefined, 5000, 'c-d-red'),

                    a.editVertex('c', undefined, undefined, undefined, undefined, colors.redHighlightLight, undefined, 1000),
                    a.editVertex('f', undefined, undefined, undefined, undefined, colors.redHighlightLight, undefined, 2000),
                    a.editVertex('h', undefined, undefined, undefined, undefined, colors.redHighlightLight, undefined, 3000),
                    a.editVertex('e', undefined, undefined, undefined, undefined, colors.redHighlightLight, undefined, 4000),
                    a.editVertex('d', undefined, undefined, undefined, undefined, colors.redHighlightLight, undefined, 5000),
                ],
                sentence: {
                    text: [
                        bs.strong({}, 'Kružnice (cyklus)'), ' v grafu ',
                        bs.em({}, 'G'),
                        ' je posloupnost',
                        bs.em({}, [
                            '(v',
                            bs.sub({}, '0'), ', e',
                            bs.sub({}, '1'), ', v',
                            bs.sub({}, '1'), ', ..., e',
                            bs.sub({}, 'k'), ', v',
                            bs.sub({}, '0'), ')'
                        ]),
                        ' kde ',
                        bs.em({}, ['e', bs.sub({}, 'i')]), ' = ', bs.em({}, ['{v', bs.sub({}, 'i-1'), ', v', bs.sub({}, 'i'), '}, i']),
                        ' = ', bs.em({}, ['1,..., k-1; ']),
                        bs.em({}, ['e', bs.sub({}, 'k')]), ' = ', bs.em({}, ['{v', bs.sub({}, 'k-1'), ', v', bs.sub({}, '0'), '}'
                        ]),
                    ]
                },
                time: 7200
            },
            { // 13
                actions: [
                    a.removeHint('dukaz-9'),
                    a.addHint('dukaz-10', { x: 200, y: 20 }, [
                        'Odebrali jsme hranu ',
                        bs.em({}, ['e']), ' = ', bs.em({}, ['{c, f}']),
                    ], undefined, colors.redHighlight, 0),

                    a.unHighlightEdge('c-f-red', a.HighlightType.Full),
                    a.removeEdge('c-f'),

                ],
                sentence: {
                    text: [
                        bs.strong({}, 'Tvrzení 2:'),
                        bs.e({ tag: 'br' }),
                        'Nechť graf ', bs.em({}, 'G'), ' je souvislý a nechť obsahuje kružnici ', bs.em({}, 'C'),
                        '. Pak graf ', bs.em({}, 'G '), '-', 
                        bs.em({}, ' e'), ', kde ', bs.em({}, 'e'), ' je libovolná hrana kružnice ', bs.em({}, 'C'),
                        ', je také souvislý. '
                    ]
                },
                time: 600
            }
        ]
    }
];