import * as b from 'bobril';
import * as bs from 'bobrilstrap';
import * as a from '../../viewer/actions';
import * as colors from '../../common/colors';

export const examples = () => [
    {
        name: 'veta4', definitions: [
            { // 0
                nesting: 0,
                color: colors.orangeHighlight,
                text: [
                    'Věta: Graf ',
                    bs.em({}, 'T'), ' je strom právě tehdy, když je souvislý a platí vztah ',
                    bs.em({}, 'm'), ' = ',
                    bs.em({}, 'n '), '-', bs.em({}, ' 1'), '.'
                ]
            },
            { // 1
                nesting: 0,
                color: colors.orangeHighlight,
                text: [
                    'Rozdělení věty na dva výroky ',
                    bs.em({}, 'A'),
                    ' a ',
                    bs.em({}, 'B'),
                    ' spojené pomocí ekvivalence. '
                ]
            },
            { // 2
                nesting: 0,
                color: colors.orangeHighlight,
                text: 'Ekvivalenci dokážeme rozdělením na dvě implikace. '
            },
            { // 3
                nesting: 0,
                color: colors.blueHighlight,
                text: [
                    '1. implikace: Jestliže  ',
                    bs.em({}, 'T'), ' je strom, pak je souvislý a platí vztah ',
                    bs.em({}, 'm'), ' = ',
                    bs.em({}, 'n '), '-', bs.em({}, ' 1'), '.'
                ]
            },
            { // 4
                nesting: 1,
                color: colors.blueHighlightLight,
                text: [
                    'Podle definice stromu už víme, že strom je souvislý graf. Stačí dokázat, že počet hran odpovídá počtu vrcholů mínus jedna.',
                ]
            },
            { // 5
                nesting: 1,
                color: colors.blueHighlightLight,
                text: [
                    'Dokážeme indukcí. ',
                    'Rovnice zřejmě platí pro triviální strom s jedním vrcholem, ',
                    bs.em({}, 'n'), ' = ',
                    bs.em({}, '1'), ', a žádnou hranou, ',
                    bs.em({}, 'm'), ' = ',
                    bs.em({}, '0'), '.'
                ]
            },
            { // 6
                nesting: 1,
                color: colors.blueHighlightLight,
                text: [
                    'Rovnice zřejmě platí i pro strom s dvěma vrcholy, ',
                    bs.em({}, 'n'), ' = ',
                    bs.em({}, '2'), ', a jednou hranou, ',
                    bs.em({}, 'm'), ' = ',
                    bs.em({}, '1'), '.'
                ]
            },
            { // 7
                nesting: 1,
                color: colors.blueHighlightLight,
                text: [
                    'Předpokládáme, že platí indukční předpoklad: Věta platí pro grafy s méně než ',
                    bs.em({}, [
                        'n'
                    ]), ' vrcholy. ',
                    'Nyní dokážeme implikaci: ',
                    '\u2200',
                    bs.em({}, ['n']),
                    ' \u2208 ',
                    bs.em({}, ['N: V(n)']),
                    ' \u21D2 ',
                    bs.em({}, 'V(n '), '+', bs.em({}, '1)')
                ]
            },
            { // 8
                nesting: 1,
                color: colors.blueHighlightLight,
                text: [
                    'Graf je strom. Podle Věty 3 víme, že každá jeho hrana je most. ',
                ]
            },
            { // 9
                nesting: 1,
                color: colors.blueHighlightLight,
                text: [
                    'Pokud hranu odebereme, výsledný graf bude mít více komponent (dle definice mostu). ',
                ]
            },
            { // 10
                nesting: 1,
                color: colors.blueHighlightLight,
                text: [
                    'Když sečteme vrcholy všech komponent, vyjde počet vrcholů v původním grafu, tedy ',
                    bs.em({}, 'n'), ' = ',
                    bs.em({}, ['n', bs.sub({}, '1')]), ' + ',
                    bs.em({}, ['n', bs.sub({}, '2')]), '.'
                ]
            },
            { // 11
                nesting: 1,
                color: colors.blueHighlightLight,
                text: [
                    'Pro každou komponentu platí indukční předpoklad, tedy ',
                    bs.em({}, 'm'), ' = ',
                    bs.em({}, 'n '), '-', bs.em({}, ' 1'), '.'
                ]
            },
            { // 12
                nesting: 1,
                color: colors.blueHighlightLight,
                text: [
                    'Počet hran v původním grafu vypočteme jako součet počtu hran v komponentách plus jedna hrana, kterou jsme odebrali, tedy ',
                    bs.em({}, 'm'), ' = ',
                    bs.em({}, ['m', bs.sub({}, '1')]), ' + ',
                    bs.em({}, ['m', bs.sub({}, '2')]), ' + ',
                    bs.em({}, ['1']), '.'
                ]
            },
            { // 13
                nesting: 1,
                color: colors.blueHighlightLight,
                text: [
                    'Po úpravě vyjde ',
                    bs.em({}, 'm'), ' = ',
                    bs.em({}, 'n '), '-', bs.em({}, ' 1'), '. Dokázali jsme první implikaci. '
                ]
            },
            { // 14
                nesting: 0,
                color: colors.pinkHighlight,
                text: [
                    '2. implikace: Jestliže graf ',
                    bs.em({}, 'T'), ' je souvislý a platí vztah ',
                    bs.em({}, 'm'), ' = ',
                    bs.em({}, 'n '), '-', bs.em({}, ' 1'), ', pak je ',
                    bs.em({}, 'T'), ' strom.'
                ]
            },
            { // 15
                nesting: 1,
                color: colors.pinkHighlightLight,
                text: [
                    'Dokážeme sporem: Existuje souvislý graf ',
                    bs.em({}, 'T'),
                    ' a platí vztah ',
                    bs.em({}, 'm'), ' = ',
                    bs.em({}, 'n '), '-', bs.em({}, ' 1'),
                    ' a zároveň ',
                    bs.em({}, 'T'),
                    ' není strom. Pokud graf není stromem, pak je (dle definice stromu) nesouvislý nebo obsahuje alespoň jednu kružnici ',
                    bs.em({}, 'C'),
                    '.',
                ]
            },
            { // 16
                nesting: 1,
                color: colors.purpleHighlight,
                text: [
                    'a. Graf je nesouvislý. Došli jsme ke sporu s předpokladem, že graf je souvislý.',
                ]
            },
            { // 17
                nesting: 1,
                color: colors.redHighlight,
                text: [
                    'b. Graf obsahuje kružnici. Označíme jej ',
                    bs.em({}, ['T', bs.sub({}, '0')]),
                    '. '
                ]
            },
            { // 18
                nesting: 2,
                color: colors.redHighlightLight,
                text: [
                    'Odebereme libovolnou hranu ',
                    bs.em({}, 'e'),
                    ' ležící na kružnici ',
                    bs.em({}, 'C'),
                    '. Dle tvrzení 2 získáme opět souvislý graf ',
                    bs.em({}, ['T', bs.sub({}, '1')]),
                    '.',
                ]
            },
            { // 19
                nesting: 2,
                color: colors.redHighlightLight,
                text: [
                    'Odebereme další hrany',
                    ' ležící na kružnici',
                    ', dokud z grafu není strom ',
                    bs.em({}, ['T', bs.sub({}, 'p')]),
                    '.',
                ]
            },
            { // 20
                nesting: 2,
                color: colors.redHighlightLight,
                text: [
                    'Dle první dokázané implikace má strom ',
                    bs.em({}, ['T', bs.sub({}, 'p')]),
                    ' ',
                    bs.em({}, 'n '), '-', bs.em({}, ' 1'),
                    ' hran.',
                ]
            },
            { // 21
                nesting: 2,
                color: colors.redHighlightLight,
                text: [
                    'Původní graf ',
                    bs.em({}, ['T', bs.sub({}, '0')]),
                    ' má ale o několik hran navíc (hrany, co jsme odebírali). Došli jsme ke sporu, ',
                    bs.em({}, ['T', bs.sub({}, '0')]),
                    ' nemůže mít ',
                    bs.em({}, 'n '), '-', bs.em({}, ' 1'),
                    ' hran, protože má více hran než ',
                    bs.em({}, ['T', bs.sub({}, 'p')]),
                    '. Dokázali jsme druhou implikaci.',
                ]
            },
        ],
        steps: [
            { // 0
                actions: [
                    a.addWhiteboard(
                        'whiteboard1',
                        { x: 0, y: 50 },
                        ['Pro každý graf ', bs.em({}, 'T'), ' = ', bs.em({}, '(V, E)'), ' platí:'],
                        undefined,
                        undefined,
                        40,
                        0
                    ),
                    a.addWhiteboard(
                        'whiteboard1.2',
                        { x: 0, y: 110 },
                        ['Graf ', bs.em({}, 'T'), ' je strom '],
                        undefined,
                        undefined,
                        40,
                        1500
                    ),
                    a.addWhiteboard(
                        'whiteboard1.3',
                        { x: 0, y: 170 },
                        [bs.strong({}, [' právě tehdy, když '])],
                        undefined,
                        undefined,
                        40,
                        2250
                    ),
                    a.addWhiteboard(
                        'whiteboard1.4',
                        { x: 0, y: 230 },
                        [' je souvislý a platí vztah ',
                            bs.em({}, 'm'), ' = ',
                            bs.em({}, 'n '), '-', bs.em({}, ' 1'), '.'],
                        undefined,
                        undefined,
                        40,
                        3000
                    ),
                ],
                sentence: {
                    text: [
                        bs.strong({}, 'Graf'), ' je definován množinou vrcholů ',
                        bs.em({}, ['V']), ' a hran ',
                        bs.em({}, ['E']), '. ',
                        bs.e({ tag: 'br' }),
                        'Symbol ',
                        bs.em({}, ['|E|']), ' nebo ',
                        bs.em({}, ['m']), ' znamená počet hran.',
                        bs.e({ tag: 'br' }),
                        'Symbol ',
                        bs.em({}, ['|V|']), ' nebo ',
                        bs.em({}, ['n']), ' znamená počet vrcholů.',
                        bs.e({ tag: 'br' }),
                        bs.strong({}, 'Strom'), ' je souvislý graf, který neobsahuje kružnici. Značíme písmenem ',
                        bs.em({}, 'T'), ' (ze slova tree).',
                        bs.e({ tag: 'br' }),

                    ]
                },
                time: 5100
            },
            { // 1
                actions: [
                    a.editWhiteboard(
                        'whiteboard1.2',
                        undefined,
                        [b.style(bs.element({ tag: 'span' }, [
                            'Graf ', bs.em({}, 'T'), ' je strom ',
                        ]), { color: colors.redHighlight })],
                    ),
                    a.editWhiteboard(
                        'whiteboard1.4',
                        undefined,
                        [b.style(bs.element({ tag: 'span' }, [
                            ' je souvislý a platí vztah ',
                            bs.em({}, 'm'), ' = ',
                            bs.em({}, 'n '), '-', bs.em({}, ' 1'), '.'
                        ]), { color: colors.greenHighlight })],
                    ),
                    a.addHint(
                        'whiteboard2',
                        { x: 530, y: 140 },
                        ['Výrok ', bs.em({}, 'A')],
                        undefined,
                        colors.redHighlight,
                        1500
                    ),
                    a.addHint(
                        'whiteboard3',
                        { x: 530, y: 255 },
                        ['Výrok ', bs.em({}, 'B')],
                        undefined,
                        colors.greenHighlight,
                        3000
                    ),
                    a.addWhiteboard(
                        'whiteboard4',
                        { x: 210, y: 350 },
                        [bs.em({}, 'A')],
                        colors.redHighlight,
                        undefined,
                        40,
                        1500,
                        35
                    ),
                    a.addWhiteboard(
                        'whiteboard4.2',
                        { x: 320, y: 350 },
                        [bs.em({}, 'B')],
                        colors.greenHighlight,
                        undefined,
                        40,
                        3000,
                        35
                    ),
                    a.addWhiteboard(
                        'whiteboard4.3',
                        { x: 260, y: 350 },
                        ['\u21D4'],
                        colors.defaultBlack,
                        undefined,
                        40,
                        4000,
                        35
                    )
                ],
                sentence: {
                    text: [
                        bs.strong({}, 'Výrok')
                        , ' je tvrzení, o kterém můžeme prohlásit, jestli je pravdivé nebo nepravdivé',
                        bs.e({ tag: 'br' }),
                        bs.strong({}, 'Složený výrok')
                        , ' vytvoříme složením výroků pomocí logických spojek (konjunkce, disjunkce, implikace, ekvivalence)',
                        bs.e({ tag: 'br' }),
                    ]
                },
                time: 6100
            },
            { // 2
                actions: [
                    a.removeWhiteboard('whiteboard1'),
                    a.removeWhiteboard('whiteboard1.2'),
                    a.removeWhiteboard('whiteboard1.3'),
                    a.removeWhiteboard('whiteboard1.4'),
                    a.removeHint('whiteboard2'),
                    a.removeHint('whiteboard3'),
                    a.removeWhiteboard('whiteboard4'),
                    a.removeWhiteboard('whiteboard4.2'),
                    a.removeWhiteboard('whiteboard4.3'),
                    a.addWhiteboard(
                        'whiteboard5',
                        { x: 240, y: 30 },
                        [bs.em({}, 'A'),
                            ' \u21D4 ',
                        bs.em({}, 'B')],
                        colors.orangeHighlight,
                        undefined,
                        40,
                        0,
                        30
                    ),
                    a.addWhiteboard(
                        'whiteboard6',
                        { x: 200, y: 120 },
                        ['1. implikace: ',
                            bs.em({}, 'A'),
                            ' \u21D2 ',
                            bs.em({}, 'B')],
                        colors.redHighlight,
                        undefined,
                        40,
                        1500
                    ),
                    a.addWhiteboard(
                        'whiteboard6.2',
                        { x: 10, y: 170 },
                        [
                            'Jestliže graf ',
                            bs.em({}, 'T'), ' je strom, pak je souvislý a platí vztah ',
                            bs.em({}, 'm'), ' = ',
                            bs.em({}, 'n '), '-', bs.em({}, ' 1'), '.'
                        ],
                        colors.defaultBlack,
                        undefined,
                        40,
                        1500
                    ),
                    a.addWhiteboard(
                        'whiteboard7',
                        { x: 200, y: 280 },
                        ['2. implikace: ', bs.em({}, 'B '), '\u21D2', bs.em({}, ' A')],
                        colors.greenHighlight,
                        undefined,
                        40,
                        3000
                    ),
                    a.addWhiteboard(
                        'whiteboard7.2',
                        { x: 10, y: 330 },
                        [
                            'Jestliže graf ',
                            bs.em({}, 'T'), ' je souvislý a platí vztah ',
                            bs.em({}, 'm'), ' = ',
                            bs.em({}, 'n '), '-', bs.em({}, ' 1'), ', pak je ',
                            bs.em({}, 'T'), ' strom.'
                        ],
                        colors.defaultBlack,
                        undefined,
                        40,
                        3000
                    ),
                ],
                sentence: {
                    text: [
                        bs.strong({}, ['Implikace ',
                            bs.em({}, 'p'), ' \u21D2 ', bs.em({}, 'q')]), ': jestliže platí výrok ',
                        bs.em({}, 'p'), ', pak platí výrok ',
                        bs.em({}, 'q'),
                        bs.e({ tag: 'br' }),
                        bs.strong({}, ['Ekvivalence ',
                            bs.em({}, 'p'), ' \u21D4 ', bs.em({}, 'q')]), ': výrok ',
                        bs.em({}, 'p'), ' platí právě tehdy, když platí výrok ',
                        bs.em({}, 'q'),
                        bs.e({ tag: 'br' }),
                        'Ekvivalenci rozdělíme na dvě implikace, které dokážeme zvlášť. '
                    ]
                },
                time: 5376
            },
            { // 3
                actions: [
                    a.removeWhiteboard('whiteboard5'),
                    a.removeWhiteboard('whiteboard6'),
                    a.removeWhiteboard('whiteboard6.2'),
                    a.removeWhiteboard('whiteboard7.2'),
                    a.removeWhiteboard('whiteboard7'),

                    a.addCloud(),

                    a.addVertex('a', { x: 200, y: 300 }, 'a'),
                    a.addVertex('b', { x: 190, y: 220 }, 'b'),
                    a.addVertex('c', { x: 290, y: 120 }, 'c'),
                    a.addVertex('h', { x: 410, y: 270 }, 'h'),
                    a.addVertex('g', { x: 300, y: 200 }, 'g'),
                    a.addVertex('e', { x: 500, y: 300 }, 'e'),
                    a.addVertex('i', { x: 160, y: 107 }, 'i'),
                    a.addVertex('d', { x: 580, y: 170 }, 'd'),
                    a.addVertex('f', { x: 500, y: 110 }, 'f'),

                    a.addEdge('a-b', 'a', 'b'),
                    a.addEdge('d-e', 'd', 'e'),
                    a.addEdge('c-f', 'c', 'f'),
                    a.addEdge('d-g', 'd', 'g'),
                    a.addEdge('b-c', 'b', 'c'),
                    a.addEdge('c-d', 'c', 'd'),
                    a.addEdge('e-h', 'e', 'h'),
                    a.addEdge('b-i', 'b', 'i'),
                ],
                sentence: {
                    text: [
                        bs.strong({}, 'Graf'), ' je definován množinou vrcholů ',
                        bs.em({}, ['V']), ' a hran ',
                        bs.em({}, ['E']), '. ',
                        bs.e({ tag: 'br' }),
                        'Symbol ',
                        bs.em({}, ['|E|']), ' nebo ',
                        bs.em({}, ['m']), ' znamená počet hran.',
                        bs.e({ tag: 'br' }),
                        'Symbol ',
                        bs.em({}, ['|V|']), ' nebo ',
                        bs.em({}, ['n']), ' znamená počet vrcholů.',
                        bs.e({ tag: 'br' }),
                        bs.strong({}, 'Strom'), ' je souvislý graf, který neobsahuje kružnici.'
                    ]
                },
                time: 100
            },
            { // 4
                actions: [
                    a.addHint('dukaz-2', { x: 200, y: 20 }, [
                        'Graf je souvislý.',
                    ], undefined, colors.blueHighlight, 0),
                ],
                sentence: {
                    text: [
                        bs.strong({}, 'Strom'), ' je souvislý graf, který neobsahuje kružnici.',
                        bs.e({ tag: 'br' }),
                        bs.strong({}, 'Souvislý graf'), ' je graf, ve kterém existuje mezi každými jeho dvěma vrcholy cesta. ',
                    ]
                },
                time: 500
            },
            { // 5
                actions: [
                    a.removeHint('dukaz-2'),
                    a.addHint('dukaz-3', { x: 100, y: 150 }, [
                        'Počet hran = počet vrcholů - 1',
                        bs.e({ tag: 'br' }),
                        bs.em({}, 'm'),
                        ' = ',
                        bs.em({}, 'n '), '-', bs.em({}, ' 1'),
                        bs.e({ tag: 'br' }),
                        bs.em({}, '0'),
                        ' = ',
                        bs.em({}, '1 '), '-', bs.em({}, ' 1'),
                    ], undefined, colors.blueHighlight, 0),

                    a.removeVertex('b'),
                    a.removeVertex('c'),
                    a.removeVertex('h'),
                    a.removeVertex('g'),
                    a.removeVertex('e'),
                    a.removeVertex('i'),
                    a.removeVertex('d'),
                    a.removeVertex('f'),

                    a.removeEdge('a-b'),
                    a.removeEdge('d-e'),
                    a.removeEdge('c-f'),
                    a.removeEdge('d-g'),
                    a.removeEdge('b-c'),
                    a.removeEdge('c-d'),
                    a.removeEdge('e-h'),
                    a.removeEdge('b-i'),
                ],
                sentence: {
                    text: [
                        bs.strong({}, 'Důkaz matematickou indukcí: '),
                        bs.e({ tag: 'br' }),
                        '1. Dokážeme platnost tvrzení pro nejmenší prvek z uvažované množiny.',
                        bs.e({ tag: 'br' }),
                        '2. Dokazujeme implikaci \u2200',
                        bs.em({}, ['n']),
                        ' \u2208 ',
                        bs.em({}, ['N: V(n)']),
                        ' \u21D2 ',
                        bs.em({}, 'V(n '), '+', bs.em({}, '1)'),
                        ' (tvrzení platí pro všechny prvky).',
                    ]
                },
                time: 600
            },
            { // 6
                actions: [
                    a.removeHint('dukaz-3'),
                    a.addHint('dukaz-4', { x: 100, y: 20 }, [
                        'Počet hran = počet vrcholů - 1',
                        bs.e({ tag: 'br' }),
                        bs.em({}, 'm'),
                        ' = ',
                        bs.em({}, 'n '), '-', bs.em({}, ' 1'),
                        bs.e({ tag: 'br' }),
                        bs.em({}, '1'),
                        ' = ',
                        bs.em({}, '2 '), '-', bs.em({}, ' 1'),
                    ], undefined, colors.blueHighlight, 0),

                    a.addVertex('b', { x: 190, y: 220 }, 'b'),
                    a.addEdge('a-b', 'a', 'b')
                ],
                sentence: {
                    text: [
                        bs.strong({}, 'Důkaz matematickou indukcí: '),
                        bs.e({ tag: 'br' }),
                        '1. Dokážeme platnost tvrzení pro nejmenší prvek z uvažované množiny.',
                        bs.e({ tag: 'br' }),
                        '2. Dokazujeme implikaci \u2200',
                        bs.em({}, ['n']),
                        ' \u2208 ',
                        bs.em({}, ['N: V(n)']),
                        ' \u21D2 ',
                        bs.em({}, 'V(n '), '+', bs.em({}, '1)'),
                        ' (tvrzení platí pro všechny prvky).',
                    ]
                },
                time: 400
            },
            { // 7
                actions: [
                    a.removeHint('dukaz-4'),
                    a.addHint('dukaz-42', { x: 200, y: 20 }, [
                        'Graf má ',
                        bs.em({}, 'n'),
                        ' vrcholů. ',
                    ], undefined, colors.blueHighlight, 0),

                    a.addVertex('c', { x: 290, y: 120 }, 'c'),
                    a.addVertex('h', { x: 410, y: 270 }, 'h'),
                    a.addVertex('g', { x: 300, y: 200 }, 'g'),
                    a.addVertex('e', { x: 500, y: 300 }, 'e'),
                    a.addVertex('i', { x: 160, y: 107 }, 'i'),
                    a.addVertex('d', { x: 580, y: 170 }, 'd'),
                    a.addVertex('f', { x: 500, y: 110 }, 'f'),

                    a.addEdge('d-e', 'd', 'e'),
                    a.addEdge('c-f', 'c', 'f'),
                    a.addEdge('d-g', 'd', 'g'),
                    a.addEdge('b-c', 'b', 'c'),
                    a.addEdge('c-d', 'c', 'd'),
                    a.addEdge('e-h', 'e', 'h'),
                    a.addEdge('b-i', 'b', 'i'),
                ],
                sentence: {
                    text: [
                        bs.strong({}, 'Důkaz matematickou indukcí: '),
                        bs.e({ tag: 'br' }),
                        '1. Dokážeme platnost tvrzení pro nejmenší prvek z uvažované množiny.',
                        bs.e({ tag: 'br' }),
                        '2. Dokazujeme implikaci \u2200',
                        bs.em({}, ['n']),
                        ' \u2208 ',
                        bs.em({}, ['N: V(n)']),
                        ' \u21D2 ',
                        bs.em({}, 'V(n '), '+', bs.em({}, '1)'),
                        ' (tvrzení platí pro všechny prvky).',
                    ]
                },
                time: 600
            },
            { // 8
                actions: [
                    a.removeHint('dukaz-42'),
                    a.addHint('dukaz-5', { x: 200, y: 10 }, [
                        'Most je například hrana ',
                        bs.em({}, '{b, c}'),
                    ], undefined, colors.blueHighlight, 0),

                    a.highlightEdge('b-c', a.HighlightType.Full, undefined,
                        colors.blueHighlight, undefined, undefined, undefined, 'b-c-blue'),
                ],
                sentence: {
                    text: [
                        bs.strong({}, 'Věta 3:'),
                        bs.e({ tag: 'br' }),
                        'Graf ',
                        bs.em({}, 'T'), ' je strom právě tehdy, když je souvislý a každá jeho hrana je most.'
                    ]
                },
                time: 500
            },
            { // 9
                actions: [
                    a.removeHint('dukaz-5'),
                    a.addHint('dukaz-6', { x: 200, y: 10 }, [
                        'Odebrali jsme hranu ',
                        bs.em({}, '{b, c},'),
                        bs.e({ tag: 'br' }),
                        'vznikly dvě komponenty.',
                    ], undefined, colors.blueHighlight, 0),

                    a.unHighlightEdge('b-c-blue', a.HighlightType.Full),
                    a.removeEdge('b-c'),
                    a.editVertex('a', undefined, undefined, undefined, undefined, colors.greenHighlightLight),
                    a.editVertex('b', undefined, undefined, undefined, undefined, colors.greenHighlightLight),
                    a.editVertex('i', undefined, undefined, undefined, undefined, colors.greenHighlightLight),
                    a.editVertex('c', undefined, undefined, undefined, undefined, colors.orangeHighlightLight),
                    a.editVertex('f', undefined, undefined, undefined, undefined, colors.orangeHighlightLight),
                    a.editVertex('d', undefined, undefined, undefined, undefined, colors.orangeHighlightLight),
                    a.editVertex('g', undefined, undefined, undefined, undefined, colors.orangeHighlightLight),
                    a.editVertex('h', undefined, undefined, undefined, undefined, colors.orangeHighlightLight),
                    a.editVertex('e', undefined, undefined, undefined, undefined, colors.orangeHighlightLight),
                ],
                sentence: {
                    text: [
                        'Hrana ',
                        bs.em({}, 'e'), ' je ',
                        bs.strong({}, 'most'),
                        ' grafu ',
                        bs.em({}, 'G'), ', jestliže graf ',
                        bs.em({}, 'G '), '-', bs.em({}, ' e'), ' má více komponent než graf ',
                        bs.em({}, 'G'), '.',
                        bs.e({ tag: 'br' }),
                        bs.strong({}, 'Komponenta grafu'),
                        ' je maximální souvislý podgraf grafu (není podgrafem jiného souvislého podgrafu). ',
                    ]
                },
                time: 400
            },
            { // 10
                actions: [
                    a.removeHint('dukaz-6'),
                    a.addHint('dukaz-7', { x: 200, y: 20 }, [
                        bs.em({}, ['n', bs.sub({}, '1')]), ' = ',
                        bs.em({}, '3'), ' a ',
                        bs.em({}, ['n', bs.sub({}, '2')]), ' = ',
                        bs.em({}, '6, '),
                        bs.e({ tag: 'br' }),
                        'tedy ',
                        bs.em({}, 'n'), ' = ',
                        bs.em({}, '9'), '.',
                    ],
                        undefined, colors.blueHighlight, 0),

                ],
                sentence: {
                    text: [
                        bs.strong({}, 'Komponenta grafu'),
                        ' je maximální souvislý podgraf grafu (není podgrafem jiného souvislého podgrafu). ',
                        bs.e({ tag: 'br' }),
                        'Symbol ',
                        bs.em({}, ['|E|']), ' nebo ',
                        bs.em({}, ['m']), ' znamená počet hran.',
                        bs.e({ tag: 'br' }),
                        'Symbol ',
                        bs.em({}, ['|V|']), ' nebo ',
                        bs.em({}, ['n']), ' znamená počet vrcholů.',
                    ]
                },
                time: 300
            },
            { // 11
                actions: [
                    a.removeHint('dukaz-7'),
                    a.addHint('dukaz-8', { x: 200, y: 380 }, [
                        'Zelená komponenta má tři vrcholy a dvě hrany, ',
                        bs.e({ tag: 'br' }),
                        'tedy ',
                        bs.em({}, '2'), ' = ',
                        bs.em({}, '3'), ' - ',
                        bs.em({}, '1'), '.',
                        bs.e({ tag: 'br' }),
                        'Červená komponenta má šest vrcholů a pět hran, ',
                        bs.e({ tag: 'br' }),
                        'tedy ',
                        bs.em({}, '6'), ' = ',
                        bs.em({}, '5'), ' - ',
                        bs.em({}, '1'), '.',
                    ], undefined, colors.blueHighlight, 0),

                    a.highlightEdge('b-i', a.HighlightType.Full, undefined,
                        colors.greenHighlight, undefined, undefined, undefined, 'b-i-green'),
                    a.highlightEdge('a-b', a.HighlightType.Full, undefined,
                        colors.greenHighlight, undefined, undefined, undefined, 'a-b-green'),

                    a.highlightEdge('c-f', a.HighlightType.Full, undefined,
                        colors.redHighlight, undefined, undefined, undefined, 'c-f-red'),
                    a.highlightEdge('c-d', a.HighlightType.Full, undefined,
                        colors.redHighlight, undefined, undefined, undefined, 'c-d-red'),
                    a.highlightEdge('d-g', a.HighlightType.Full, undefined,
                        colors.redHighlight, undefined, undefined, undefined, 'd-g-red'),
                    a.highlightEdge('d-e', a.HighlightType.Full, undefined,
                        colors.redHighlight, undefined, undefined, undefined, 'd-e-red'),
                    a.highlightEdge('e-h', a.HighlightType.Full, undefined,
                        colors.redHighlight, undefined, undefined, undefined, 'e-h-red'),
                ],
                sentence: {
                    text: [
                        bs.strong({}, 'Komponenta grafu'),
                        ' je maximální souvislý podgraf grafu (není podgrafem jiného souvislého podgrafu). ',
                        bs.e({ tag: 'br' }),
                        'Symbol ',
                        bs.em({}, ['|E|']), ' nebo ',
                        bs.em({}, ['m']), ' znamená počet hran.',
                        bs.e({ tag: 'br' }),
                        'Symbol ',
                        bs.em({}, ['|V|']), ' nebo ',
                        bs.em({}, ['n']), ' znamená počet vrcholů.',
                    ]
                },
                time: 500
            },
            { // 12
                actions: [
                    a.removeHint('dukaz-8'),
                    a.addHint('dukaz-9', { x: 200, y: 400 }, [
                        'První komponenta má dvě hrany, ',
                        bs.e({ tag: 'br' }),
                        'druhá šest hran, tedy ',
                        bs.e({ tag: 'br' }),
                        bs.em({}, '2'), ' + ',
                        bs.em({}, '6'), ' + ',
                        bs.em({}, '1'), ' = ',
                        bs.em({}, '9'), '.',
                        bs.e({ tag: 'br' }),
                    ], undefined, colors.blueHighlight, 0),

                    a.addEdge('b-c', 'b', 'c'),
                    a.highlightEdge('b-c', a.HighlightType.Full, undefined,
                        colors.blueHighlight, undefined, undefined, undefined, 'b-c-blue'),
                ],
                sentence: {
                    text: [
                        bs.strong({}, 'Komponenta grafu'),
                        ' je maximální souvislý podgraf grafu (není podgrafem jiného souvislého podgrafu). ',
                        bs.e({ tag: 'br' }),
                        'Symbol ',
                        bs.em({}, ['|E|']), ' nebo ',
                        bs.em({}, ['m']), ' znamená počet hran.',
                        bs.e({ tag: 'br' }),
                        'Symbol ',
                        bs.em({}, ['|V|']), ' nebo ',
                        bs.em({}, ['n']), ' znamená počet vrcholů.',
                    ]
                },
                time: 300
            },
            { // 13
                actions: [
                    a.removeHint('dukaz-9'),
                    a.addHint('dukaz-10', { x: 300, y: 295 }, [
                        bs.em({}, 'n'), ' = ',
                        bs.em({}, ['n', bs.sub({}, '1')]), ' + ',
                        bs.em({}, ['n', bs.sub({}, '2')]), ' (celkový součet vrcholů)'
                    ], undefined, colors.purpleHighlight, 4500),

                    a.addHint('dukaz-11', { x: 300, y: 235 }, [
                        'Pro každou komponentu platí, že ',
                        bs.em({}, 'm'), ' = ',
                        bs.em({}, ['n']), ' - ',
                        bs.em({}, ['1'])
                    ], undefined, colors.blueHighlight, 3000),

                    a.addWhiteboard(
                        'whiteboard0',
                        { x: 0, y: 50 },
                        [
                            'Počet hran = počet hran první komponenty + počet hran druhé komponenty + odebraná hrana',
                        ],
                        undefined,
                        undefined,
                        40,
                        0
                    ),

                    a.addWhiteboard(
                        'whiteboard1',
                        { x: 0, y: 150 },
                        [
                            bs.em({}, 'm'), ' = ',
                            b.style
                                (bs.element({ tag: 'span' }, [bs.em({}, ['m', bs.sub({}, '1')])]), { color: colors.greenHighlight }), ' + ',
                            b.style
                                (bs.element({ tag: 'span' }, [bs.em({}, ['m', bs.sub({}, '2')])]), { color: colors.redHighlight }), ' + ',
                            b.style
                                (bs.element({ tag: 'span' }, [bs.em({}, ['1'])]), { color: colors.blueHighlight }),
                        ],
                        undefined,
                        undefined,
                        40,
                        1500
                    ),

                    a.addWhiteboard(
                        'whiteboard2',
                        { x: 0, y: 210 },
                        [
                            bs.em({}, 'm'), ' = ',
                            b.style
                                (bs.element({ tag: 'span' }, [bs.em({}, ['n', bs.sub({}, '1')]), ' - ',
                                bs.em({}, ['1'])]), { color: colors.greenHighlight }), ' + ',
                            b.style
                                (bs.element({ tag: 'span' }, [bs.em({}, ['n', bs.sub({}, '2')]), ' - ',
                                bs.em({}, ['1'])]), { color: colors.redHighlight }), ' + ',
                            b.style
                                (bs.element({ tag: 'span' }, [bs.em({}, ['1'])]), { color: colors.blueHighlight }),
                        ],
                        undefined,
                        undefined,
                        40,
                        3000
                    ),

                    a.addWhiteboard(
                        'whiteboard3',
                        { x: 0, y: 270 },
                        [
                            bs.em({}, 'm'), ' = ',
                            b.style
                                (bs.element({ tag: 'span' }, [bs.em({}, ['n', bs.sub({}, '1')])]), { color: colors.purpleHighlight }), ' + ',
                            b.style
                                (bs.element({ tag: 'span' }, [bs.em({}, ['n', bs.sub({}, '2')])]), { color: colors.purpleHighlight }), ' - ',
                            b.style
                                (bs.element({ tag: 'span' }, [bs.em({}, ['1'])]), { color: colors.defaultBlack }),
                        ],
                        undefined,
                        undefined,
                        40,
                        4500
                    ),

                    a.addWhiteboard(
                        'whiteboard4',
                        { x: 0, y: 330 },
                        [
                            bs.strong({}, [bs.em({}, 'm'), ' = ',
                            b.style
                                (bs.element({ tag: 'span' }, [bs.em({}, ['n'])]), { color: colors.purpleHighlight }), ' - ',
                            b.style
                                (bs.element({ tag: 'span' }, [bs.em({}, ['1'])]), { color: colors.defaultBlack }),
                            ])
                        ],
                        undefined,
                        undefined,
                        40,
                        6000
                    ),

                    a.removeCloud(),

                    a.removeVertex('a'),
                    a.removeVertex('b'),
                    a.removeVertex('c'),
                    a.removeVertex('h'),
                    a.removeVertex('g'),
                    a.removeVertex('e'),
                    a.removeVertex('i'),
                    a.removeVertex('d'),
                    a.removeVertex('f'),

                    a.unHighlightEdge('a-b-green', a.HighlightType.Full),
                    a.unHighlightEdge('d-e-red', a.HighlightType.Full),
                    a.unHighlightEdge('c-f-red', a.HighlightType.Full),
                    a.unHighlightEdge('d-g-red', a.HighlightType.Full),
                    a.unHighlightEdge('b-c-blue', a.HighlightType.Full),
                    a.unHighlightEdge('c-d-red', a.HighlightType.Full),
                    a.unHighlightEdge('e-h-red', a.HighlightType.Full),
                    a.unHighlightEdge('b-i-green', a.HighlightType.Full),

                    a.removeEdge('a-b'),
                    a.removeEdge('d-e'),
                    a.removeEdge('c-f'),
                    a.removeEdge('d-g'),
                    a.removeEdge('b-c'),
                    a.removeEdge('c-d'),
                    a.removeEdge('e-h'),
                    a.removeEdge('b-i'),
                ],
                sentence: {
                    text: [
                        bs.strong({}, 'Komponenta grafu'),
                        ' je maximální souvislý podgraf grafu (není podgrafem jiného souvislého podgrafu). ',
                        bs.e({ tag: 'br' }),
                        'Symbol ',
                        bs.em({}, ['|E|']), ' nebo ',
                        bs.em({}, ['m']), ' znamená počet hran.',
                        bs.e({ tag: 'br' }),
                        'Symbol ',
                        bs.em({}, ['|V|']), ' nebo ',
                        bs.em({}, ['n']), ' znamená počet vrcholů.',
                    ]
                },
                time: 8300
            },
            { // 14
                actions: [
                    a.removeHint('dukaz-10'),
                    a.removeHint('dukaz-11'),
                    a.removeWhiteboard('whiteboard0'),
                    a.removeWhiteboard('whiteboard1'),
                    a.removeWhiteboard('whiteboard2'),
                    a.removeWhiteboard('whiteboard3'),
                    a.removeWhiteboard('whiteboard4'),

                    a.addCloud(),

                    a.addVertex('a', { x: 200, y: 300 }, 'a'),
                    a.addVertex('b', { x: 190, y: 220 }, 'b'),
                    a.addVertex('c', { x: 290, y: 120 }, 'c'),
                    a.addVertex('h', { x: 410, y: 270 }, 'h'),
                    a.addVertex('g', { x: 300, y: 200 }, 'g'),
                    a.addVertex('e', { x: 500, y: 300 }, 'e'),
                    a.addVertex('i', { x: 160, y: 107 }, 'i'),
                    a.addVertex('d', { x: 580, y: 170 }, 'd'),
                    a.addVertex('f', { x: 500, y: 110 }, 'f'),

                    a.addEdge('a-b', 'a', 'b'),
                    a.addEdge('d-e', 'd', 'e'),
                    a.addEdge('c-f', 'c', 'f'),
                    a.addEdge('d-g', 'd', 'g'),
                    a.addEdge('b-c', 'b', 'c'),
                    a.addEdge('c-d', 'c', 'd'),
                    a.addEdge('e-h', 'e', 'h'),
                    a.addEdge('b-i', 'b', 'i'),
                ],
                sentence: {
                    text: [
                        bs.strong({}, 'Strom'), ' je souvislý graf, který neobsahuje kružnici.',
                        bs.e({ tag: 'br' }),
                        bs.strong({}, 'Souvislý graf'), ' je graf, ve kterém existuje mezi každými jeho dvěma vrcholy cesta. ',
                    ]
                },
                time: 300
            },
            { // 15
                actions: [
                    a.addHint('dukaz-12', { x: 200, y: 20 }, [
                        'Předpokládáme, že graf není strom a platí: ',
                        bs.e({ tag: 'br' }),
                        bs.em({}, 'm'), ' = ',
                        bs.em({}, ['n']), ' - ',
                        bs.em({}, ['1'])
                    ], undefined, colors.pinkHighlight, 0),

                    a.addEdge('b-g', 'b', 'g'),
                    a.addEdge('d-f', 'd', 'f'),

                    a.removeEdge('d-e')
                ],
                sentence: {
                    text: [
                        bs.strong({}, 'Důkaz sporem: '),
                        bs.e({ tag: 'br' }),
                        'Vytvoříme negaci věty, odvozujeme logické důsledky až dojdeme k výroku ',
                        bs.em({}, ['S']), ', který je nepravdivý. Negace věty tedy neplatí, platí původní věta. ',
                        bs.e({ tag: 'br' }),
                        'Věta: ',
                        bs.em({}, 'A'), ' \u21D2 ', bs.em({}, 'B'),
                        ', negace: ',
                        bs.em({}, 'A'), ' \u2227 ', bs.em({}, 'B\u2032')
                    ]
                },
                time: 400
            },
            { // 16
                actions: [
                    a.removeHint('dukaz-12'),
                    a.addHint('dukaz-13', { x: 200, y: 20 }, [
                        'Graf není stromem, protože je nesouvislý.',
                    ], undefined, colors.purpleHighlight, 0),
                ],
                sentence: {
                    text: [
                        bs.strong({}, 'Strom'), ' je souvislý graf, který neobsahuje kružnici.',
                        bs.e({ tag: 'br' }),
                        bs.strong({}, 'Kružnice (cyklus)'), ' v grafu ',
                        bs.em({}, 'G'),
                        ' je posloupnost',
                        bs.em({}, [
                            '(v',
                            bs.sub({}, '0'), ', e',
                            bs.sub({}, '1'), ', v',
                            bs.sub({}, '1'), ', ..., e',
                            bs.sub({}, 'k'), ', v',
                            bs.sub({}, '0'), ')'
                        ]),
                        ' kde ',
                        bs.em({}, ['e', bs.sub({}, 'i')]), ' = ', bs.em({}, ['{v', bs.sub({}, 'i-1'), ', v', bs.sub({}, 'i'), '}, i']),
                        ' = ', bs.em({}, ['1,..., k-1; ']),
                        bs.em({}, ['e', bs.sub({}, 'k')]), ' = ', bs.em({}, ['{v', bs.sub({}, 'k-1'), ', v', bs.sub({}, '0'), '}'
                        ]),
                    ]
                },
                time: 500
            },
            { // 17
                actions: [
                    a.removeHint('dukaz-13'),
                    a.addHint('dukaz-14', { x: 100, y: 20 }, [
                        'Graf není stromem, protože obsahuje kružnici ',
                        bs.em({}, 'C'), ' = ',
                        bs.em({}, '(b, c, d, g, b)'), '.',
                    ], undefined, colors.redHighlight, 0),

                    a.addWhiteboard('graf1', { x: 560, y: 50 }, [
                        'Graf ', bs.em({}, ['T', bs.sub({}, ['0'])])]),

                    a.removeEdge('e-h'),
                    a.removeVertex('e'),
                    a.removeVertex('h'),

                    a.highlightEdge('b-c', a.HighlightType.Full, undefined, colors.redHighlight, undefined, undefined, 1000, 'b-c-red'),
                    a.highlightEdge('c-d', a.HighlightType.Full, undefined, colors.redHighlight, undefined, undefined, 2000, 'c-d-red'),
                    a.highlightEdge('d-g', a.HighlightType.Full, undefined, colors.redHighlight, undefined, undefined, 3000, 'd-g-red'),
                    a.highlightEdge('b-g', a.HighlightType.Full, undefined, colors.redHighlight, undefined, undefined, 4000, 'b-g-red'),

                    a.editVertex('b', undefined, undefined, undefined, undefined, colors.redHighlightLight, undefined, 2000),
                    a.editVertex('c', undefined, undefined, undefined, undefined, colors.redHighlightLight, undefined, 3000),
                    a.editVertex('g', undefined, undefined, undefined, undefined, colors.redHighlightLight, undefined, 5000),
                    a.editVertex('d', undefined, undefined, undefined, undefined, colors.redHighlightLight, undefined, 4000)
                ],
                sentence: {
                    text: [
                        bs.strong({}, 'Kružnice (cyklus)'), ' v grafu ',
                        bs.em({}, 'G'),
                        ' je posloupnost',
                        bs.em({}, [
                            '(v',
                            bs.sub({}, '0'), ', e',
                            bs.sub({}, '1'), ', v',
                            bs.sub({}, '1'), ', ..., e',
                            bs.sub({}, 'k'), ', v',
                            bs.sub({}, '0'), ')'
                        ]),
                        ' kde ',
                        bs.em({}, ['e', bs.sub({}, 'i')]), ' = ', bs.em({}, ['{v', bs.sub({}, 'i-1'), ', v', bs.sub({}, 'i'), '}, i']),
                        ' = ', bs.em({}, ['1,..., k-1; ']),
                        bs.em({}, ['e', bs.sub({}, 'k')]), ' = ', bs.em({}, ['{v', bs.sub({}, 'k-1'), ', v', bs.sub({}, '0'), '}'
                        ]),
                    ]
                },
                time: 7400
            },
            { // 18
                actions: [
                    a.removeHint('dukaz-14'),
                    a.addHint('dukaz-15', { x: 200, y: 20 }, [
                        'Odebrali jsme hranu ',
                        bs.em({}, '{d, g}'), '.',
                    ], undefined, colors.redHighlight, 0),

                    a.removeWhiteboard('graf1'),
                    a.addWhiteboard('graf2', { x: 560, y: 50 }, [
                        'Graf ', bs.em({}, ['T', bs.sub({}, ['1'])])]),

                    a.unHighlightEdge('d-g-red', a.HighlightType.Full),
                    a.unHighlightEdge('b-c-red', a.HighlightType.Full),
                    a.unHighlightEdge('c-d-red', a.HighlightType.Full),
                    a.unHighlightEdge('b-g-red', a.HighlightType.Full),
                    a.editVertex('b', undefined, undefined, undefined, undefined, colors.defaultVertex),
                    a.editVertex('c', undefined, undefined, undefined, undefined, colors.defaultVertex),
                    a.editVertex('g', undefined, undefined, undefined, undefined, colors.defaultVertex),
                    a.editVertex('d', undefined, undefined, undefined, undefined, colors.defaultVertex),
                    a.removeEdge('d-g')
                ],
                sentence: {
                    text: [
                        bs.strong({}, 'Tvrzení 2:'),
                        bs.elem({ tag: 'br' }),
                        'Nechť graf ', bs.em({}, 'G'), ' je souvislý a nechť obsahuje kružnici ', bs.em({}, 'C'),
                        '. Pak graf ', bs.em({}, 'G '), '-',
                        bs.em({}, ' e'), ', kde ', bs.em({}, 'e'), ' je libovolná hrana kružnice ', bs.em({}, 'C'),
                        ', je také souvislý. ',
                    ]
                },
                time: 400
            },
            { // 19
                actions: [
                    a.removeHint('dukaz-15'),
                    a.addHint('dukaz-16', { x: 200, y: 20 }, [
                        'Odebrali jsme hranu ',
                        bs.em({}, '{c, d}'), '.',
                        bs.elem({ tag: 'br' }),
                        'Graf je strom. ',
                    ], undefined, colors.redHighlight, 0),

                    a.removeWhiteboard('graf2'),
                    a.addWhiteboard('graf3', { x: 560, y: 50 }, [
                        'Graf ', bs.em({}, ['T', bs.sub({}, ['p'])])]),

                    a.removeEdge('c-d')
                ],
                sentence: {
                    text: [
                        bs.strong({}, 'Tvrzení 2 (Souvislost a kružnice):'),
                        bs.elem({ tag: 'br' }),
                        'Nechť graf ', bs.em({}, 'G'), ' je souvislý a nechť obsahuje kružnici ', bs.em({}, 'C'),
                        '. Pak graf ', bs.em({}, 'G '), '-',
                        bs.em({}, ' e'), ', kde ', bs.em({}, 'e'), ' je libovolná hrana kružnice ', bs.em({}, 'C'),
                        ', je také souvislý. ',
                    ]
                },
                time: 500
            },
            { // 20
                actions: [
                    a.removeHint('dukaz-16'),
                    a.addHint('dukaz-17', { x: 200, y: 20 }, [
                        'Strom má 6 hran a 7 vrcholů, platí ',
                        bs.em({}, 'm'), ' = ',
                        bs.em({}, 'n'), ' - ',
                        bs.em({}, '1'), '.',
                    ], undefined, colors.redHighlight, 0),
                ],
                sentence: {
                    text: [
                        '1. implikace: Jestliže  ',
                        bs.em({}, 'T'), ' je strom, pak je souvislý a platí vztah ',
                        bs.em({}, 'm'), ' = ',
                        bs.em({}, 'n '), '-', bs.em({}, ' 1'), '.'
                    ]
                },
                time: 400
            },
            { // 21
                actions: [
                    a.removeHint('dukaz-17'),
                    a.addHint('dukaz-18', { x: 250, y: 300 }, [
                        'U původního grafu nemůže platit ',
                        bs.em({}, 'm'), ' = ',
                        bs.em({}, 'n'), ' - ',
                        bs.em({}, '1'), ',',
                        bs.elem({ tag: 'br' }),
                        'protože v něm jsou i hrany ',
                        bs.em({}, '{c, d}'), ' a ',
                        bs.em({}, '{d, g}'), ',',
                        bs.elem({ tag: 'br' }),
                        'které jsme odebírali. ',
                    ], undefined, colors.redHighlight, 0),

                    a.removeWhiteboard('graf3'),
                    a.addWhiteboard('graf4', { x: 560, y: 50 }, [
                        'Graf ', bs.em({}, ['T', bs.sub({}, ['0'])])]),

                    a.addEdge('c-d', 'c', 'd', undefined, 7, colors.redHighlight, undefined, undefined, undefined, 1000),
                    a.addEdge('d-g', 'd', 'g', undefined, 7, colors.redHighlight, undefined, undefined, undefined, 3000),
                ],
                sentence: {
                    text: [
                        '1. implikace: Jestliže  ',
                        bs.em({}, 'T'), ' je strom, pak je souvislý a platí vztah ',
                        bs.em({}, 'm'), ' = ',
                        bs.em({}, 'n '), '-', bs.em({}, ' 1'), '.',
                        bs.elem({ tag: 'br' }),
                        'Spor, protože ', bs.em({}, 'n '), '-',
                        bs.em({}, ' 1'), ' (v původním grafu) nemůže být větší než ',
                        bs.em({}, 'n '), '-', bs.em({}, ' 1'), ' (ve stromu vytvořeném odebíráním hran). ',
                    ]
                },
                time: 5300
            },
        ]
    }
];