import * as b from 'bobril';
import * as bs from 'bobrilstrap';

const tableKvantStyle = b.styleDef({
    width: 900,
    marginLeft: 'auto',
    marginRight: 'auto'
});

export const kvantifikovaneVyroky = b.createVirtualComponent({
    id: 'kvantifikovaneVyroky',
    render(ctx: b.IBobrilCtx, me: b.IBobrilNode) {
        me.children = [
            bs.h2({}, 'Kvantifikované výroky'),
            bs.paragraph({}, ['Kvantifikovaný výrok je výrok obsahující určitý počet prvků, které mají nějakou vlastnost.',
                ' Je spojením ',
                b.link(bs.a({}, 'výroku'), 'vyroky'),
                ' s univerzálním nebo existenčním kvantifikátorem. ',
                'Kvantifikátory jsou matematické symboly, které nám pomohou s určením rozsahu ',
                'proměnných, pro které platí daný výrok.']),
            bs.ul({}, [
                bs.li({}, ['\u2200 označuje univerzální, obecný nebo velký kvantifikátor. ',
                    'Zápis \u2200x lze do českého jazyka přeložit jako slovní spojení "pro všechna x", ',
                    '"pro libovolné x" nebo "pro každé x".']),
                bs.li({}, ['\u2203 označuje existenční nebo malý kvantifikátor. ',
                    'Zápis \u2203x lze přeložit jako "existuje alespoň jeden prvek x" nebo "pro alespoň jedno x platí".']),
            ]),
            bs.paragraph({}, ['Za kvantifikované výroky můžeme označit věty:']),
            bs.ul({}, [
                bs.li({}, ['"Existuje město, které má více než jeden milion obyvatel."']),
                bs.li({}, ['"Každé prvočíslo je dělitelné pouze číslem jedna a sebou samým."']),
                bs.li({}, ['"Petr má alespoň dvě dobré známky."'])
            ]),

            bs.h2({}, 'Negace kvantifikovaných výroků'),
            bs.paragraph({}, ['Negování kvantifikovaných výroků může být náročnější ',
                'z hlediska správné formulace negace. Při negování se můžeme řídit následující tabulkou:']),

            bs.elem({ tag: 'br' }),
            b.style(
                bs.table({ bordered: true, striped: true }, [
                    bs.thead({}, [
                        bs.tr({}, [
                            bs.th({}, [bs.em({}, ['p'])]),
                            bs.th({}, ['\xAC', bs.em({}, 'p')]),
                        ]),
                    ]),
                    bs.tbody({}, [
                        bs.tr({}, [
                            bs.td({}, ['Právě ', bs.em({}, ['n']), ' prvků má danou vlastnost']),
                            bs.td({}, ['Nejvýše ',
                                bs.em({}, 'n '), '-', bs.em({}, '1'), ' nebo alespoň ',
                                bs.em({}, 'n '), '+', bs.em({}, '1'), ' prvků má danou vlastnost']),
                        ]),
                        bs.tr({}, [
                            bs.td({}, ['Alespoň ', bs.em({}, 'n '), ' prvků má danou vlastnost']),
                            bs.td({}, ['Nejvýše ', bs.em({}, 'n '), '-', bs.em({}, '1'), ' prvků má danou vlastnost']),
                        ]),
                        bs.tr({}, [
                            bs.td({}, ['Nejvýše ', bs.em({}, 'n '), ' prvků má danou vlastnost']),
                            bs.td({}, ['Alespoň ', bs.em({}, 'n '), '+', bs.em({}, '1'), ' prvků má danou vlastnost']),
                        ]),
                        bs.tr({}, [
                            bs.td({}, ['Každý prvek má danou vlastnost (resp. všechny prvky)']),
                            bs.td({}, ['Existuje alespoň jeden prvek, který nemá danou vlastnost']),
                        ]),
                        bs.tr({}, [
                            bs.td({}, ['Existuje alespoň jeden prvek, který má danou vlastnost']),
                            bs.td({}, ['Každý prvek nemá danou vlastnost (resp. všechny prvky)']),
                        ]),
                    ])
                ]),
                tableKvantStyle),
            bs.elem({ tag: 'br' }),

            bs.paragraph({}, ['Příklad správné a nesprávné negace kvantifikovaného výroku:']),
            bs.ul({}, [
                bs.li({}, ['Výrok: "Všichni Češi pijí pivo."']),
                bs.li({}, ['Nesprávná negace: "Všichni Češi nepijí pivo." ', bs.elem({ tag: 'br' }, []),
                    'Tato věta by znamenala, ',
                    'že žádný Čech pivo nepije. Přitom pro popření původního výroku stačí jen jeden Čech, ',
                    'který pivo nepije.']),
                bs.li({}, ['Správná negace: "Existuje alespoň jeden Čech, který nepije pivo."']),
                bs.li({}, ['Další možná negace: "Není pravda, že všichni Češi pijí pivo."'])
            ]),
        ];
    }
});