import * as b from 'bobril';
import * as bs from 'bobrilstrap';
import { exercises } from '../components/negations/exercises';

const exerciseMarginStyle = b.styleDef({
    marginLeft: 87,
});

export const procviceni = b.createVirtualComponent({
    id: 'procviceni',
    render(ctx: b.IBobrilCtx, me: b.IBobrilNode) {
        me.children = [
            bs.h2({}, 'Procvičení negací'),
            bs.paragraph({}, ['Zkuste si procvičit získané znalosti a vytvořte negace pro následující výroky. Pokud si nebudete vědět rady, klikněte na výrok pro zobrazení správné odpovědi (někdy může být více správných možností). Správné možnosti nezahrnují jednoduchou negaci, která vznikne přidáním slovního spojení "Není pravda, že" před daný výrok.',
                bs.e({ tag: 'br' }), bs.e({ tag: 'br' }),
                exercises(
                    {
                        exercises: [
                            {
                                statement: 'Každý student se těší na zkouškové období.',
                                answer: [
                                    'Existuje student, který se na zkouškové období netěší.',
                                    bs.elem({ tag: 'br' }),
                                    [
                                        b.style(
                                            bs.element({ tag: 'span' }, [
                                                'Alespoň jeden student se na zkouškové období netěší.'
                                            ]),
                                            exerciseMarginStyle)],
                                ]
                            },
                            {
                                statement: 'Existuje talíř, který je prázdný.',
                                answer: [
                                    'Každý talíř není prázdný.',
                                    bs.elem({ tag: 'br' }),
                                    [
                                        b.style(
                                            bs.element({ tag: 'span' }, [
                                                'Všechny talíře nejsou prázdné.'
                                            ]),
                                            exerciseMarginStyle)],
                                ]
                            },
                            {
                                statement: 'Doma mám právě dva psy.',
                                answer: [
                                    'Doma mám méně nebo více než dva psy.',
                                    bs.elem({ tag: 'br' }),
                                    [
                                        b.style(
                                            bs.element({ tag: 'span' }, [
                                                'Doma mám nejvýše jednoho nebo alespoň tři psy.'
                                            ]),
                                            exerciseMarginStyle)],
                                ]
                            },
                            {
                                statement: 'V knihovně si půjčím alespoň šest knih.',
                                answer: [
                                    'V knihovně si půjčím nejvýše pět knih.',
                                    bs.elem({ tag: 'br' }),
                                    [
                                        b.style(
                                            bs.element({ tag: 'span' }, [
                                                'V knihovně si půjčím maximálně pět knih.'
                                            ]),
                                            exerciseMarginStyle)],
                                ]
                            },
                            {
                                statement: 'Včera jsem vypil nejvýše tři hrníčky tatranského čaje.',
                                answer: [
                                    'Včera jsem vypil alespoň čtyři hrníčky tatranského čaje.',
                                    bs.elem({ tag: 'br' }),
                                    [
                                        b.style(
                                            bs.element({ tag: 'span' }, [
                                                'Včera jsem vypil minimálně čtyři hrníčky tatranského čaje.'
                                            ]),
                                            exerciseMarginStyle)],
                                ]
                            },
                            {
                                statement: 'Právě dva studenti dostanou jedničku.',
                                answer: [
                                    'Nejvýše jeden student nebo alespoň tři studenti dostanou jedničku.',
                                    bs.elem({ tag: 'br' }),
                                    [
                                        b.style(
                                            bs.element({ tag: 'span' }, [
                                                'Více nebo méně než dva studenti dostanou jedničku.'
                                            ]),
                                            exerciseMarginStyle)],
                                ]
                            },
                            {
                                statement: 'Za svůj život navštívím alespoň čtyři kontinenty.',
                                answer: [
                                    'Za svůj život navštívím nejvýše tři kontinenty.',
                                    bs.elem({ tag: 'br' }),
                                    [
                                        b.style(
                                            bs.element({ tag: 'span' }, [
                                                'Za svůj život navštívím maximálně tři kontinenty.'
                                            ]),
                                            exerciseMarginStyle)],
                                ]
                            },
                            {
                                statement: 'Jestliže mám na sobě bílé kalhoty, pak mám bílé sako.',
                                answer: 'Mám na sobě bílé kalhoty a zároveň nemám bílé sako.'
                            },
                            {
                                statement: 'Jestliže bude dnes pršet, pak nepůjdeme hrát tenis. ',
                                answer: 'Dnes bude pršet a zároveň půjdeme hrát tenis. '
                            },
                            {
                                statement: 'Jestliže nedostanu jedničku, pak nedostanu kapesné. ',
                                answer: 'Nedostanu jedničku a zároveň dostanu kapesné. '
                            },
                            {
                                statement: 'Jestliže se naučím negovat, pak budu rozumět důkazům.',
                                answer: 'Naučím se negovat a zároveň nebudu rozumět důkazům. '
                            },
                        ]
                    },
                    [])
            ])];
    }
});