import * as b from 'bobril';
import * as bs from 'bobrilstrap';

const tableStyle = b.styleDef({
    width: 600,
    marginLeft: 'auto',
    marginRight: 'auto'
});

export const slozeneVyroky = b.createVirtualComponent({
    id: 'slozene-vyroky',
    render(ctx: b.IBobrilCtx, me: b.IBobrilNode) {
        me.children = [
            bs.h2({}, 'Složené výroky'),
            bs.paragraph({}, [
                b.link(bs.a({}, 'Výroky'), 'vyroky'),
                ' můžeme skládat do složených výroků pomocí logických spojek zvaných konjunkce, disjunkce, implikace a ekvivalence. ',
            ]),
            bs.ul({}, [
                bs.li({}, ['Konjunkce ',
                    '\u2227', ' znamená "a", "i" nebo "a zároveň". ']),
                bs.li({}, ['Disjunkce ',
                    '\u2228', ' znamená "nebo". ']),
                bs.li({}, ['Implikace ',
                    '\u21D2', ' znamená "jestliže, pak". ']),
                bs.li({}, ['Ekvivalence ',
                    '\u21D4', ' znamená "právě tehdy, když". ']),
            ]),

            bs.paragraph({}, [
                'Příkladem takových složených výroků mohou být věty:',
            ]),
            bs.ul({}, [
                bs.li({}, ['"V Pardubicích prší a v Hradci Králové svítí slunce."']),
                bs.li({}, ['"Půjdeme do školy nebo půjdeme do práce."']),
                bs.li({}, ['"Jestliže je dané číslo větší než pět, pak je kladné."']),
                bs.li({}, [
                    '"V grafu existuje cesta z vrcholu v do vrcholu w právě tehdy, když v grafu existuje sled z vrcholu v do vrcholu w."'
                ]),
            ]),

            bs.h2({}, 'Negace složených výroků'),
            bs.paragraph({}, [
                'Při negování složených výroků se můžeme řídit například tabulkou v knize [Doplnit]. ',
                'Při dokazování matematických vět se často používá negovaná implikace: ',
            ]),
            b.style(
                bs.table({ bordered: true, striped: true }, [
                    bs.thead({}, [
                        bs.tr({}, [
                            bs.th({}, ['Složený výrok']),
                            bs.th({}, ['Negace výroku']),
                        ]),
                    ]),
                    bs.tbody({}, [
                        bs.tr({}, [
                            bs.td({}, [bs.em({}, 'a '), '\u21D2', bs.em({}, ' b')]),
                            bs.td({}, [bs.em({}, 'a '), '\u2227', bs.em({}, ' '), '\xAC', bs.em({}, 'b')]),
                        ]),
                        bs.tr({}, [
                            bs.td({}, ['Jestliže platí ',
                                bs.em({}, ['a']), ', pak platí ',
                                bs.em({}, ['b']), '']),
                            bs.td({}, ['Platí ',
                                bs.em({}, ['a']), ' a zároveň neplatí ',
                                bs.em({}, ['b']), '']),
                        ]),
                    ]),
                ]),
                tableStyle),
        ];
    }
});