import * as b from 'bobril';
import * as bs from 'bobrilstrap';
import * as a from '../viewer/actions';

const tableStyle = b.styleDef({
    width: 400,
    marginLeft: 'auto',
    marginRight: 'auto'
});

export const vety = b.createVirtualComponent({
    id: 'vety',
    render(ctx: b.IBobrilCtx, me: b.IBobrilNode) {
        me.children = [
            bs.h2({}, 'Matematické věty'),
            bs.paragraph({}, ['Axiom', ' je elementární tvrzení, které považujeme za pravdivé bez důkazu. Matematická věta',
                ' je výrok o matematických objektech. Je to tvrzení, které se musí dokázat, a to pomocí axiomů, ',
                'definic nebo již dříve dokázaných vět. Často je vyjádřena složeným výrokem obsahujícím implikaci ',
                'nebo ekvivalenci.']),

            bs.h3({}, 'Věta obsahující implikaci'),
            bs.paragraph({}, ['Taková věta je tvořena dvěma výroky, které jsou spojené pomocí logické spojky zvané ',
                'implikace. Pro každé ',
                bs.em({}, ['x']), ' ležící na dané množině platí: jestliže platí výrok ',
                bs.em({}, ['A']), ', pak platí výrok ',
                bs.em({}, ['B']), '. ']),
            bs.well({}, ['\u2200', bs.em({}, ' x '), '\u2208', bs.em({}, ' M: A(x) '), '\u21D2', bs.em({}, ' B(x)')]),

            bs.h4({}, 'Obměněná věta'),
            bs.paragraph({}, ['K této větě můžeme vytvořit takzvanou obměnu. Obměna má stejnou pravdivostní hodnotu ',
                'jako původní věta. Proto se používá v ',
                b.link(bs.a({}, 'nepřímých důkazech'), 'neprimo'),
                ', jinak také nazývaných důkazy obměněnou implikací. ',
                'Pro každé ',
                bs.em({}, ['x']), ' ležící na dané množině platí: jestliže platí negace výroku ',
                bs.em({}, ['B']), ', ',
                'pak platí negace výroku ',
                bs.em({}, ['A']), '. ']),
            bs.well({}, ['\u2200', bs.em({}, ' x '), '\u2208', bs.em({}, ' M: B\'(x) '), '\u21D2', bs.em({}, ' A\'(x)')]),

            bs.h4({}, 'Obrácená věta'),
            bs.paragraph({}, ['Oproti obměně, obrácená věta nemusí mít stejnou pravdivostní hodnotu ',
                'jako původní věta. Pro každé ',
                bs.em({}, ['x']), ' ležící na dané množině platí: jestliže platí výrok ',
                bs.em({}, ['B']), ', pak platí výrok ',
                bs.em({}, ['A']), '. ']),
            bs.well({}, ['\u2200', bs.em({}, ' x '), '\u2208', bs.em({}, ' M: B(x) '), '\u21D2', bs.em({}, ' A(x)')]),

            bs.h4({}, 'Negace věty'),
            bs.paragraph({}, ['Negaci věty s implikací jsme přiblížili již na stránce o složených výrocích. ',
                'Negace věty má opačnou pravdivostní hodnotu než původní věta. Negace implikace se používá při ',
                b.link(bs.a({}, 'důkazech sporem'), 'sporem'),
                '. ',
                'Pro každé ',
                bs.em({}, ['x']), ' ležící na dané množině ',
                'platí: platí výrok ',
                bs.em({}, ['A']), ' a zároveň platí negace výroku ',
                bs.em({}, ['B']), '. ']),
            bs.well({}, ['\u2200', bs.em({}, ' x '), '\u2208', bs.em({}, ' M: A(x) '), '\u2227', bs.em({}, ' B\'(x)')]),

            bs.h3({}, 'Věta obsahující ekvivalenci'),
            bs.paragraph({}, ['Tato věta je tvořena dvěma výroky spojenými pomocí logické spojky, které říkáme ekvivalence. ',
                'Pro každé ',
                bs.em({}, ['x']), ' ležící na dané množině platí: výrok ',
                bs.em({}, ['A']), ' platí právě tehdy, když platí výrok ',
                bs.em({}, ['B']), '.']),
            bs.well({}, ['\u2200', bs.em({}, ' x '), '\u2208', bs.em({}, ' M: A(x) '), '\u21D4', bs.em({}, ' B(x)')]),

            bs.paragraph({}, [
                'V případě důkazu věty založené na ekvivalenci můžeme tuto spojku rozložit na dvě implikace a každou ',
                'dokázat zvlášť. Tím dokážeme celou ekvivalenci. ',
                bs.em({}, ['A']), ' platí právě tehdy, když platí ',
                bs.em({}, ['B']), ' můžeme rozložit na: jestliže platí ',
                bs.em({}, ['A']), ', pak platí ',
                bs.em({}, ['B']), ' a jestliže platí ',
                bs.em({}, ['B']), ', pak platí ',
                bs.em({}, ['A']), '.',
            ]),
            bs.elem({ tag: 'br' }, []),

            b.style(
                bs.table({ bordered: true, striped: true }, [
                    bs.tbody({}, [
                        bs.tr({}, [
                            b.style(bs.td({ colspan: 2 }, [bs.em({}, 'A(x) '), '\u21D4', bs.em({}, ' B(x)')]), { textAlign: 'center ' }),
                        ]),
                        bs.tr({}, [
                            b.style(bs.td({}, [bs.em({}, 'A(x) '), '\u21D2', bs.em({}, ' B(x)')]), { textAlign: 'center ' }),
                            b.style(bs.td({}, [bs.em({}, 'B(x) '), '\u21D2', bs.em({}, ' A(x)')]), { textAlign: 'center ' }),
                        ]),
                    ]),
                ]),
                tableStyle),
        ];
    }
});