import * as b from 'bobril';
import * as bs from 'bobrilstrap';

const tableStyle = b.styleDef({
    width: 200,
    marginLeft: 'auto',
    marginRight: 'auto'
});

export const vyroky = b.createVirtualComponent({
    id: 'vyroky',
    render(ctx: b.IBobrilCtx, me: b.IBobrilNode) {
        me.children = [
            bs.h2({}, 'Výroky'),
            bs.paragraph({}, [
                'Studiem výroků se zabývá výroková logika. ',
                'Výrok ', bs.em({}, ['p']),
                ' je sdělení, o kterém je smysluplné prohlásit, zda je pravdivé nebo nepravdivé (tzv. princip dvouhodnotovosti). ',
                'Pravdivý výrok má pravdivostní hodnotu 1 (true), nepravdivý 0 (false). Není možné, ',
                'aby byl výrok pravdivý a zároveň nepravdivý. Stejně tak je jisté, že platí alespoň jedna z možností.'
            ]),
            bs.paragraph({}, ['Za výrok se dají označit následující oznamovací věty, u kterých můžeme rozhodnout o jejich pravdivosti:']),
            bs.ul({}, [
                bs.li({}, ['"Sofie je hlavní město Bulharska."']),
                bs.li({}, ['"Petr dostal na vysvědčení tři dobré známky."']),
                bs.li({}, ['"Číslo jedna je prvočíslo."'])
            ]),
            bs.paragraph({}, ['Některé věty není možné považovat za výroky, patří sem hlavně rozkazovací věty a otázky jako například:']),
            bs.ul({}, [
                bs.li({}, ['"Ticho!"']),
                bs.li({}, ['"Kolik je hodin?"']),
                bs.li({}, ['"x = y"'])
            ]),
            bs.paragraph({}, ['Věty výše jsou příkladem jednoduchých výroků. Speciálním případem jsou ',
                b.link(bs.a({}, 'kvantifikované výroky'), 'kvantifikovaneVyroky'),
                '. Výroky také můžeme poskládat do ',
                b.link(bs.a({}, 'složených výroků'), 'slozeneVyroky'),
                '.']),
            bs.h2({}, 'Negace'),
            bs.paragraph({}, ['Negace výroku ',
                '\xAC', bs.em({}, 'p'),
                ' má opačnou pravdivostní hodnotu než původní výrok ',
                bs.em({}, ['p']),
                '. Negaci lze značit také ',
                bs.em({}, ['p\'']),
                ' a textově pomocí slova ',
                bs.em({}, ['non']),
                '. Tento výrok je interpretován jako pravdivý, když je původní výrok ',
                bs.em({}, ['p']),
                ' nepravdivý, podobně i pro opačný případ (výrok ',
                bs.em({}, ['p']),
                ' pravdivý a jeho negace je nepravdivá). To ukazuje tabulka níže. ']),
            b.style(
                bs.table({ bordered: true, striped: true }, [
                    bs.thead({}, [
                        bs.tr({}, [
                            bs.th({}, [bs.em({}, ['p'])]),
                            bs.th({}, ['\xAC', bs.em({}, 'p')]),
                        ]),
                    ]),
                    bs.tbody({}, [
                        bs.tr({}, [
                            bs.td({}, ['0']),
                            bs.td({}, ['1']),
                        ]),
                        bs.tr({}, [
                            bs.td({}, ['1']),
                            bs.td({}, ['0']),
                        ]),
                    ])
                ]),
                tableStyle),

            bs.paragraph({}, ['Při negování výroku lze před původní výrok umístit slovní spojení ',
                '"Není pravda, že…". Většinou jde ale utvořit vhodnější formulaci: ']),
            bs.ul({}, [
                bs.li({}, ['Výrok: "Sofie je hlavní město Bulharska."']),
                bs.li({}, ['Negace: "Není pravda, že Sofie je hlavní město Bulharska."']),
                bs.li({}, ['Vhodnější negace: "Sofie není hlavní město Bulharska."'])
            ]),
        ];
    }
});